-- the current rhadatip version
local RhadaTipVersion = "3.4"

--local RhadaTip_GCD = 1.5
-- whether tooltips will read DPS or HPC
RhadaTip_GainType = ""

--function RhadaTip_OnLoad(self)
	
RhadaTip = CreateFrame("Frame", "RhadaTip")
-- register this mod on the following four events
RhadaTip:RegisterEvent("ADDON_LOADED");
RhadaTip:RegisterEvent("PLAYER_LOGIN");
RhadaTip:RegisterEvent("PLAYER_ENTERING_WORLD");
RhadaTip:RegisterEvent("PLAYER_ALIVE");
RhadaTip:RegisterEvent("PLAYER_EQUIPMENT_CHANGED");
RhadaTip:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
RhadaTip:RegisterEvent("SOCKET_INFO_UPDATE");
RhadaTip:RegisterEvent("FORGE_MASTER_ITEM_CHANGED");
RhadaTip:RegisterEvent("FORGE_MASTER_SET_ITEM");
RhadaTip:RegisterEvent("ZONE_CHANGED_NEW_AREA");
--RhadaTip:RegisterEvent("SPELL_UPDATE_COOLDOWN");

RhadaTip_Scales = {}

-- set the slash commands to call this mod with
SLASH_RhadaTip1 = "/RhadaTip";
SLASH_RhadaTip2 = "/rt";
SLASH_RhadaTip3 = "/rtip";
SlashCmdList["RhadaTip"] = function(msg)
	RhadaTip:SlashCommandHandler(msg);
end

-- this hooks our event handlers below. The OnEvent sends us a reference to ourselves, along with the event itself.
-- this is then passed to our local handler RhadaTip:<event name> along with parameters.
RhadaTip:SetScript("OnEvent", function(RhadaTip, Event, ...) RhadaTip[Event](RhadaTip, ...) end)

-- global variable used to display tooltip additional informations just once for the MAIN TOOLTIP
RhadaTip.lineAdded = false
-- global variable used to display tooltip additional informations just once for the CHATLINK TOOLTIP
RhadaTip.chatLineAdded = false
-- global variable used to display tooltip additional informations just once for the EQUIPCOMPARE TOOLTIP 2
RhadaTip.ec1LineAdded = false
-- global variable used to display tooltip additional informations just once for the EQUIPCOMPARE TOOLTIP 2
RhadaTip.ec2LineAdded = false
-- global variable used to display tooltip additional informations just once for the ATLASLOOT TOOLTIP
RhadaTip.alLineAdded = false
-- global variable used to display tooltip additional informations just once for the SHOPPINGTOOLTIP2
RhadaTip.st1LineAdded = false
-- global variable used to display tooltip additional informations just once for the SHOPPINGTOOLTIP2
RhadaTip.st2LineAdded = false
-- global variable used to display tooltip additional informations just once for the SHOPPINGTOOLTIP3
RhadaTip.st3LineAdded = false
RhadaTip.profiles_loaded = false
RhadaTip.totalGearDps_calc_error = true

RhadaTip.load_time = time()
RhadaTip.load_delay = true

--RhadaTip tooltip variables
RhadaTip.tooltip_cache = {}

RhadaTip_InstGearReported = {}
RhadaTip_InstGearUpgrades = {}
RhadaTip_Inst_List = {}
RhadaTip_atlas_gear_ids = {}

RhadaTip_Inst_type = { 
	"Normal", -- 5 Man
	"Heroic", -- 5 man Heroic
	"Normal", -- 10 Man
	"Normal", -- 25 Man
	"Heroic", -- 10 Man Heroic
	"Heroic", -- 25 Man Heroic
	"Normal", -- 20 Man
	"Normal", -- 40 Man
}



function RhadaTip:round(num, idp)
  return tonumber(string.format("%." .. (idp or 0) .. "f", num))
end

-- this function activates or deactivates the help tooltips, depending on whether the relative checkbox in /rt hc is checker or not
function RhadaTip:DisplayHelpTooltips()
	if (Rhada_config_panel_options_CheckButton2:GetChecked()) then
		SHOW_HELP_TOOLTIPS = "YES"
	else
		SHOW_HELP_TOOLTIPS = "NO"
	end
end

-- this function activates or deactivates seeing the offspec item values on tooltips, depending on whether the relative checkbox in /rt hc is checker or not
function RhadaTip:DisplayOffspecValues()
	if (Rhada_config_panel_options_CheckButton5:GetChecked()) then
		SHOW_OFFSPEC_VALUES = "YES"
	else
		SHOW_OFFSPEC_VALUES = "NO"
	end
end


-- this function adds the gem tooltip to the currently selected gem
function RhadaTip:ShowGemTip(parent, name, self)

	--did the even come from the options panel	
	if parent:GetName() == "Rhada_config_panel_options" then
		RhadaTipGemTooltip:SetOwner(self:GetParent(), "ANCHOR_CURSOR")
		RhadaTipGemTooltip:SetScale(0.7)
		
		--determine which popup was hovered, and what the contents of the menu was
		if name == "Rhada_config_panel_options_DropDown1" and UIDropDownMenu_GetSelectedName(Rhada_config_panel_options_DropDown1) ~= nil then
			RhadaTipGemTooltip:SetHyperlink(UIDropDownMenu_GetSelectedName(Rhada_config_panel_options_DropDown1))
			--add our dps value to the gem tip
			RhadaTip_OnTooltipSetItem(RhadaTipGemTooltip)
		elseif name == "Rhada_config_panel_options_DropDown2" and UIDropDownMenu_GetSelectedName(Rhada_config_panel_options_DropDown2) ~= nil then
			RhadaTipGemTooltip:SetHyperlink(UIDropDownMenu_GetSelectedName(Rhada_config_panel_options_DropDown2))
			--add our dps value to the gem tip
			RhadaTip_OnTooltipSetItem(RhadaTipGemTooltip)
		elseif name == "Rhada_config_panel_options_DropDown3" and UIDropDownMenu_GetSelectedName(Rhada_config_panel_options_DropDown3) ~= nil then
			RhadaTipGemTooltip:SetHyperlink(UIDropDownMenu_GetSelectedName(Rhada_config_panel_options_DropDown3))
			--add our dps value to the gem tip
			RhadaTip_OnTooltipSetItem(RhadaTipGemTooltip)
		elseif name == "Rhada_config_panel_options_DropDown4" and UIDropDownMenu_GetSelectedName(Rhada_config_panel_options_DropDown4) ~= nil then
			RhadaTipGemTooltip:SetHyperlink(UIDropDownMenu_GetSelectedName(Rhada_config_panel_options_DropDown4))
			--add our dps value to the gem tip
			RhadaTip_OnTooltipSetItem(RhadaTipGemTooltip)
			
		end
	end
	
	if parent:GetName() == "Rhada_config_panel_gem_opt" then
		RhadaTipGemTooltip:SetOwner(self:GetParent(), "ANCHOR_CURSOR")
		RhadaTipGemTooltip:SetScale(0.7)

		if name == "Rhada_config_panel_gem_opt_InputBox151" then
			if Rhada_config_panel_gem_opt_InputBox151:GetText() ~= "" then
				RhadaTipGemTooltip:SetHyperlink(RhadaTip_RedGemLink)
				--add our dps value to the gem tip
				RhadaTip_OnTooltipSetItem(RhadaTipGemTooltip)
		end
		elseif name == "Rhada_config_panel_gem_opt_InputBox152" then
			if Rhada_config_panel_gem_opt_InputBox152:GetText() ~= "" then
				RhadaTipGemTooltip:SetHyperlink(RhadaTip_YellowGemLink)
				--add our dps value to the gem tip
				RhadaTip_OnTooltipSetItem(RhadaTipGemTooltip)
			end
		elseif name == "Rhada_config_panel_gem_opt_InputBox153" then
			if Rhada_config_panel_gem_opt_InputBox153:GetText() ~= "" then
				RhadaTipGemTooltip:SetHyperlink(RhadaTip_BlueGemLink)
				--add our dps value to the gem tip
				RhadaTip_OnTooltipSetItem(RhadaTipGemTooltip)
			end
		elseif name == "Rhada_config_panel_gem_opt_InputBox154" then
			if Rhada_config_panel_gem_opt_InputBox154:GetText() ~= "" then
				RhadaTipGemTooltip:SetHyperlink(Rhada_config_panel_gem_opt_InputBox154:GetText())
				--add our dps value to the gem tip
				RhadaTip_OnTooltipSetItem(RhadaTipGemTooltip)
			end
		elseif name == "Rhada_config_panel_gem_opt_InputBox155" then
			if Rhada_config_panel_gem_opt_InputBox155:GetText() ~= "" then
				RhadaTipGemTooltip:SetHyperlink(Rhada_config_panel_gem_opt_InputBox155:GetText())
				--add our dps value to the gem tip
				RhadaTip_OnTooltipSetItem(RhadaTipGemTooltip)
			end
		elseif name == "Rhada_config_panel_gem_opt_InputBox156" then
			if Rhada_config_panel_gem_opt_InputBox156:GetText() ~= "" then
				RhadaTipGemTooltip:SetHyperlink(Rhada_config_panel_gem_opt_InputBox156:GetText())
				--add our dps value to the gem tip
				RhadaTip_OnTooltipSetItem(RhadaTipGemTooltip)
			end
		end
	end
end

-- clear the gem tooltip
function RhadaTip:ClearGemTip(me)	
	RhadaTipGemTooltip:Hide()
end

-- this function adds help tooltips to most of the items in the rhadatip frames
function RhadaTip:HelpTooltip(gui_item_name)
	

	if gui_item_name == "RhadaTip_SVICON" or gui_item_name == "RhadaTip_HCICON" then
		RhadaTipHelpTooltip:SetOwner(Rhada_config_panel_options, "ANCHOR_CURSOR")
		RhadaTipHelpTooltip:SetScale(0.7)
		local activeTalentGroup = GetActiveTalentGroup(false, false)
		local _, _, _, _, points1 = GetTalentTabInfo(1, false, false, activeTalentGroup)
		local _, _, _, _, points2 = GetTalentTabInfo(2, false, false, activeTalentGroup)
		local _, _, _, _, points3 = GetTalentTabInfo(3, false, false, activeTalentGroup)
		RhadaTipHelpTooltip:SetText(points1 .. "-" .. points2 .. "-" .. points3, 1, 0.7, 0, 1, 1)
	elseif SHOW_HELP_TOOLTIPS == "YES" then
		RhadaTipHelpTooltip:SetOwner(Rhada_config_panel_options, "ANCHOR_CURSOR")
		RhadaTipHelpTooltip:SetScale(0.7)
		if gui_item_name == "Rhada_config_panel_options_InputBox2" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT13_HT_IB2, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_options_InputBox3" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT13_HT_IB3, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_options_InputBox4" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT13_HT_IB4, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_options_CheckButton1" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT13_HT_CB1, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_options_CheckButton2" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT13_HT_CB2, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_options_CheckButton3" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT13_HT_CB3, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_options_CheckButton4" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT13_HT_CB4, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_options_CheckButton5" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT13_HT_CB1110, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_options_RadioButton1" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT13_HT_RB1, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_options_RadioButton2" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT13_HT_RB2, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_gem_opt_RadioButton1" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT15_OG_RB1, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_gem_opt_RadioButton2" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT15_OG_RB2, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_gem_opt_RadioButton3" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT15_OG_RB3, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_gem_opt_RadioButton4" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT15_OG_RB4, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_gem_opt_RadioButton5" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT15_OG_RB5, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_gem_opt_RadioButton6" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT15_OG_RB6, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_gem_opt_RadioButton7" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT15_OG_RB7, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_gem_opt_RadioButton8" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT15_OG_RB8, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_gem_opt_RadioButton9" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT15_OG_RB9, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_gem_opt_RadioButton10" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT15_OG_RB10, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_gem_opt_RadioButton11" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT15_OG_RB11, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_gem_opt_RadioButton12" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT15_OG_RB12, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_gem_opt_RadioButton13" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT15_OG_RB13, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_gem_opt_RadioButton14" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT15_OG_RB14, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_gem_opt_RadioButton15" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT15_OG_RB15, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_gem_opt_InputBox157" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT15_OG_IB157, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_gem_opt_CheckButton1209" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT15_OG_CB1209, 1, 0.7, 0, 1, 1)
		elseif gui_item_name == "Rhada_config_panel_gear_opt_InputBox1" then
			RhadaTipHelpTooltip:SetText(RHADATIP_XML_RT16_OGEAR_IB1, 1, 0.7, 0, 1, 1)
		end
	end
end

-- clear the help tooltip
function RhadaTip:ClearHelpTooltip()	
	RhadaTipHelpTooltip:Hide()
end

-- this function loads the dropdown gem menu
--function RhadaTipDropDownMenu_OnLoad(self)
--	UIDropDownMenu_Initialize(self, RhadaTipDropDownMenu_Initialize(self));
--end

-- these functions handle clicks in the first of the 4 gem dropdown menus in /rt hc
function RhadaTipDropdown_OnClick1(dropdownbutton, arg1, arg2, checked)
	local activeTalentGroup = GetActiveTalentGroup(false, false)
--	RhadaTip:debug_out("clicked " .. arg1 .. arg2)
	UIDropDownMenu_SetSelectedValue(Rhada_config_panel_options_DropDown1, arg2);
	UIDropDownMenu_SetSelectedName(Rhada_config_panel_options_DropDown1, arg1);
	UIDropDownMenu_SetText(Rhada_config_panel_options_DropDown1, arg1);

	RHAD_META_GEM = arg1
	if activeTalentGroup == 1 then
		RHAD_META_GEM1 = arg1
	else
		RHAD_META_GEM2 = arg1
	end
end

function RhadaTipDropdown_OnClick2(dropdownbutton, arg1, arg2, checked)
	local activeTalentGroup = GetActiveTalentGroup(false, false)
--	RhadaTip:debug_out(dropdownbutton:GetParent():GetName())
	UIDropDownMenu_SetSelectedValue(Rhada_config_panel_options_DropDown2, arg2);
	UIDropDownMenu_SetSelectedName(Rhada_config_panel_options_DropDown2, arg1);
	UIDropDownMenu_SetText(Rhada_config_panel_options_DropDown2, arg1);

	RHAD_RED_GEM = arg1
	if activeTalentGroup == 1 then
		RHAD_RED_GEM1 = arg1
	else
		RHAD_RED_GEM2 = arg1
	end
end	

function RhadaTipDropdown_OnClick3(dropdownbutton, arg1, arg2, checked)
	local activeTalentGroup = GetActiveTalentGroup(false, false)
	UIDropDownMenu_SetSelectedValue(Rhada_config_panel_options_DropDown3, arg2);
	UIDropDownMenu_SetSelectedName(Rhada_config_panel_options_DropDown3, arg1);
	UIDropDownMenu_SetText(Rhada_config_panel_options_DropDown3, arg1);

	RHAD_YELLOW_GEM = arg1
	if activeTalentGroup == 1 then
		RHAD_YELLOW_GEM1 = arg1
	else
		RHAD_YELLOW_GEM2 = arg1
	end
end

function RhadaTipDropdown_OnClick4(dropdownbutton, arg1, arg2, checked)
	local activeTalentGroup = GetActiveTalentGroup(false, false)
	UIDropDownMenu_SetSelectedValue(Rhada_config_panel_options_DropDown4, arg2);
	UIDropDownMenu_SetSelectedName(Rhada_config_panel_options_DropDown4, arg1);
	UIDropDownMenu_SetText(Rhada_config_panel_options_DropDown4, arg1);

	RHAD_BLUE_GEM = arg1
	if activeTalentGroup == 1 then
		RHAD_BLUE_GEM1 = arg1
	else
		RHAD_BLUE_GEM2 = arg1
	end
end

local info = {}
function Rhada_DropDown1_init(self, level)
--	should not need this here, but there is a problem with out of order loading going on.
--	Doing this to make sure our proper gem list is in mem when we build the menu.
	rhada_load_gems();
	local top_gem_dps = 0
	local gem_count = 0
--	RhadaTip:debug_out("button loader 1")	
	-- check to see if proper non null level was passed
	if not level then return end
	--prepare our structure for loading button properties
    wipe(info)
    if level == 1 then
        -- Create the title of the menu
        info.isTitle = 1
        info.text = "Select Prefered Meta Gem"
        info.notCheckable = 1
        UIDropDownMenu_AddButton(info, level)

		-- time to add our gems
		--prepare our structure for loading button properties
		wipe(info)
		--step through the gem structure looking for meta gems	
		table.sort(RhadaTip_defaultGems,function(a,b) return a.dps > b.dps; end)
      	for k,v in ipairs(RhadaTip_defaultGems) do
			if rhada_gem_is_meta(v.gemID) and (gem_count < 25) then
				--is it our SAVED meta gem?
				if v.gemName == RHAD_META_GEM then
					-- if it is, let make sure we mark it in the list
					info.checked = true
--					set the menu text and selected item for display when menu is closed
					UIDropDownMenu_SetSelectedName(Rhada_config_panel_options_DropDown1, v.gemName);
					UIDropDownMenu_SetSelectedValue(Rhada_config_panel_options_DropDown1, k);
					UIDropDownMenu_SetText(Rhada_config_panel_options_DropDown1, v.gemName);
				else
					--if this is not our saved/selected gem, then make sure to uncheck it
					info.checked = false
				end
				info.text = (v.gemName .. " - " .. format("%.2f", v.dps))
				info.value = v.gemName
				-- arguements to be passed to our click event
				info.arg1 = v.gemName
				info.arg2 = k
				-- the click event handler
				info.func = RhadaTipDropdown_OnClick1
				-- add out button
				UIDropDownMenu_AddButton(info, level)
				gem_count = gem_count + 1
			end
		end
	end
end

function Rhada_DropDown2_init(self, level)
	local top_gem_dps = 0
	local gem_count = 0
--	set our default attributes for the look of the button. Probably needs to be moved into layout definition
	UIDropDownMenu_SetWidth(Rhada_config_panel_options_DropDown2, 242);
	UIDropDownMenu_JustifyText(Rhada_config_panel_options_DropDown2, "LEFT")

--	should not need this here, but there is a problem with out of order loading going on.
--	Doing this to make sure our proper gem list is in mem when we build the menu.
	rhada_load_gems();
	-- check to see if proper non null level was passed
	if not level then return end
	--prepare our structure for loading button properties
    wipe(info)
    if level == 1 then
        -- Create the title of the menu
        info.isTitle = 1
        info.text = "Select Prefered Red Gem"
        info.notCheckable = 1
        UIDropDownMenu_AddButton(info, level)

		-- time to add our gems
		--prepare our structure for loading button properties
		wipe(info)
		--step through the gem structure looking for meta gems		
		table.sort(RhadaTip_defaultGems,function(a,b) return a.dps > b.dps; end)
      	for k,v in ipairs(RhadaTip_defaultGems) do
			if rhada_gem_is_red(v.gemID) and (gem_count < 25) then
				--is it our SAVED red gem?
				if v.gemName == RHAD_RED_GEM then
					-- if it is, let make sure we mark it in the list
					info.checked = true
--					set the menu text and selected item for display when menu is closed
					UIDropDownMenu_SetSelectedName(Rhada_config_panel_options_DropDown2, v.gemName);
					UIDropDownMenu_SetSelectedValue(Rhada_config_panel_options_DropDown2, k);
					UIDropDownMenu_SetText(Rhada_config_panel_options_DropDown2, v.gemName);
				else
					--if this is not our saved/selected gem, then make sure to uncheck it
					info.checked = false
				end
				info.text = (v.gemName .. " - " .. format("%.2f", (v.dps or 0)))
				info.value = v.gemName
				-- arguements to be passed to our click event
				info.arg1 = v.gemName
				info.arg2 = k
				-- the click event handler
				info.func = RhadaTipDropdown_OnClick2
				-- add out button
				UIDropDownMenu_AddButton(info, level)
				gem_count = gem_count + 1
			end
		end
	end
end

function Rhada_DropDown3_init(self, level)
	local top_gem_dps = 0
	local gem_count = 0
--	set our default attributes for the look of the button. Probably needs to be moved into layout definition
	UIDropDownMenu_SetWidth(Rhada_config_panel_options_DropDown3, 242);
	UIDropDownMenu_JustifyText(Rhada_config_panel_options_DropDown3, "LEFT")

--	should not need this here, but there is a problem with out of order loading going on.
--	Doing this to make sure our proper gem list is in mem when we build the menu.
	rhada_load_gems();
	-- check to see if proper non null level was passed
	if not level then return end
	--prepare our structure for loading button properties
    wipe(info)
    if level == 1 then
        -- Create the title of the menu
        info.isTitle = 1
        info.text = "Select Prefered Yellow Gem"
        info.notCheckable = 1
        UIDropDownMenu_AddButton(info, level)

		-- time to add our gems
		--prepare our structure for loading button properties
		wipe(info)
		--step through the gem structure looking for meta gems		
		table.sort(RhadaTip_defaultGems,function(a,b) return a.dps > b.dps; end)
      	for k,v in ipairs(RhadaTip_defaultGems) do
			if rhada_gem_is_yellow(v.gemID) and (gem_count < 25) then
				--is it our SAVED yellow gem?
				if v.gemName == RHAD_YELLOW_GEM then
					-- if it is, let make sure we mark it in the list
					info.checked = true
--					set the menu text and selected item for display when menu is closed
					UIDropDownMenu_SetSelectedName(Rhada_config_panel_options_DropDown3, v.gemName);
					UIDropDownMenu_SetSelectedValue(Rhada_config_panel_options_DropDown3, k);
					UIDropDownMenu_SetText(Rhada_config_panel_options_DropDown3, v.gemName);
				else
					--if this is not our saved/selected gem, then make sure to uncheck it
					info.checked = false
				end
				info.text = (v.gemName .. " - " .. format("%.2f", (v.dps or 0)))
				info.value = v.gemName
				-- arguements to be passed to our click event
				info.arg1 = v.gemName
				info.arg2 = k
				-- the click event handler
				info.func = RhadaTipDropdown_OnClick3
				-- add out button
				UIDropDownMenu_AddButton(info, level)
				gem_count = gem_count + 1
			end
		end
	end
end

function Rhada_DropDown4_init(self, level)
	local gem_color
	local top_gem_dps = 0
	local gem_count = 0
--	set our default attributes for the look of the button. Probably needs to be moved into layout definition
	UIDropDownMenu_SetWidth(Rhada_config_panel_options_DropDown4, 242);
	UIDropDownMenu_JustifyText(Rhada_config_panel_options_DropDown4, "LEFT")

--	should not need this here, but there is a problem with out of order loading going on.
--	Doing this to make sure our proper gem list is in mem when we build the menu.
	rhada_load_gems();
	-- check to see if proper non null level was passed
	if not level then return end
	--prepare our structure for loading button properties
    wipe(info)
    if level == 1 then
        -- Create the title of the menu
        info.isTitle = 1
        info.text = "Select Prefered Blue Gem"
        info.notCheckable = 1
        UIDropDownMenu_AddButton(info, level)

		-- time to add our gems
		--prepare our structure for loading button properties
		wipe(info)
		--step through the gem structure looking for meta gems	
		table.sort(RhadaTip_defaultGems,function(a,b) return a.dps > b.dps; end)
      	for k,v in ipairs(RhadaTip_defaultGems) do
			if rhada_gem_is_blue(v.gemID) and (gem_count < 25) then
				--is it our SAVED meta gem?
				if v.gemName == RHAD_BLUE_GEM then
					-- if it is, let make sure we mark it in the list
					info.checked = true
--					set the menu text and selected item for display when menu is closed
					UIDropDownMenu_SetSelectedName(Rhada_config_panel_options_DropDown4, v.gemName);
					UIDropDownMenu_SetSelectedValue(Rhada_config_panel_options_DropDown4, k);
					UIDropDownMenu_SetText(Rhada_config_panel_options_DropDown4, v.gemName);
				else
					--if this is not our saved/selected gem, then make sure to uncheck it
					info.checked = false
				end
				info.text = (v.gemName .. " - " .. format("%.2f", (v.dps or 0)))
				info.value = v.gemName
				-- arguements to be passed to our click event
				info.arg1 = v.gemName
				info.arg2 = k
				-- the click event handler
				info.func = RhadaTipDropdown_OnClick4
				-- add out button
				UIDropDownMenu_AddButton(info, level)
				gem_count = gem_count + 1
			end
		end
	end
end

function Rhada_config_tab_btn_handler(clicked_tab)
		Rhada_config_panel:Show()
		Rhada_config_panel_options:Hide();
		Rhada_config_panel_scales:Hide();
		Rhada_config_panel_gear_opt:Hide()
		Rhada_config_panel_gem_opt:Hide()
		Rhada_config_panel_pv:Hide()

	if clicked_tab == "Rhada_config_panelTab1" then
		PanelTemplates_SetTab(Rhada_config_panel, 1);
		Rhada_config_panel_options:Show();
	elseif clicked_tab == "Rhada_config_panelTab2" then
		PanelTemplates_SetTab(Rhada_config_panel, 2);
		Rhada_config_panel_scales:Show();
	elseif clicked_tab == "Rhada_config_panelTab3" then
		PanelTemplates_SetTab(Rhada_config_panel, 3);
		Rhada_config_panel_gear_opt:Show()
	elseif clicked_tab == "Rhada_config_panelTab4" then
		PanelTemplates_SetTab(Rhada_config_panel, 4);
		Rhada_config_panel_gem_opt:Show()
	elseif clicked_tab == "Rhada_config_panelTab5" then
		PanelTemplates_SetTab(Rhada_config_panel, 5);
		Rhada_config_panel_pv:Show()
	end	
end


-- this function is used to close frames with the escape key if they have textboxes
function RhadaTip_CloseFrame(self)
	self:ClearFocus();
	Rhada_config_panel:Hide();
end

function RhadaTip:config_panel_load_values()
	local f_sv

-- SV panel
	_, icon = RhadaTip_class.get_spec()
	-- create the frame and add the proper icon to it
	f_sv = CreateFrame("Frame","RhadaTip_SVICON",Rhada_config_panel_scales)
	f_sv:SetFrameStrata("DIALOG")
	f_sv:SetWidth(35) -- Set these to whatever height/width is needed 
	f_sv:SetHeight(33) -- for your Texture
	local t = f_sv:CreateTexture("RhadaTip_SVTEXTURE","MEDIUM")
	t:SetTexture(icon)
	t:SetAllPoints(f_sv)
	f_sv.texture = t
	f_sv:SetPoint("CENTER",257,-124)
	f_sv:Show()
	f_sv:EnableMouse(1)
--	f_sv:SetScript("OnEnter", RhadaTip_HelpTooltip())
--	f_sv:SetScript("OnLeave", RhadaTip_ClearHelpTooltip())

	if DEFAULT_PROFILE_VALUES ~= nil then
		Rhada_config_panel_scales_Text1:SetText("RhadaTip is currently defaulted to using the " .. DEFAULT_PROFILE_VALUES .. " profile.")
	else
		Rhada_config_panel_scales_Text1:SetText("RhadaTip is currently using your custom settings from above.")
	end
	
	local activeTalentGroup = GetActiveTalentGroup(false, false)

	-- set the values, if a scaling value exists, show it, otherwise show 0
	Rhada_config_panel_scales_InputBox2:SetText(RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_STAMINA_SHORT"] or "0")
	Rhada_config_panel_scales_InputBox3:SetText(RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_INTELLECT_SHORT"] or "0")
	Rhada_config_panel_scales_InputBox4:SetText(RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_SPIRIT_SHORT"] or "0")
	Rhada_config_panel_scales_InputBox5:SetText(RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_SPELL_POWER_SHORT"] or "0")
	Rhada_config_panel_scales_InputBox6:SetText(RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_HIT_RATING_SHORT"] or "0")
	Rhada_config_panel_scales_InputBox7:SetText(RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_CRIT_RATING_SHORT"] or "0")
	Rhada_config_panel_scales_InputBox8:SetText(RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_HASTE_RATING_SHORT"] or "0")
	Rhada_config_panel_scales_InputBox9:SetText(RhadaTip_Scales[activeTalentGroup]["HIT_SCALE_POST_CAP"] or "0")
	Rhada_config_panel_scales_InputBox10:SetText(RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_STRENGTH_SHORT"] or "0")
	Rhada_config_panel_scales_InputBox11:SetText(RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_AGILITY_SHORT"] or "0")
	Rhada_config_panel_scales_InputBox12:SetText(RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_ATTACK_POWER_SHORT"] or "0")
	Rhada_config_panel_scales_InputBox13:SetText(RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_MASTERY_RATING_SHORT"] or "0")
	Rhada_config_panel_scales_InputBox14:SetText(RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_EXPERTISE_RATING_SHORT"] or "0")
	Rhada_config_panel_scales_InputBox15:SetText(RhadaTip_Scales[activeTalentGroup]["mainhand"] or "0")
	Rhada_config_panel_scales_InputBox16:SetText(RhadaTip_Scales[activeTalentGroup]["offhand"] or "0")
	Rhada_config_panel_scales_InputBox17:SetText(RhadaTip_Scales[activeTalentGroup]["tPT7_SCALE"] or "0")
	Rhada_config_panel_scales_InputBox18:SetText(RhadaTip_Scales[activeTalentGroup]["fPT7_SCALE"] or "0")
	Rhada_config_panel_scales_InputBox19:SetText(RhadaTip_Scales[activeTalentGroup]["tPT8_SCALE"] or "0")
	Rhada_config_panel_scales_InputBox20:SetText(RhadaTip_Scales[activeTalentGroup]["fPT8_SCALE"] or "0")
	Rhada_config_panel_scales_InputBox21:SetText(RhadaTip_Scales[activeTalentGroup]["tPT9_SCALE"] or "0")
	Rhada_config_panel_scales_InputBox22:SetText(RhadaTip_Scales[activeTalentGroup]["fPT9_SCALE"] or "0")
	Rhada_config_panel_scales_InputBox23:SetText(RhadaTip_Scales[activeTalentGroup]["tPT10_SCALE"] or "0")
	Rhada_config_panel_scales_InputBox24:SetText(RhadaTip_Scales[activeTalentGroup]["fPT10_SCALE"] or "0")
	Rhada_config_panel_scales_InputBox25:SetText(RhadaTip_Scales[activeTalentGroup]["tPT11_SCALE"] or "0")
	Rhada_config_panel_scales_InputBox26:SetText(RhadaTip_Scales[activeTalentGroup]["fPT11_SCALE"] or "0")

	
--	loading HC(options) panel
	f_hc = CreateFrame("Frame","RhadaTip_HCICON",Rhada_config_panel_options)
	f_hc:SetFrameStrata("DIALOG")
	f_hc:SetWidth(35) -- Set these to whatever height/width is needed 
	f_hc:SetHeight(33) -- for your Texture
	local t = f_hc:CreateTexture("RhadaTip_HCTEXTURE","MEDIUM")
	t:SetTexture(icon)
	t:SetAllPoints(f_hc)
	f_hc.texture = t
	f_hc:SetPoint("CENTER",257,-124)
	f_hc:Show()
	f_hc:EnableMouse(1)
--	f_hc:SetScript("OnEnter", RhadaTip_HelpTooltip())
--	f_hc:SetScript("OnLeave", RhadaTip_ClearHelpTooltip())

	Rhada_config_panel_options_InputBox2:SetText(HIT_CAP or "0")
	local temp_hit_rating, temp_hit_cap = RhadaTip_class.get_hitcap()
		Rhada_config_panel_options_Text4:SetText("Hit: " .. format("%.2f",temp_hit_rating/(RhadaTip_class.get_hit_conv())) .. "%   Cap: " .. format("%.2f",temp_hit_cap) .. "(" .. format("%.2f",temp_hit_cap/(RhadaTip_class.get_hit_conv())) .. "%)"  )
	-- expertise_cap
	Rhada_config_panel_options_InputBox4:SetText(EXPERTISE_CAP or "0")
	Rhada_config_panel_options_InputBox3:SetText(SOME_CASTING_TIME or "9999")
	if CASTER_OR_MELEE == 2 then
		Rhada_config_panel_options_RadioButton1:SetChecked(nil)
		Rhada_config_panel_options_RadioButton2:SetChecked(1)
	else 
		Rhada_config_panel_options_RadioButton1:SetChecked(1)
		Rhada_config_panel_options_RadioButton2:SetChecked(nil)
	end
	if SHOW_HELP_TOOLTIPS == "YES" then
		Rhada_config_panel_options_CheckButton2:SetChecked(1)
	else
		Rhada_config_panel_options_CheckButton2:SetChecked(nil)
	end
	if SHOW_OFFSPEC_VALUES == "YES" then
		Rhada_config_panel_options_CheckButton5:SetChecked(1)
	else
		Rhada_config_panel_options_CheckButton5:SetChecked(nil)
	end
	if DPS_ENCHANTS == true then
		Rhada_config_panel_options_CheckButton4:SetChecked(true)
	else
		Rhada_config_panel_options_CheckButton4:SetChecked(false)
	end
	
	UIDropDownMenu_SetSelectedName(Rhada_config_panel_options_DropDown1, RHAD_META_GEM);
	UIDropDownMenu_SetText(Rhada_config_panel_options_DropDown1, RHAD_META_GEM);
	UIDropDownMenu_SetSelectedName(Rhada_config_panel_options_DropDown2, RHAD_RED_GEM);
	UIDropDownMenu_SetText(Rhada_config_panel_options_DropDown2, RHAD_RED_GEM);
	UIDropDownMenu_SetSelectedName(Rhada_config_panel_options_DropDown3, RHAD_YELLOW_GEM);
	UIDropDownMenu_SetText(Rhada_config_panel_options_DropDown3, RHAD_YELLOW_GEM);
	UIDropDownMenu_SetSelectedName(Rhada_config_panel_options_DropDown4, RHAD_BLUE_GEM);
	UIDropDownMenu_SetText(Rhada_config_panel_options_DropDown4, RHAD_BLUE_GEM);

--	load gem info for gem optimizer functions
	RhadaTip_GetOptimalGems()
	
--	if not RhadaTip.profiles_loaded then
		RhadaTip_LoadPV()
--		RhadaTip.profiles_loaded = true
--	end	

end

function RhadaTip_FrameKeyHandler(self, key)
	if key ~= nil then
		out(key)
	end
end

function RhadaTip:load_gem_opt()
	RhadaTip:config_panel_load_values()
	Rhada_config_tab_btn_handler("Rhada_config_panelTab4")
end
-- this function is used to load the scale value input frame with pre-saved scale values, if any
function RhadaTip:LoadSV()
	Rhada_config_tab_btn_handler("Rhada_config_panelTab2")
	RhadaTip:config_panel_load_values()
end

-- this function is used to load the hit cap input frame with pre-saved hit cap values, if any. it also manages the avg casting time, the filling gems, and the help and wowequip tooltips
function RhadaTip:LoadHC()
	Rhada_config_tab_btn_handler("Rhada_config_panelTab1")
	RhadaTip:config_panel_load_values()
end

-- this function is used to load the gear optimizer frame
function RhadaTip:LoadGO()
	Rhada_config_tab_btn_handler("Rhada_config_panelTab3")
	Rhada_config_panel_gear_opt_ComputationTime:SetText("")
end

-- this function gets the user input data (scale values) and updates the global variables with them
function RhadaTip_ValidateExample12(arg1)
	-- get the active talent group to decide in which global variables the user input has to be saved in
	local activeTalentGroup = GetActiveTalentGroup(false, false)
	-- if the Stamina field of the inputBox is not nil
   	if (Rhada_config_panel_scales_InputBox2:GetText()) then
		-- check if it is a number
		local temp = tonumber(Rhada_config_panel_scales_InputBox2:GetText())
   		if temp == nil then
			-- otherwise display and error message, and set RhadaTip_Scales[spec]["ITEM_MOD_STAMINA_SHORT"] to zero
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper stamina scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		-- if it is a number, update the global variable RhadaTip_Scales[spec]["ITEM_MOD_STAMINA_SHORT"] with it
		-- store the user input into RhadaTip_Scales[1]["ITEM_MOD_STAMINA_SHORT"]
		RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_STAMINA_SHORT"] = temp

   	end
   	if (Rhada_config_panel_scales_InputBox3:GetText()) then
		local temp = tonumber(Rhada_config_panel_scales_InputBox3:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper intellect scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_INTELLECT_SHORT"] = temp
   	end

   	if (Rhada_config_panel_scales_InputBox4:GetText()) then
 		local temp = tonumber(Rhada_config_panel_scales_InputBox4:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper spirit scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_SPIRIT_SHORT"] = temp
   	end

   	if (Rhada_config_panel_scales_InputBox5:GetText()) then
 		local temp = tonumber(Rhada_config_panel_scales_InputBox5:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper spell power scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_SPELL_POWER_SHORT"] = temp
   	end

   	if (Rhada_config_panel_scales_InputBox6:GetText()) then
 		local temp = tonumber(Rhada_config_panel_scales_InputBox6:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper pre cap hit rating scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_HIT_RATING_SHORT"] = temp
   	end

   	if (Rhada_config_panel_scales_InputBox9:GetText()) then
 		local temp = tonumber(Rhada_config_panel_scales_InputBox9:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper post cap hit rating scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["HIT_SCALE_POST_CAP"] = temp
   	end

   	if (Rhada_config_panel_scales_InputBox7:GetText()) then
 		local temp = tonumber(Rhada_config_panel_scales_InputBox7:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper crit rating scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_CRIT_RATING_SHORT"] = temp
   	end

   	if (Rhada_config_panel_scales_InputBox8:GetText()) then
 		local temp = tonumber(Rhada_config_panel_scales_InputBox8:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper haste rating scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_HASTE_RATING_SHORT"] = temp
   	end

   	if (Rhada_config_panel_scales_InputBox10:GetText()) then
 		local temp = tonumber(Rhada_config_panel_scales_InputBox10:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper strength scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_STRENGTH_SHORT"] = temp
   	end

   	if (Rhada_config_panel_scales_InputBox11:GetText()) then
 		local temp = tonumber(Rhada_config_panel_scales_InputBox11:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper agility scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_AGILITY_SHORT"] = temp
   	end

   	if (Rhada_config_panel_scales_InputBox12:GetText()) then
 		local temp = tonumber(Rhada_config_panel_scales_InputBox12:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper attack power scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_ATTACK_POWER_SHORT"] = temp
   	end

   	if (Rhada_config_panel_scales_InputBox13:GetText()) then
 		local temp = tonumber(Rhada_config_panel_scales_InputBox13:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper mastery scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_MASTERY_RATING_SHORT"] = temp
   	end

   	if (Rhada_config_panel_scales_InputBox14:GetText()) then
 		local temp = tonumber(Rhada_config_panel_scales_InputBox14:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper expertise scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_EXPERTISE_RATING_SHORT"] = temp
   	end

   	if (Rhada_config_panel_scales_InputBox15:GetText()) then
 		local temp = tonumber(Rhada_config_panel_scales_InputBox15:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper main hand or bow scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["mainhand"] = temp
   	end

   	if (Rhada_config_panel_scales_InputBox16:GetText()) then
 		local temp = tonumber(Rhada_config_panel_scales_InputBox16:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper off hand scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["offhand"] = temp
   	end

   	if (Rhada_config_panel_scales_InputBox17:GetText()) then
 		local temp = tonumber(Rhada_config_panel_scales_InputBox17:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper 2 pieces tier 7 scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["tPT7_SCALE"] = temp
   	end

   	if (Rhada_config_panel_scales_InputBox18:GetText()) then
 		local temp = tonumber(Rhada_config_panel_scales_InputBox18:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper 4 pieces tier 7 scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["fPT7_SCALE"] = temp
   	end

   	if (Rhada_config_panel_scales_InputBox19:GetText()) then
 		local temp = tonumber(Rhada_config_panel_scales_InputBox19:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper 2 pieces tier 8 scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["tPT8_SCALE"] = temp
   	end

   	if (Rhada_config_panel_scales_InputBox20:GetText()) then
 		local temp = tonumber(Rhada_config_panel_scales_InputBox20:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper 4 pieces tier 8 scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["fPT8_SCALE"] = temp
   	end

	if (Rhada_config_panel_scales_InputBox21:GetText()) then
  		local temp = tonumber(Rhada_config_panel_scales_InputBox21:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper 2 pieces tier 9 scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["tPT9_SCALE"] = temp
   	end

	if (Rhada_config_panel_scales_InputBox22:GetText()) then
  		local temp = tonumber(Rhada_config_panel_scales_InputBox22:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper 4 pieces tier 9 scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["fPT9_SCALE"] = temp
   	end

	if (Rhada_config_panel_scales_InputBox23:GetText()) then
  		local temp = tonumber(Rhada_config_panel_scales_InputBox23:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper 2 pieces tier 10 scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["tPT10_SCALE"] = temp
   	end

	if (Rhada_config_panel_scales_InputBox24:GetText()) then
  		local temp = tonumber(Rhada_config_panel_scales_InputBox24:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper 4 pieces tier 10 scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["fPT10_SCALE"] = temp
   	end

	if (Rhada_config_panel_scales_InputBox25:GetText()) then
  		local temp = tonumber(Rhada_config_panel_scales_InputBox25:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper 2 pieces tier 11 scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["tPT11_SCALE"] = temp
   	end

	if (Rhada_config_panel_scales_InputBox26:GetText()) then
  		local temp = tonumber(Rhada_config_panel_scales_InputBox26:GetText())
   		if temp == nil then
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper 4 pieces tier 11 scale value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			temp = 0 
   		end
		RhadaTip_Scales[activeTalentGroup]["fPT11_SCALE"] = temp
   	end

	-- refresh the scaling values with the newly inserted data
	DEFAULT_PROFILE_VALUES = nil
--	RhadaTip:init_scales()
	RhadaTip:SetTemplateSVOnLoad(false)
	-- first flush the item value cache with RhadaTip:ClearItemCacheTable(), and then recompute everything with non cached items
	RhadaTip:ClearItemCacheTable()
	RhadaTip:ClearTTcache()
	-- after the scaling values have changed, recompute the full gear dps
	RhadaTip:ComputeAllGear()
	-- after the scaling values have changed, recompute the full WoWEquip gear dps
	RhadaTip:config_panel_load_values()
end

function RhadaTip:init_scales()

-- "ITEM_MOD_STAMINA_SHORT" 
-- "ITEM_MOD_INTELLECT_SHORT" 
-- "ITEM_MOD_SPIRIT_SHORT" 
-- "ITEM_MOD_STRENGTH_SHORT" 
-- "ITEM_MOD_AGILITY_SHORT" 
-- "ITEM_MOD_HIT_RATING_SHORT" 
-- "ITEM_MOD_HASTE_RATING_SHORT" 
-- "ITEM_MOD_SPELL_POWER_SHORT" 
-- "ITEM_MOD_CRIT_RATING_SHORT" 
-- "ITEM_MOD_ATTACK_POWER_SHORT" 
-- "ITEM_MOD_MASTERY_RATING_SHORT" 
-- "ITEM_MOD_EXPERTISE_RATING_SHORT" 
-- "ITEM_MOD_DODGE_RATING_SHORT" 
-- "ITEM_MOD_PARRY_RATING_SHORT" 

	--this code is a legacy holdover to make sure peoples older stat scales migrate forward
	--to the new array strutures
	if RhadaTip_Scales[1] == nil then
		RhadaTip_Scales[1] = {}
		RhadaTip_Scales[1]["ITEM_MOD_STAMINA_SHORT"] = (STAMINA_SCALE1 or 0)
		RhadaTip_Scales[1]["ITEM_MOD_INTELLECT_SHORT"] = (INTELLECT_SCALE1 or 0)
		RhadaTip_Scales[1]["ITEM_MOD_SPIRIT_SHORT"] = (SPIRIT_SCALE1 or 0)
		RhadaTip_Scales[1]["ITEM_MOD_SPELL_POWER_SHORT"] = (SPELLPOWER_SCALE1 or 0)
		RhadaTip_Scales[1]["ITEM_MOD_HIT_RATING_SHORT"] = (HIT_SCALE1 or 0)
		RhadaTip_Scales[1]["HIT_SCALE_POST_CAP"] = (HIT_SCALE_POST_CAP1 or 0)
		RhadaTip_Scales[1]["ITEM_MOD_CRIT_RATING_SHORT"] = (CRIT_SCALE1 or 0)
		RhadaTip_Scales[1]["ITEM_MOD_HASTE_RATING_SHORT"] = (HASTE_SCALE1 or 0)
		RhadaTip_Scales[1]["ITEM_MOD_STRENGTH_SHORT"]  = (STRENGTH_SCALE1 or 0)
		RhadaTip_Scales[1]["ITEM_MOD_AGILITY_SHORT"] = (AGILITY_SCALE1 or 0)
		RhadaTip_Scales[1]["ITEM_MOD_ATTACK_POWER_SHORT"] = (ATTACKPOWER_SCALE1 or 0)
		RhadaTip_Scales[1]["ITEM_MOD_MASTERY_RATING_SHORT"] = (MASTERY_SCALE1 or 0)
		RhadaTip_Scales[1]["ITEM_MOD_EXPERTISE_RATING_SHORT"] = (EXPERTISE_SCALE1 or 0)
		RhadaTip_Scales[1]["ITEM_MOD_DODGE_RATING_SHORT"] = (0)
		RhadaTip_Scales[1]["ITEM_MOD_PARRY_RATING_SHORT"] = (0)
		RhadaTip_Scales[1]["Base_DMG"] = (1)
		RhadaTip_Scales[1]["mainhand"] = (MAINHAND_SCALE1 or 0)
		RhadaTip_Scales[1]["offhand"] = (OFFHAND_SCALE1 or 0)
		RhadaTip_Scales[1]["tPT7_SCALE"] = (tPT7_SCALE1 or 0)
		RhadaTip_Scales[1]["fPT7_SCALE"] = (fPT7_SCALE1 or 0)
		RhadaTip_Scales[1]["tPT8_SCALE"] = (tPT8_SCALE1 or 0)
		RhadaTip_Scales[1]["fPT8_SCALE"] = (fPT8_SCALE1 or 0)
		RhadaTip_Scales[1]["tPT9_SCALE"] = (tPT9_SCALE1 or 0)
		RhadaTip_Scales[1]["fPT9_SCALE"] = (fPT9_SCALE1 or 0)
		RhadaTip_Scales[1]["tPT10_SCALE"] = (tPT10_SCALE1 or 0)
		RhadaTip_Scales[1]["fPT10_SCALE"] = (fPT10_SCALE1 or 0)
	end
	
	if RhadaTip_Scales[2] == nil then
		RhadaTip_Scales[2] = {}
		RhadaTip_Scales[2]["ITEM_MOD_STAMINA_SHORT"] = (STAMINA_SCALE2 or 0)
		RhadaTip_Scales[2]["ITEM_MOD_INTELLECT_SHORT"] = (INTELLECT_SCALE2 or 0)
		RhadaTip_Scales[2]["ITEM_MOD_SPIRIT_SHORT"] = (SPIRIT_SCALE2 or 0)
		RhadaTip_Scales[2]["ITEM_MOD_SPELL_POWER_SHORT"] = (SPELLPOWER_SCALE2 or 0)
		RhadaTip_Scales[2]["ITEM_MOD_HIT_RATING_SHORT"] = (HIT_SCALE2 or 0)
		RhadaTip_Scales[2]["HIT_SCALE_POST_CAP"] = (HIT_SCALE_POST_CAP2 or 0)
		RhadaTip_Scales[2]["ITEM_MOD_CRIT_RATING_SHORT"] = (CRIT_SCALE2 or 0)
		RhadaTip_Scales[2]["ITEM_MOD_HASTE_RATING_SHORT"] = (HASTE_SCALE2 or 0)
		RhadaTip_Scales[2]["ITEM_MOD_STRENGTH_SHORT"]  = (STRENGTH_SCALE2 or 0)
		RhadaTip_Scales[2]["ITEM_MOD_AGILITY_SHORT"] = (AGILITY_SCALE2 or 0)
		RhadaTip_Scales[2]["ITEM_MOD_ATTACK_POWER_SHORT"] = (ATTACKPOWER_SCALE2 or 0)
		RhadaTip_Scales[2]["ITEM_MOD_MASTERY_RATING_SHORT"] = (MASTERY_SCALE2 or 0)
		RhadaTip_Scales[2]["ITEM_MOD_EXPERTISE_RATING_SHORT"] = (EXPERTISE_SCALE2 or 0)
		RhadaTip_Scales[2]["ITEM_MOD_DODGE_RATING_SHORT"] = (0)
		RhadaTip_Scales[2]["ITEM_MOD_PARRY_RATING_SHORT"] = (0)
		RhadaTip_Scales[2]["Base_DMG"] = (1)
		RhadaTip_Scales[2]["mainhand"] = (MAINHAND_SCALE2 or 0)
		RhadaTip_Scales[2]["offhand"] = (OFFHAND_SCALE2 or 0)
		RhadaTip_Scales[2]["tPT7_SCALE"] = (tPT7_SCALE2 or 0)
		RhadaTip_Scales[2]["fPT7_SCALE"] = (fPT7_SCALE2 or 0)
		RhadaTip_Scales[2]["tPT8_SCALE"] = (tPT8_SCALE2 or 0)
		RhadaTip_Scales[2]["fPT8_SCALE"] = (fPT8_SCALE2 or 0)
		RhadaTip_Scales[2]["tPT9_SCALE"] = (tPT9_SCALE2 or 0)
		RhadaTip_Scales[2]["fPT9_SCALE"] = (fPT9_SCALE2 or 0)
		RhadaTip_Scales[2]["tPT10_SCALE"] = (tPT10_SCALE2 or 0)
		RhadaTip_Scales[2]["fPT10_SCALE"] = (fPT10_SCALE2 or 0)
	end
	RhadaTip_Scales[2]["ITEM_MOD_DAMAGE_PER_SECOND_SHORT"] = RhadaTip_Scales[2]["mainhand"]
	RhadaTip_Scales[1]["ITEM_MOD_DAMAGE_PER_SECOND_SHORT"] = RhadaTip_Scales[1]["mainhand"]
end

-- this function gets user input data (like hit cap, some casting time) and updates the global variables with them
function RhadaTip_ValidateExample13(arg1)
	local activeTalentGroup = GetActiveTalentGroup(false, false)
	DEFAULT_PROFILE_VALUES = nil
	-- if the hit cap field of the inputBox is not nil
   	if (Rhada_config_panel_options_InputBox2:GetText()) then
		-- check if it is a number
    		if tonumber(Rhada_config_panel_options_InputBox2:GetText()) ~= nil then
			-- if it is a number, update the global variable HIT_CAP with it
			if activeTalentGroup == 1 then
				HIT_CAP1 = Rhada_config_panel_options_InputBox2:GetText()   
			else
				HIT_CAP2 = Rhada_config_panel_options_InputBox2:GetText()   
			end
		else
			-- otherwise display and error message, and set HIT_CAP to zero
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper hit cap value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			if activeTalentGroup == 1 then
				HIT_CAP1 = 0 
			else
				HIT_CAP2 = 0
			end
   		end
   	end
	-- if the expertise cap field of the inputBox is not nil
   	if (Rhada_config_panel_options_InputBox4:GetText()) then
		-- check if it is a number
    		if tonumber(Rhada_config_panel_options_InputBox4:GetText()) ~= nil then
			-- if it is a number, update the global variable EXPERTISE_CAP with it
			if activeTalentGroup == 1 then
				EXPERTISE_CAP1 = Rhada_config_panel_options_InputBox4:GetText()   
			else
				EXPERTISE_CAP2 = Rhada_config_panel_options_InputBox4:GetText()   
			end
		else
			-- otherwise display and error message, and set EXPERTISE_CAP to zero
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper expertise cap value, setting it to 0", 1.0, 0.0, 0.0, 53, 5);
			if activeTalentGroup == 1 then
				EXPERTISE_CAP1 = 0 
			else
				EXPERTISE_CAP2 = 0
			end
   		end
   	end
	-- if the some casting time field of the inputBox is not nil
   	if (Rhada_config_panel_options_InputBox3:GetText()) then
		-- check if it is a number
    		if tonumber(Rhada_config_panel_options_InputBox3:GetText()) ~= nil then
			-- if it is a number, update the global variable SOME_CASTING_TIME with it
			if activeTalentGroup == 1 then
				SOME_CASTING_TIME1 = Rhada_config_panel_options_InputBox3:GetText()   	
			else
				SOME_CASTING_TIME2 = Rhada_config_panel_options_InputBox3:GetText()   	
			end
		else
			-- otherwise display and error message, and set HIT_CAP to zero
			DEFAULT_CHAT_FRAME:AddMessage("Not a proper spell casting time value, setting it to 9999", 1.0, 0.0, 0.0, 53, 5);
			if activeTalentGroup == 1 then
				SOME_CASTING_TIME1 = 9999 
			else
				SOME_CASTING_TIME2 = 9999
			end
   		end
   	end
	if (Rhada_config_panel_options_RadioButton1:GetChecked()) then
		if activeTalentGroup == 1 then
			MELEE_OR_CASTER1 = 1   	
		else
			MELEE_OR_CASTER2 = 1   	
		end
	end
	if (Rhada_config_panel_options_RadioButton2:GetChecked()) then
		if activeTalentGroup == 2 then
			MELEE_OR_CASTER2 = 2   	
		else
			MELEE_OR_CASTER1 = 2   	
		end
	end
	if (Rhada_config_panel_options_CheckButton2:GetChecked()) then
		SHOW_HELP_TOOLTIPS = "YES"
	else
	   	SHOW_HELP_TOOLTIPS = "NO"
	end
	if (Rhada_config_panel_options_CheckButton5:GetChecked()) then
		SHOW_OFFSPEC_VALUES = "YES"
	else
	   	SHOW_OFFSPEC_VALUES = "NO"
	end

	if (Rhada_config_panel_options_CheckButton4:GetChecked()) then
		DPS_ENCHANTS = true
	else
		DPS_ENCHANTS = false
	end
	

	RhadaTip:RefreshHitCap(activeTalentGroup);
	-- first flush the item value cache with RhadaTip:ClearItemCacheTable(), and then recompute everything with non cached items
	RhadaTip:ClearItemCacheTable()
	RhadaTip:ClearTTcache()
	-- after a change, recompute the dps gain from the currently equipped gear
	RhadaTip:ComputeAllGear()
	-- after the scaling values have changed, recompute the full WoWEquip gear dps

end

-- refresh the hit cap, casting time and default gems for the currently active talent group
function RhadaTip:RefreshHitCap(activeTalentGroup)
	if activeTalentGroup == 1 then
		HIT_CAP = HIT_CAP1
		EXPERTISE_CAP = EXPERTISE_CAP1
		-- this is necessary for someone logging into the game on spec 2 and swapping to spec 1
		if SOME_CASTING_TIME1 ~= nil then
			SOME_CASTING_TIME = SOME_CASTING_TIME1
		else
			DEFAULT_CHAT_FRAME:AddMessage("No spell casting time has been set yet, setting it to 9999", 1.0, 0.0, 0.0, 53, 5);
			SOME_CASTING_TIME = 9999
		end
		RHAD_META_GEM = RHAD_META_GEM1
		RHAD_RED_GEM = RHAD_RED_GEM1
		RHAD_YELLOW_GEM = RHAD_YELLOW_GEM1
		RHAD_BLUE_GEM = RHAD_BLUE_GEM1
		CASTER_OR_MELEE = MELEE_OR_CASTER1
	elseif activeTalentGroup == 2 then
		HIT_CAP = HIT_CAP2
		EXPERTISE_CAP = EXPERTISE_CAP2
		-- the following check is needed to avoid having SOME_CASTING_TIME be equal to nil if the user logs onto the game while on his secondary spec and with no casting time set
		if SOME_CASTING_TIME2 ~= nil then
			SOME_CASTING_TIME = SOME_CASTING_TIME2
		else
			DEFAULT_CHAT_FRAME:AddMessage("No spell casting time has been set yet, setting it to 9999", 1.0, 0.0, 0.0, 53, 5);
			SOME_CASTING_TIME = 9999
		end
		RHAD_META_GEM = RHAD_META_GEM2
		RHAD_RED_GEM = RHAD_RED_GEM2
		RHAD_YELLOW_GEM = RHAD_YELLOW_GEM2
		RHAD_BLUE_GEM = RHAD_BLUE_GEM2
		CASTER_OR_MELEE = MELEE_OR_CASTER2
	end
end

-- utility printing function
function RhadaTip:debug_out(text)
	DEFAULT_CHAT_FRAME:AddMessage(text)
-- 	UIErrorsFrame:AddMessage(text, 1.0, 1.0, 0, 1, 10) 
end

-- utility printing function
function out(text)
	DEFAULT_CHAT_FRAME:AddMessage("RT:" .. text, 1.0, 0.0, 0.95, 50, 5);
-- 	UIErrorsFrame:AddMessage(text, 1.0, 1.0, 0, 1, 10) 
end

-- this function gets the user scales from the command line. It takes a table holding those values as its input
function RhadaTip:GetCommandLineScales(scalesTable)
	-- get the active talent group to decide in which global variables the user input has to be saved in
	local activeTalentGroup = GetActiveTalentGroup(false, false)
	local stamina, intellect, spirit, spellpower, hit, crit, haste, mp5, strength, agility, attackpower, mastery, expertise, mainhand, offhand = 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	-- loop over the scalesTable
	for k,v in pairs(scalesTable) do
		if strfind(v,"Stamina") ~= nil then
			_, stamina = strsplit("=", v)
		end
		if strfind(v,"Intellect") ~= nil then
			_, intellect = strsplit("=", v)
		end
		if strfind(v,"Spirit") ~= nil then
			_, spirit = strsplit("=", v)
		end
		if strfind(v,"SpellDamage") ~= nil then
			_, spellpower = strsplit("=", v)
		end
		if strfind(v,"HitRating") ~= nil then
			_, hit = strsplit("=", v)
		end
		if strfind(v,"CritRating") ~= nil then
			_, crit = strsplit("=", v)
		end
		if strfind(v,"HasteRating") ~= nil then
			_, haste = strsplit("=", v)
		end
		if strfind(v,"Strength") ~= nil then
			_, strength = strsplit("=", v)
		end
		if strfind(v,"Agility") ~= nil then
			_, agility = strsplit("=", v)
		end
		if strfind(v,"Ap=") ~= nil then
			_, attackpower = strsplit("=", v)
		end
		if strfind(v,"MasteryRating") ~= nil then
			_, mastery = strsplit("=", v)
		end
		if strfind(v,"ExpertiseRating") ~= nil then
			_, expertise = strsplit("=", v)
		end
		if strfind(v,"MeleeDps") ~= nil then
			_, mainhand = strsplit("=", v)
		end
		if strfind(v,"RangedDps") ~= nil then
			_, offhand = strsplit("=", v)
		end
	end
	if activeTalentGroup == 1 then
		RhadaTip_Scales[1]["ITEM_MOD_STAMINA_SHORT"] = stamina
		RhadaTip_Scales[1]["ITEM_MOD_INTELLECT_SHORT"] = intellect
		RhadaTip_Scales[1]["ITEM_MOD_SPIRIT_SHORT"] = spirit
		RhadaTip_Scales[1]["ITEM_MOD_SPELL_POWER_SHORT"] = spellpower
		RhadaTip_Scales[1]["ITEM_MOD_HIT_RATING_SHORT"] = hit
		RhadaTip_Scales[1]["ITEM_MOD_CRIT_RATING_SHORT"] = crit
		RhadaTip_Scales[1]["ITEM_MOD_HASTE_RATING_SHORT"] = haste
		RhadaTip_Scales[1]["ITEM_MOD_STRENGTH_SHORT"] = strength
		RhadaTip_Scales[1]["ITEM_MOD_AGILITY_SHORT"] = agility
		RhadaTip_Scales[1]["ITEM_MOD_ATTACK_POWER_SHORT"] = attackpower
		RhadaTip_Scales[1]["ITEM_MOD_MASTERY_RATING_SHORT"] = mastery
		RhadaTip_Scales[1]["ITEM_MOD_EXPERTISE_RATING_SHORT"] = expertise
		RhadaTip_Scales[1]["mainhand"] = mainhand
		RhadaTip_Scales[1]["offhand"] = offhand
	else
		RhadaTip_Scales[2]["ITEM_MOD_STAMINA_SHORT"] = stamina
		RhadaTip_Scales[2]["ITEM_MOD_INTELLECT_SHORT"] = intellect
		RhadaTip_Scales[2]["ITEM_MOD_SPIRIT_SHORT"] = spirit
		RhadaTip_Scales[2]["ITEM_MOD_SPELL_POWER_SHORT"] = spellpower
		RhadaTip_Scales[2]["ITEM_MOD_HIT_RATING_SHORT"] = hit
		RhadaTip_Scales[2]["ITEM_MOD_CRIT_RATING_SHORT"] = crit
		RhadaTip_Scales[2]["ITEM_MOD_HASTE_RATING_SHORT"] = haste
		RhadaTip_Scales[2]["ITEM_MOD_STRENGTH_SHORT"] = strength
		RhadaTip_Scales[2]["ITEM_MOD_AGILITY_SHORT"] = agility
		RhadaTip_Scales[2]["ITEM_MOD_ATTACK_POWER_SHORT"] = attackpower
		RhadaTip_Scales[2]["ITEM_MOD_MASTERY_RATING_SHORT"] = mastery
		RhadaTip_Scales[2]["ITEM_MOD_EXPERTISE_RATING_SHORT"] = expertise
		RhadaTip_Scales[2]["mainhand"] = mainhand
		RhadaTip_Scales[2]["offhand"] = offhand
	end
	-- refresh the scaling values with the newly inserted data
--	RhadaTip:init_scales()
	-- first flush the item value cache with RhadaTip:ClearItemCacheTable(), and then recompute everything with non cached items
	RhadaTip:ClearItemCacheTable()
	RhadaTip:ClearTTcache()
	-- after the scaling values have changed, recompute the full gear dps
	RhadaTip:ComputeAllGear()
	RhadaTip:config_panel_load_values()
end

-- function to handle the different slash command possibilities
function RhadaTip:SlashCommandHandler(msg)
	local msg1, msg2, msg3, msg4 = strsplit(" ", msg, 4)
	-- if msg is 0, reload the ui
	if (msg == "0") then
		ReloadUI();
	--show what items we have cached
	elseif (msg == "zone" or msg == "ZONE") then
		RhadaTip_GetInstanceBossList()
	elseif (msg == "stats" or msg == "STATS") then
		RhadaTip_init_gear_table()
		local set_stats = {}
		local item_stats = {}
		local spec = GetActiveTalentGroup(false, false)
		for a,b in pairs(RhadaTip_Gear_Table) do
			wipe(item_stats)
			GetItemStats(b, item_stats)
			
			item_stats = RhadaTip_ReforgeStats(b, item_stats)		
			--get gem stats
			
			local gem_stats = RhadaTip_GetItemGemStats(b)
			
			if gem_stats ~= nil then
				for k,v in pairs(gem_stats) do
					if RhadaTip_Scales[spec][k] then
						item_stats[k] = (item_stats[k] or 0) + v
					end
				end
			end

			local enchant_spell_id = tonumber(rhada_get_enchant_id(b))
			if enchant_spell_id and enchant_spell_id > 0 then
				for k,v in pairs(RhadaTip_Enchant_proc[enchant_spell_id]) do
					if v["proc_len"] == 1 and v["proc_chan"] == 1 and v["proc_ICD"] == 1 then
						item_stats[v["proc_stat"]] = (item_stats[v["proc_stat"]] or 0) + (v["stat_val"]or 0)
					end
				end
			end
			
			for c,d in pairs(item_stats) do
				if c == "ITEM_MOD_INTELLECT_SHORT" then
					out(b .. ":" .. d)
				end
				set_stats[c] = (set_stats[c] or 0) + d
			end
		end
		for k,v in pairs(set_stats) do
			out(k .. " : " .. v)
		end
	elseif (msg == "prof" or msg == "PROF") then
		RhadaTip_class.setup_item_tree()
		local p1, p2, p3, p4, p5, p6, p7, p8, p9 = GetItemInfo(57871)
		if p6 == nil or p7 == nil then
			DEFAULT_CHAT_FRAME:AddMessage("retreiving item", 1.0, 0.0, 0.95, 50, 5);
		else
			DEFAULT_CHAT_FRAME:AddMessage(p6, 1.0, 0.0, 0.95, 50, 5);
			for k,v in pairs(rhada_item_index) do
				if p6 == k then
					break
				end
			end
			DEFAULT_CHAT_FRAME:AddMessage("7: " .. p7 .. "(" .. rhada_item_index[p6][p7] .. ")", 1.0, 0.0, 0.95, 50, 5);
		end
	elseif (msg1 == "upg" or msg == "UPG") then
		if not (IsAddOnLoaded("AtlasLoot")) then
			out("AtlasLoot is not enabled or installed")
			return
		end

		local RhadaTip_upg_ids = {}
		local equip_dps = 0
		msg2 = strreplace(msg, "upg ", "", "1")

		if msg2 == "" or msg2 == nil then
			out("item link required for search")
			return
		end

		--step through main key boss/dungeon
		--create a tooltip so we can calculate our item
		RhadaTipScanningTooltip:SetOwner(UIParent, "ANCHOR_NONE")
		-- get the basic properties for the item we currently have
		local _, itemLink, _, _, _, equip_itemType, equip_SubType, _, equip_EquipLoc, _ = GetItemInfo(msg2)
		--load the item into our tooltip
		RhadaTipScanningTooltip:SetHyperlink(itemLink)
		--calculate our dps for the item
		equip_dps = getItemSlotValue(RhadaTipScanningTooltip)
		equip_dps = tonumber(equip_dps)
		for k,v in pairs(AtlasLoot_Data) do
			if AtlasLoot_Data[k].info and AtlasLoot_Data[k].info.module and AtlasLoot_Data[k].info.module == "AtlasLootCataclysm" then
--				out(k .. " - " .. AtlasLoot_Data[k].info.module)
				--step through normal/heroic sets
				for a,b in pairs(v) do
					if a == "Normal" or a == "Heroic" then
--						out(a)
						--step through pages
						for c,d in pairs(b) do
							--step through items
							-- now we go look for an upgrade.
							for e,f in pairs(d) do
								if type(f[2]) == "table" then
								--there are items out there that have multiple faction subsets. 
								--atlas loot groups these into a subtable. Eventually we need to parse these as well
								else
									--make sure the pointer is valid
									if f[2] then
										--check to see if we have a valid item id
										if f[2] ~= "0" and f[2] ~= 0 then
											--get the item stats for the item in the database
--											out(c .. ":" .. e .. ":" .. f[2])
											local iname, itemLink, _, _, _, itemType, itemSubType, _, itemEquipLoc, _ = GetItemInfo(f[2])
											--check to see if the item in the database is of the same type as we are looking for.
											if equip_EquipLoc == itemEquipLoc and IsEquippableItem(itemLink) then
												--load the item into our scanning tooltip
												RhadaTipScanningTooltip:SetHyperlink(itemLink)
												--calculate the item's dps
												local item_dps = getItemSlotValue(RhadaTipScanningTooltip)
												item_dps = tonumber(item_dps)
												--check to see if we have a possible upgrade
												if item_dps > equip_dps then
													local valid = true
													--check to see if this is a tier item with class restrictons
													if RhadaTip_tier_items[f[2]] ~= nil then
														valid = false
														--get our class
														local playerClass, englishClass = UnitClass("player");
--														out(AtlasLoot_Data[k].info.name .. " vs " .. playerClass)
														--check to see if the item is for our class
														if strfind(AtlasLoot_Data[k].info.name, playerClass) ~= nil then valid = true end
													end
													if valid then
														--insert this item into the table for later processing
														tinsert(RhadaTip_upg_ids, {item = itemLink, item_type = itemType, slot = itemEquipLoc, item_dps = tonumber(item_dps), boss = AtlasLoot_Data[k].info.name, instance = AtlasLoot_Data[k].info.instance})
													end
												end
											end
										end
									end
								end
							end
						end
					end
				end
			end
		end
		--kill our scanning tooltip
		RhadaTipScanningTooltip:Hide()
		--sort the upgrade table by dps
		table.sort(RhadaTip_upg_ids,function(a,b) return a.item_dps < b.item_dps end)
		local item_count = 0
		DEFAULT_CHAT_FRAME:AddMessage("Next 10 upgrades for " .. msg2 .. "(" .. equip_dps .. "):")
		for k,v in ipairs(RhadaTip_upg_ids) do
			if item_count < 10 then
				DEFAULT_CHAT_FRAME:AddMessage(v.item_dps .."-".. v.item .."(".. v.boss .. "/" .. (v.instance or "") ..")")
				item_count = item_count +1
			end

		end
	elseif (msg1 == "enchants" or msg == "ENCHANTS") then
		local ench_list = {}
		msg2 = strreplace(msg, "enchants ", "", "1")
		if msg2 == nil or msg2 == "" then
			for k,v in pairs(RhadaTip_Enchant_proc) do
				if v[1]["id"] ~= nil then
					tinsert(ench_list, {enchant = v[1]["id"], dps = 0})
				end
			end
			for a,b in pairs(ench_list) do
				for a,b in pairs(ench_list) do
					ench_list[a].dps = RhadaTip_GetEnchDPS(ench_list[a].enchant)
				end
			end
			table.sort(ench_list,function(a,b) return a.dps > b.dps; end)
			local count = 0
			for k,v in pairs(ench_list) do
				if count < 10 then
					if v.dps > 0 then
						local name = GetSpellInfo(v.enchant)
						out(name .. ": " .. v.dps)
						count = count+1
					end
				end
			end	
		else
			local ench_id, ench_dps, ench_status = RhadaTip_get_enchant_info(msg2)
			DEFAULT_CHAT_FRAME:AddMessage(ench_status)
		end
	elseif (msg == "cache" or msg == "CACHE") then
		RhadaTip:dump_cachedItems()
	elseif (msg == "speclist") then
		for k,v in pairs(RhadaTip_ScalingValues) do
			out(k)
		end
	elseif (msg1 == "item" or msg == "ITEM") then
		msg2 = strreplace(msg, "item ", "", "1")
		local activeTalentGroup = GetActiveTalentGroup(false, false)
		local stats = {}
		wipe(stats)
		local _, itemLink = GetItemInfo(msg2)
		if itemLink~= nil then
			GetItemStats(itemLink, stats)
		end
		local stat_dps = 0
		--loop through the stats and multiply them by our scale values.
		for stat, value in pairs(stats) do
			if RhadaTip_Scales[activeTalentGroup][stat] ~= nil then
				stat_dps = stat_dps + RhadaTip_Scales[activeTalentGroup][stat] * value
				out(stat .. ":" .. value)
			end		
		end
		local p1, p2, p3, p4, p5, p6, p7, p8, p9 = GetItemInfo(msg2)
		out("p1:" .. (p1 or "n/a"))
		out("p2:" .. (p2 or "n/a"))
		out("p3:" .. (p3 or "n/a"))
		out("p4:" .. (p4 or "n/a"))
		out("p5:" .. (p5 or "n/a"))
		out("p6:" .. (p6 or "n/a"))
		out("p7:" .. (p7 or "n/a"))
		out("p8:" .. (p8 or "n/a"))
		out("p9:" .. (p9 or "n/a"))
	elseif (msg == "hit" or msg == "HIT") then
		RhadaTip_class.get_hit_conv()
		local temp_hit_rating, temp_hit_cap = RhadaTip_class.get_hitcap()
		DEFAULT_CHAT_FRAME:AddMessage("Current Rating: " .. format("%.2f",temp_hit_rating), 1.0, 0.0, 0.95, 50, 5);
		DEFAULT_CHAT_FRAME:AddMessage("Current Cap:    " .. format("%.2f",temp_hit_cap), 1.0, 0.0, 0.95, 50, 5);
		DEFAULT_CHAT_FRAME:AddMessage("Current Conv:   " .. format("%.2f",RhadaTip_class.get_hit_conv()), 1.0, 0.0, 0.95, 50, 5);
		DEFAULT_CHAT_FRAME:AddMessage("Current Percent:" .. format("%.2f",temp_hit_rating/(RhadaTip_class.get_hit_conv())) .. "%", 1.0, 0.0, 0.95, 50, 5);
	elseif (msg == "exp" or msg == "EXP") then
		local exp_conv = RhadaTip_class.get_exp_conv()
		local temp_exp_rating, temp_exp_cap = RhadaTip_class.get_expcap()
		DEFAULT_CHAT_FRAME:AddMessage("Current Rating:   " .. format("%.2f",temp_exp_rating), 1.0, 0.0, 0.95, 50, 5);
		DEFAULT_CHAT_FRAME:AddMessage("Current Cap:      " .. format("%.2f",temp_exp_cap), 1.0, 0.0, 0.95, 50, 5);
		DEFAULT_CHAT_FRAME:AddMessage("Current Conv:     " .. format("%.2f",exp_conv), 1.0, 0.0, 0.95, 50, 5);
		DEFAULT_CHAT_FRAME:AddMessage("Current Expertise:" .. format("%.2f",(temp_exp_rating/exp_conv)+6), 1.0, 0.0, 0.95, 50, 5);
	elseif (msg == "gearlvl" or msg == "GEARLVL") then
		DEFAULT_CHAT_FRAME:AddMessage("Avg item level: " .. rhada_gear_lvl(), 1.0, 0.0, 0.95, 50, 5);
		DEFAULT_CHAT_FRAME:AddMessage("Spec: " .. RhadaTip_class.get_spec(), 1.0, 0.0, 0.95, 50, 5);
	elseif (msg == "pvcheck" or msg == "PVCHECK") then
		local result = rhada_PV_spec_finder()
		DEFAULT_CHAT_FRAME:AddMessage(result, 1.0, 0.0, 0.95, 50, 5);
	-- otherwise, if msg is pv, open the preset scaling values tab
	elseif (msg == "pv" or msg == "PV") then
		RhadaTip:config_panel_load_values()
		Rhada_config_tab_btn_handler("Rhada_config_panelTab5")
	-- otherwise, if msg is sv, open the stored scaling values tab
	elseif (msg == "sv" or msg == "12" or msg == "SV") then
		RhadaTip:LoadSV()
	-- otherwise, if msg is hc, open the stored hit cap etc tab
	elseif (msg == "hc" or msg == "13" or msg == "HC") then
		RhadaTip:LoadHC()
	-- otherwise, if msg is gems, list the supported gems
	elseif (msg == "gems" or msg == "GEMS") then
		DEFAULT_CHAT_FRAME:AddMessage("RhadaTip " .. RhadaTipVersion .. ": Supported Gems: ", 1.0, 0.0, 0.95, 50, 5);
		for k,v in ipairs(RhadaTip_defaultGems) do
			local rsr = v
			if rsr ~= nil then
				DEFAULT_CHAT_FRAME:AddMessage("- " .. rsr, 1.0, 0.0, 0.95, 50, 5);
			end
		end
	-- otherwise, if msg is trinkets, list the supported trinkets
	elseif (msg == "trinkets" or msg == "TRINKETS") then
		local trinket_array = {}
		DEFAULT_CHAT_FRAME:AddMessage("RhadaTip " .. RhadaTipVersion .. ": Supported Trinkets: ", 1.0, 0.0, 0.95, 50, 5);
		for k,v in pairs(RhadaTip_trinket_procs) do
			local trinket_dps = tonumber(RhadaTip_Trinkets(nil, k) or 0)
			tinsert(trinket_array, {id = k, name = v[1]["name"], dps = trinket_dps})
		end
		table.sort(trinket_array,function(a,b) return a.dps > b.dps; end)
		for k,v in pairs(trinket_array) do
			local _, itemLink = GetItemInfo(v.id)
			if itemLink == nil then
				itemLink = "<loading>"
			end
			out(v.dps .. " DPS" .. " - " .. itemLink)
		end
	-- otherwise, if msg is ec, force loading the EquipCompare support
	elseif (msg == "ec" or msg == "EC") then
		RhadaTip_EC();
	-- otherwise, if msg is al, force loading the AtlasLoot support
	elseif (msg == "al" or msg == "AL") then
		RhadaTip_Al();
	-- otherwise, if msg is og, launch the gem optimizer
	elseif (msg == "og" or msg == "OG") then
		RhadaTip:load_gem_opt();
-- otherwise, if msg is ott, launch the gear optimizer
	elseif (msg == "ogear" or msg == "OGEAR") then
		RhadaTip:LoadGO()
	-- otherwise, if msg is menu, launch the general menu
	elseif (msg == "menu" or msg == "MENU") then
		RhadaTip:config_panel_load_values()
		Rhada_config_panel:Show()
	-- otherwise, if the user is passing the scales via command line
	elseif (strfind(msg, "^import") or strfind(msg, "^IMPORT")) then
		local _,_,c = strsplit(":", msg)
		if c ~= nil then
			local tbl = { strsplit(", ", c) }
			RhadaTip:GetCommandLineScales(tbl)
		else
			DEFAULT_CHAT_FRAME:AddMessage("It appears you have supplied an incomplete or invalid import string. The import command requires a stat scale generated by SimCraft, and expects it to follow certain conventions.", 1.0, 0.0, 0.95, 50, 5);
		end
	else
		-- for every other msg, print the usage
		RhadaTip:SlashUsage(SLASH_RhadaTip2);
	end
end

-- this function is used to print the different available slash commands
function RhadaTip:SlashUsage(SLASH_RhadaTip2)
	DEFAULT_CHAT_FRAME:AddMessage("RhadaTip " .. RhadaTipVersion .. ": Supported Slash Commands: ", 1.0, 0.0, 0.95, 50, 5);
	DEFAULT_CHAT_FRAME:AddMessage("- " .. SLASH_RhadaTip2 .. " -> Usage", 1.0, 0.0, 0.95, 50, 5);
	DEFAULT_CHAT_FRAME:AddMessage("- " .. SLASH_RhadaTip2 .. " menu -> Opens the menu frame, used to access all other frames", 1.0, 0.0, 0.95, 50, 5);
	DEFAULT_CHAT_FRAME:AddMessage("- " .. SLASH_RhadaTip2 .. " import SimCraft -> Imports SimCraft scaling values", 1.0, 0.0, 0.95, 50, 5);
	DEFAULT_CHAT_FRAME:AddMessage("- " .. SLASH_RhadaTip2 .. " sv -> Scaling Values input frame", 1.0, 0.0, 0.95, 50, 5);
	DEFAULT_CHAT_FRAME:AddMessage("- " .. SLASH_RhadaTip2 .. " hc -> Hit Cap,Spell Casting Time and Gems input frame", 1.0, 0.0, 0.95, 50, 5);
	DEFAULT_CHAT_FRAME:AddMessage("- " .. SLASH_RhadaTip2 .. " og -> Opens the Gem Optimizer frame", 1.0, 0.0, 0.95, 50, 5);
	DEFAULT_CHAT_FRAME:AddMessage("- " .. SLASH_RhadaTip2 .. " ogear -> Opens the Gear Optimizer frame", 1.0, 0.0, 0.95, 50, 5);
	DEFAULT_CHAT_FRAME:AddMessage("- " .. SLASH_RhadaTip2 .. " pv -> Pre-set Scaling Values choise frame", 1.0, 0.0, 0.95, 50, 5);
	DEFAULT_CHAT_FRAME:AddMessage("- " .. SLASH_RhadaTip2 .. " 0 -> Shortcut for /console reloadui", 1.0, 0.0, 0.95, 50, 5);
	DEFAULT_CHAT_FRAME:AddMessage("- " .. SLASH_RhadaTip2 .. " gems -> Lists all the currently supported gems", 1.0, 0.0, 0.95, 50, 5);
	DEFAULT_CHAT_FRAME:AddMessage("- " .. SLASH_RhadaTip2 .. " ec -> Forces RhadaTip to reload the support for EquipCompare", 1.0, 0.0, 0.95, 50, 5);
	DEFAULT_CHAT_FRAME:AddMessage("- " .. SLASH_RhadaTip2 .. " al -> Forces RhadaTip to reload the support for AtlasLoot", 1.0, 0.0, 0.95, 50, 5);
	DEFAULT_CHAT_FRAME:AddMessage("- " .. SLASH_RhadaTip2 .. " trinkets -> Lists supported trinkets, sorted by dps :-)", 1.0, 0.0, 0.95, 50, 5);
	DEFAULT_CHAT_FRAME:AddMessage("- " .. SLASH_RhadaTip2 .. " enchants -> Lists top 10 enchants for character", 1.0, 0.0, 0.95, 50, 5);
	DEFAULT_CHAT_FRAME:AddMessage("- " .. SLASH_RhadaTip2 .. " cache -> Lists items currently in the item cache", 1.0, 0.0, 0.95, 50, 5);
	DEFAULT_CHAT_FRAME:AddMessage("- " .. SLASH_RhadaTip2 .. " hit -> Gives you a break down of your current hit stats", 1.0, 0.0, 0.95, 50, 5);
	DEFAULT_CHAT_FRAME:AddMessage("- " .. SLASH_RhadaTip2 .. " exp -> Gives you a break down of your current Expertise stats", 1.0, 0.0, 0.95, 50, 5);
	DEFAULT_CHAT_FRAME:AddMessage("- " .. SLASH_RhadaTip2 .. " gearlvl -> Gives your current avg item lvl", 1.0, 0.0, 0.95, 50, 5);
	DEFAULT_CHAT_FRAME:AddMessage("- " .. SLASH_RhadaTip2 .. " pvcheck -> Returns the auto detected profile", 1.0, 0.0, 0.95, 50, 5);
	DEFAULT_CHAT_FRAME:AddMessage("- " .. SLASH_RhadaTip2 .. " upg <itemlink> -> Returns list of possible gear upgrades", 1.0, 0.0, 0.95, 50, 5);
end

-- this function is called on "PLAYER_ALIVE" and "ACTIVE_TALENT_GROUP_CHANGED". If the user has both the spellpower scale and the attackpower scale, it means that he didnt configure his scales yet. 
-- Rhadatip will try to find a pre set template that matches the current talents of the player, if it finds one, it loads its scales
function RhadaTip:SetTemplateSVOnLoad(silent)
	local activeTalentGroup = GetActiveTalentGroup(false, false)

--	RhadaTip:debug_out("Rhada saved value check")
	if (RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_INTELLECT_SHORT"] == nil and RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_STRENGTH_SHORT"] == nil and RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_AGILITY_SHORT"] == nil) or (RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_INTELLECT_SHORT"] == 0 and RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_STRENGTH_SHORT"] == 0 and RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_AGILITY_SHORT"] == 0) or (RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_INTELLECT_SHORT"] == "0" and RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_STRENGTH_SHORT"] == "0" and RhadaTip_Scales[activeTalentGroup]["ITEM_MOD_AGILITY_SHORT"] == "0") then
		local temp_spec = rhada_PV_spec_finder()
		if (temp_spec == "" or temp_spec == nil) and not silent then
			DEFAULT_CHAT_FRAME:AddMessage("*** WARNING: RhadaTip hasn't been configured yet. All values will be equal to zero unless you either set the input fields by yourself (in " .. SLASH_RhadaTip2 .. " sv and " .. SLASH_RhadaTip2 .. " hc), or select some pre-defined values (in " .. SLASH_RhadaTip2 .. " pv) ***", 1.0, 0.0, 0.95, 50, 5);
		else
			if not silent then
				DEFAULT_CHAT_FRAME:AddMessage("Defaulting RhadaTip scales to use " .. temp_spec, 1.0, 0.0, 0.95, 50, 5);
			end
--			RhadaTip_PresetScalingValuesNoButton(temp_spec)
			RhadaTip_Select_SV(temp_spec)
			if not silent then
				out("Loading: " .. temp_spec)
			end
			DEFAULT_PROFILE_VALUES = temp_spec
		end
	elseif DEFAULT_PROFILE_VALUES ~= nil then	
--		local temp_status = RhadaTip_PresetScalingValuesNoButton(DEFAULT_PROFILE_VALUES)
		local temp_status = RhadaTip_Select_SV(DEFAULT_PROFILE_VALUES)
		if temp_status == false then
			if not silent then
				DEFAULT_CHAT_FRAME:AddMessage("Default Profile not found... Scanning for replacement...", 1.0, 0.0, 0.95, 50, 5);
			end
			local temp_spec = rhada_PV_spec_finder()
			if (temp_spec == "" or temp_spec == nil) and not silent then
				DEFAULT_CHAT_FRAME:AddMessage("*** WARNING: RhadaTip hasn't been configured yet. All values will be equal to zero unless you either set the input fields by yourself (in " .. SLASH_RhadaTip2 .. " sv and " .. SLASH_RhadaTip2 .. " hc), or select some pre-defined values (in " .. SLASH_RhadaTip2 .. " pv) ***", 1.0, 0.0, 0.95, 50, 5);
			else
				if not silent then
					DEFAULT_CHAT_FRAME:AddMessage("Defaulting RhadaTip scales to use " .. temp_spec, 1.0, 0.0, 0.95, 50, 5);
				end
--				RhadaTip_PresetScalingValuesNoButton(temp_spec)
				RhadaTip_Select_SV(temp_spec)
				DEFAULT_PROFILE_VALUES = temp_spec
			end
		end
	end
end

-- the OnEvent function


-- this global variable is used in conjunction with the function RhadaTip:ComputeGearTooltip for every tooltip that isnt ComparisonTooltip1 or ComparisonTooltip2
--totalGearDpsTip = 0
--totalGearDpsTip_ready = false

-- this function takes an itemLink as its input, and returns the itemString minus the last two fields separated by :
function RhadaTip:GetParsedItemString(itemLink)
	local _, _, itemString = strfind(itemLink, "^|c%x+|H(.+)|h%[.*%]")
	-- i want the matchings to be done on the first 6 pieces
	local a1, a2, a3, a4, a5, a6 = select(3, strfind(itemString, "item:(%d+):(%d+):(%d+):(%d+):(%d+):(%d+)"))
	local finalString = strjoin(":", a1, a2, a3, a4, a5, a6)
	return finalString
end

RhadaTip.cachedItems = {{}}
--RhadaTip.cachedItems[0] = {[0] = {}}

function RhadaTip:dump_cachedItems()
	local activeTalentGroup = GetActiveTalentGroup(false, false)
	for k,v in pairs(RhadaTip.cachedItems[activeTalentGroup]) do 
		if RhadaTip.cachedItems[k]["DPS"] ~= nil then
		out(k .. " Data: " .. RhadaTip.cachedItems[activeTalentGroup][k]["DPS"])
		end
	end
end

-- this function clears the item cache (the table RhadaTip_cachedItem). it is called every time the user changes a scaling value, a gem, etc
function RhadaTip:ClearTTcache()
	wipe(RhadaTip.tooltip_cache)
	RhadaTip.tooltip_cache = {}
end

function RhadaTip:ClearItemCacheTable()
--	RhadaTip:debug_out(debugstack())
	wipe(RhadaTip.cachedItems)
	RhadaTip.cachedItems = {{}}
--	RhadaTip.cachedItems[0] = {[0]={}}

end

-- this function is used to compute gear dps when called from every tooltip that isnt ComparisonTooltip1 or ComparisonTooltip2
function RhadaTip:ComputeGearTooltip(itemLocation, itemLink)
	local temp_gear_dps = 0
	local headLink = GetInventoryItemLink("player",GetInventorySlotInfo("HeadSlot"))
	local neckLink = GetInventoryItemLink("player",GetInventorySlotInfo("NeckSlot"))
	local shoulderLink = GetInventoryItemLink("player",GetInventorySlotInfo("ShoulderSlot"))
	local backLink = GetInventoryItemLink("player",GetInventorySlotInfo("BackSlot"))
	local chestLink = GetInventoryItemLink("player",GetInventorySlotInfo("ChestSlot"))
	local wristLink = GetInventoryItemLink("player",GetInventorySlotInfo("wristSlot"))
	local handsLink = GetInventoryItemLink("player",GetInventorySlotInfo("HandsSlot"))
	local waistLink = GetInventoryItemLink("player",GetInventorySlotInfo("WaistSlot"))
	local legsLink = GetInventoryItemLink("player",GetInventorySlotInfo("LegsSlot"))
	local feetLink = GetInventoryItemLink("player",GetInventorySlotInfo("FeetSlot"))
	local finger0Link = GetInventoryItemLink("player",GetInventorySlotInfo("Finger0Slot"))
	local finger1Link = GetInventoryItemLink("player",GetInventorySlotInfo("Finger1Slot"))
	local trinket0Link = GetInventoryItemLink("player",GetInventorySlotInfo("Trinket0Slot"))
	local trinket1Link = GetInventoryItemLink("player",GetInventorySlotInfo("Trinket1Slot"))
	local mainHandLink = GetInventoryItemLink("player",GetInventorySlotInfo("MainHandSlot"))
	local secondaryHandLink = GetInventoryItemLink("player",GetInventorySlotInfo("SecondaryHandSlot"))
	local rangedLink = GetInventoryItemLink("player",GetInventorySlotInfo("RangedSlot"))
	-- check to see whether the tooltipped item is a currently equipped item. This check is done on the parsed itemStrings (itemString minus the last 2 fields) so that is is more strict than a mere itemId check, but still returns true no matter what the last 2 fiends are
	if IsEquippedItem(ItemLink)then
		-- the tooltipped item is an equipped item, simply return RhadaTip.totalGearDps
		temp_gear_dps = RhadaTip.totalGearDps
	else 
		-- the tooltipped item isnt an equipped one
		if itemLocation == "INVTYPE_HEAD" then
			-- if the tooltipped item is a headpiece, call the function with all the currently equipped items, minus the current headpiece plus the tooltipped item
			temp_gear_dps = RhadaTip_computeAllOptimalGear(itemLink, neckLink, shoulderLink, backLink, chestLink, wristLink, handsLink, waistLink, 
				legsLink, feetLink, mainHandLink, secondaryHandLink, rangedLink, finger0Link, finger1Link, trinket0Link, trinket1Link)	
		elseif itemLocation == "INVTYPE_NECK" then
			temp_gear_dps = RhadaTip_computeAllOptimalGear(headLink, itemLink, shoulderLink, backLink, chestLink, wristLink, handsLink, waistLink, 
				legsLink, feetLink, mainHandLink, secondaryHandLink, rangedLink, finger0Link, finger1Link, trinket0Link, trinket1Link)	
		elseif itemLocation == "INVTYPE_SHOULDER" then
			temp_gear_dps = RhadaTip_computeAllOptimalGear(headLink, neckLink, itemLink, backLink, chestLink, wristLink, handsLink, waistLink, 
				legsLink, feetLink, mainHandLink, secondaryHandLink, rangedLink, finger0Link, finger1Link, trinket0Link, trinket1Link)	
		elseif itemLocation == "INVTYPE_CLOAK" then
			temp_gear_dps = RhadaTip_computeAllOptimalGear(headLink, neckLink, shoulderLink, itemLink, chestLink, wristLink, handsLink, waistLink, 
				legsLink, feetLink, mainHandLink, secondaryHandLink, rangedLink, finger0Link, finger1Link, trinket0Link, trinket1Link)	
		elseif itemLocation == "INVTYPE_CHEST" or itemLocation == "INVTYPE_ROBE" then
			temp_gear_dps = RhadaTip_computeAllOptimalGear(headLink, neckLink, shoulderLink, backLink, itemLink, wristLink, handsLink, waistLink, 
				legsLink, feetLink, mainHandLink, secondaryHandLink, rangedLink, finger0Link, finger1Link, trinket0Link, trinket1Link)	
		elseif itemLocation == "INVTYPE_WRIST" then
			temp_gear_dps = RhadaTip_computeAllOptimalGear(headLink, neckLink, shoulderLink, backLink, chestLink, itemLink, handsLink, waistLink, 
				legsLink, feetLink, mainHandLink, secondaryHandLink, rangedLink, finger0Link, finger1Link, trinket0Link, trinket1Link)	
		elseif itemLocation == "INVTYPE_HAND" then
			temp_gear_dps = RhadaTip_computeAllOptimalGear(headLink, neckLink, shoulderLink, backLink, chestLink, wristLink, itemLink, waistLink, 
				legsLink, feetLink, mainHandLink, secondaryHandLink, rangedLink, finger0Link, finger1Link, trinket0Link, trinket1Link)	
		elseif itemLocation == "INVTYPE_WAIST" then
			temp_gear_dps = RhadaTip_computeAllOptimalGear(headLink, neckLink, shoulderLink, backLink, chestLink, wristLink, handsLink, itemLink, 
				legsLink, feetLink, mainHandLink, secondaryHandLink, rangedLink, finger0Link, finger1Link, trinket0Link, trinket1Link)	
		elseif itemLocation == "INVTYPE_LEGS" then
			temp_gear_dps = RhadaTip_computeAllOptimalGear(headLink, neckLink, shoulderLink, backLink, chestLink, wristLink, handsLink, waistLink, 
				itemLink, feetLink, mainHandLink, secondaryHandLink, rangedLink, finger0Link, finger1Link, trinket0Link, trinket1Link)	
		elseif itemLocation == "INVTYPE_FEET" then
			temp_gear_dps = RhadaTip_computeAllOptimalGear(headLink, neckLink, shoulderLink, backLink, chestLink, wristLink, handsLink, waistLink, 
				legsLink, itemLink, mainHandLink, secondaryHandLink, rangedLink, finger0Link, finger1Link, trinket0Link, trinket1Link)	
		elseif itemLocation == "INVTYPE_RELIC" then
			temp_gear_dps = RhadaTip_computeAllOptimalGear(headLink, neckLink, shoulderLink, backLink, chestLink, wristLink, handsLink, waistLink, 
				legsLink, feetLink, mainHandLink, secondaryHandLink, itemLink, finger0Link, finger1Link, trinket0Link, trinket1Link)	
		elseif itemLocation == "INVTYPE_FINGER" then
			local minusRingZero = RhadaTip_computeAllOptimalGear(headLink, neckLink, shoulderLink, backLink, chestLink, wristLink, handsLink, waistLink, 
				legsLink, feetLink, mainHandLink, secondaryHandLink, rangedLink, finger0Link, itemLink, trinket0Link, trinket1Link)
			local minusRingOne = RhadaTip_computeAllOptimalGear(headLink, neckLink, shoulderLink, backLink, chestLink, wristLink, handsLink, waistLink, 
				legsLink, feetLink, mainHandLink, secondaryHandLink, rangedLink, itemLink, finger1Link, trinket0Link, trinket1Link)
			-- rhadatip should set the temp_gear_dps to the highest of the two previous values
			if tonumber(minusRingZero) >= tonumber(minusRingOne) then
				temp_gear_dps = minusRingZero
			else
				temp_gear_dps = minusRingOne
			end			
		elseif itemLocation == "INVTYPE_TRINKET" then
			local minusTrinketZero = RhadaTip_computeAllOptimalGear(headLink, neckLink, shoulderLink, backLink, chestLink, wristLink, handsLink, waistLink, 
				legsLink, feetLink, mainHandLink, secondaryHandLink, rangedLink, finger0Link, finger1Link, trinket0Link, itemLink)
			local minusTrinketOne = RhadaTip_computeAllOptimalGear(headLink, neckLink, shoulderLink, backLink, chestLink, wristLink, handsLink, waistLink, 
				legsLink, feetLink, mainHandLink, secondaryHandLink, rangedLink, finger0Link, finger1Link, itemLink, trinket1Link)
			if tonumber(minusTrinketZero) >= tonumber(minusTrinketOne) then
				temp_gear_dps = minusTrinketZero
			else
				temp_gear_dps = minusTrinketOne
			end			
		elseif itemLocation == "INVTYPE_WEAPONMAINHAND" then
			-- if the tooltipped item is a main hand, replace it over the mainhandlink
			temp_gear_dps = RhadaTip_computeAllOptimalGear(headLink, neckLink, shoulderLink, backLink, chestLink, wristLink, handsLink, waistLink, 
				legsLink, feetLink, itemLink, secondaryHandLink, rangedLink, finger0Link, finger1Link, trinket0Link, trinket1Link)	
		elseif itemLocation == "INVTYPE_2HWEAPON" then
			-- if the tooltipped item is 2h, replace it over the mainhandlink and set the secondaryhandlink to a proxy or nil
			temp_gear_dps = RhadaTip_computeAllOptimalGear(headLink, neckLink, shoulderLink, backLink, chestLink, wristLink, handsLink, waistLink, 
				legsLink, feetLink, itemLink, nil, rangedLink, finger0Link, finger1Link, trinket0Link, trinket1Link)	
		elseif itemLocation == "INVTYPE_HOLDABLE" or itemLocation == "INVTYPE_WEAPONOFFHAND" or itemLocation == "INVTYPE_SHIELD" then
			-- if the tooltipped item is anything that goes into the off hand slot, check if it can just be replaced, or the one hand must be also removed (if it is a 2h weapon)
			local MHItemID
			local MHItemEquipLoc
			if mainHandLink ~= nil then
				MHItemID = tonumber(select(3, strfind(mainHandLink, "Hitem:(%d+)")))
				MHItemEquipLoc = select(9, GetItemInfo(MHItemID))
			end
			-- if there actually is a mh equipped, and it is a 2h weapon, set the main hand to null, otherwise just replace the offhand with itemLink
			if MHItemEquipLoc ~= nil and MHItemEquipLoc == "INVTYPE_2HWEAPON" then
				temp_gear_dps = RhadaTip_computeAllOptimalGear(headLink, neckLink, shoulderLink, backLink, chestLink, wristLink, handsLink, waistLink, 
					legsLink, feetLink, nil, itemLink, rangedLink, finger0Link, finger1Link, trinket0Link, trinket1Link)	
			else
				temp_gear_dps = RhadaTip_computeAllOptimalGear(headLink, neckLink, shoulderLink, backLink, chestLink, wristLink, handsLink, waistLink, 
					legsLink, feetLink, mainHandLink, itemLink, rangedLink, finger0Link, finger1Link, trinket0Link, trinket1Link)	
			end
		elseif itemLocation == "INVTYPE_WEAPON" then
			-- a one handed weapon can surely go in place of the main hand slot 
			local minusMainHand = RhadaTip_computeAllOptimalGear(headLink, neckLink, shoulderLink, backLink, chestLink, wristLink, handsLink, waistLink, 
				legsLink, feetLink, itemLink, secondaryHandLink, rangedLink, finger0Link, finger1Link, trinket0Link, trinket1Link)
			-- a one hand can also go into the secondary hand slot. if the weapon in the main hand slot is a 2h weapon though, the main hand link has to be put to nil
			local MHItemID
			local MHItemEquipLoc
			local minusSecondaryHand
			if mainHandLink ~= nil then
				MHItemID = tonumber(select(3, strfind(mainHandLink, "Hitem:(%d+)")))
				MHItemEquipLoc = select(9, GetItemInfo(MHItemID))
			end
			if MHItemEquipLoc == nil or MHItemEquipLoc == "INVTYPE_2HWEAPON" then
				minusSecondaryHand = RhadaTip_computeAllOptimalGear(headLink, neckLink, shoulderLink, backLink, chestLink, wristLink, handsLink, waistLink, 
					legsLink, feetLink, nil, itemLink, rangedLink, finger0Link, finger1Link, trinket0Link, trinket1Link)
			else
				if RhadaTip_class.is_dual_wield() then
					minusSecondaryHand = RhadaTip_computeAllOptimalGear(headLink, neckLink, shoulderLink, backLink, chestLink, wristLink, handsLink, waistLink, 
					legsLink, feetLink, mainHandLink, itemLink, rangedLink, finger0Link, finger1Link, trinket0Link, trinket1Link)
				else
					minusSecondaryHand = 0
				end
			end
			if tonumber(minusMainHand) >= tonumber(minusSecondaryHand) then
				temp_gear_dps = minusMainHand
			else
				temp_gear_dps = minusSecondaryHand
			end
		elseif itemLocation == "INVTYPE_RANGEDRIGHT" or itemLocation == "INVTYPE_RANGED" or itemLocation == "INVTYPE_THROWN" then
			temp_gear_dps = RhadaTip_computeAllOptimalGear(headLink, neckLink, shoulderLink, backLink, chestLink, wristLink, handsLink, waistLink, 
				legsLink, feetLink, mainHandLink, secondaryHandLink, itemLink, finger0Link, finger1Link, trinket0Link, trinket1Link)	
		end
	end 
--	RhadaTip:debug_out(itemLink .. ":" .. temp_gear_dps)
	return temp_gear_dps
end

-- the currently equipped total gear dps
RhadaTip.totalGearDps = 0

-- this is used to get the currently equipped gear dps value
function RhadaTip:ComputeAllGear()
	local headLink = GetInventoryItemLink("player",GetInventorySlotInfo("HeadSlot"))
	local neckLink = GetInventoryItemLink("player",GetInventorySlotInfo("NeckSlot"))
	local shoulderLink = GetInventoryItemLink("player",GetInventorySlotInfo("ShoulderSlot"))
	local backLink = GetInventoryItemLink("player",GetInventorySlotInfo("BackSlot"))
	local chestLink = GetInventoryItemLink("player",GetInventorySlotInfo("ChestSlot"))
	local wristLink = GetInventoryItemLink("player",GetInventorySlotInfo("wristSlot"))
	local handsLink = GetInventoryItemLink("player",GetInventorySlotInfo("HandsSlot"))
	local waistLink = GetInventoryItemLink("player",GetInventorySlotInfo("WaistSlot"))
	local legsLink = GetInventoryItemLink("player",GetInventorySlotInfo("LegsSlot"))
	local feetLink = GetInventoryItemLink("player",GetInventorySlotInfo("FeetSlot"))
	local finger0Link = GetInventoryItemLink("player",GetInventorySlotInfo("Finger0Slot"))
	local finger1Link = GetInventoryItemLink("player",GetInventorySlotInfo("Finger1Slot"))
	local trinket0Link = GetInventoryItemLink("player",GetInventorySlotInfo("Trinket0Slot"))
	local trinket1Link = GetInventoryItemLink("player",GetInventorySlotInfo("Trinket1Slot"))
	local mainHandLink = GetInventoryItemLink("player",GetInventorySlotInfo("MainHandSlot"))
	local secondaryHandLink = GetInventoryItemLink("player",GetInventorySlotInfo("SecondaryHandSlot"))
	local rangedLink = GetInventoryItemLink("player",GetInventorySlotInfo("RangedSlot"))
	RhadaTip.totalGearDps = RhadaTip_computeAllOptimalGear(headLink, neckLink, shoulderLink, backLink, chestLink, wristLink, handsLink, waistLink, 
		legsLink, feetLink, mainHandLink, secondaryHandLink, rangedLink, finger0Link, finger1Link, trinket0Link, trinket1Link)
	return RhadaTip.totalGearDps;
end

-- this function takes a table of all the currently equipped gear, calls BuildBonusSet to retrieve the list of all currently equipped tier pieces
-- and passes that list to RhadaTip_GetSetBonusesXps to receive an actual dps/hps value, that this function returns to the calling function
function RhadaTip:GetSetBonuses(gearTable)
	local tier_set_count = {}
--	local _, setCount = LIBIB:BuildBonusSet(gearTable)
--	local dps = RhadaTip_GetSetBonusesXps(setCount)
	local dps2 = 0
	for k,v in pairs(gearTable) do
		local itemID = rhada_get_item_id(v)
		local tier_number = rhada_get_tier_number(itemID)
--		RhadaTip:debug_out(v .. ": " .. tier_number)
		if tier_number ~= nil then
			if tier_set_count[tier_number] == nil then
				tier_set_count[tier_number] = 1
			else
				tier_set_count[tier_number] = tier_set_count[tier_number] + 1
			end
		end
	end

	local activeTalentGroup = GetActiveTalentGroup(false, false)

	for k,v in pairs(tier_set_count) do

		if k == "7" and v > 1 then
			if RhadaTip_Scales[activeTalentGroup]["fPT7_SCALE"] ~= nil then
				dps2 = dps2 + RhadaTip_Scales[activeTalentGroup]["tPT7_SCALE"]
			end
		end
		if k == "7" and v == 4 then
			if RhadaTip_Scales[activeTalentGroup]["fPT7_SCALE"] ~= nil then
				dps2 = dps2 + RhadaTip_Scales[activeTalentGroup]["fPT7_SCALE"]
			end
		end
		if k == "8" and v > 1 then
			if RhadaTip_Scales[activeTalentGroup]["fPT8_SCALE"] ~= nil then
				dps2 = dps2 + RhadaTip_Scales[activeTalentGroup]["tPT8_SCALE"]
			end
		end
		if k == "8" and v == 4 then
			if RhadaTip_Scales[activeTalentGroup]["fPT8_SCALE"] ~= nil then
				dps2 = dps2 + RhadaTip_Scales[activeTalentGroup]["fPT8_SCALE"]
			end
		end
		if k == "9" and v > 1 then
			if RhadaTip_Scales[activeTalentGroup]["fPT9_SCALE"] ~= nil then
				dps2 = dps2 + RhadaTip_Scales[activeTalentGroup]["tPT9_SCALE"]
			end
		end
		if k == "9" and v == 4 then
			if RhadaTip_Scales[activeTalentGroup]["fPT9_SCALE"] ~= nil then
				dps2 = dps2 + RhadaTip_Scales[activeTalentGroup]["fPT9_SCALE"]
			end
		end
		if k == "10" and v > 1 then
			if RhadaTip_Scales[activeTalentGroup]["fPT10_SCALE"] ~= nil then
				dps2 = dps2 + RhadaTip_Scales[activeTalentGroup]["tPT10_SCALE"]
			end
		end
		if k == "10" and v == 4 then
			if RhadaTip_Scales[activeTalentGroup]["fPT10_SCALE"] ~= nil then
				dps2 = dps2 + RhadaTip_Scales[activeTalentGroup]["fPT10_SCALE"]
			end
		end
		if k == "11" and v > 1 then
			if RhadaTip_Scales[activeTalentGroup]["fPT11_SCALE"] ~= nil then
				dps2 = dps2 + RhadaTip_Scales[activeTalentGroup]["tPT11_SCALE"]
			end
		end
		if k == "11" and v == 4 then
			if RhadaTip_Scales[activeTalentGroup]["fPT11_SCALE"] ~= nil then
				dps2 = dps2 + RhadaTip_Scales[activeTalentGroup]["fPT11_SCALE"]
			end
		end
	end
--	RhadaTip:debug_out(dps .. " vs " .. dps2)
	return dps2
end

function RhadaTip_OnTooltipSetItem(tooltip, ...)
	if tooltip == nil then return tooltip, ... end
	
--	if tooltip:GetName() == RhadaTipScanningTooltip then return tooltip, ... end
	
	local _, ItemLink = tooltip:GetItem();
	if ItemLink == nil then return tooltip, ... end

	if RhadaTip.tooltip_cache[ItemLink] == nil or RhadaTip.totalGearDps_calc_error then
		RhadaTip_GenerateTooltip(tooltip, ItemLink)
	end
	RhadaTip_UpdateTooltip(tooltip, ItemLink)
	return tooltip, ...
end

function RhadaTip_GenerateTooltip(tooltip, ItemLink)
	if ItemLink ~= nil then

		-- get static properties of the item itemID, usefull to determine if the item is an armor piece, weapon, trinket
		local _, _, _, _, _, itemType, itemSubType, _, itemEquipLoc, _ = GetItemInfo(ItemLink)
--		RhadaTip:debug_out(RhadaTip_class.rhada_item_index[itemType][itemSubType])
--		RhadaTip:debug_out(itemType.. ":" .. itemSubType)
		if RhadaTip_class.rhada_item_index[itemType] == nil then return end
		if RhadaTip_class.rhada_item_index[itemType][itemSubType] == nil then return end
			
		-- only do the following if the item is an armor or weapon	
		if itemType == RhadaTip_Localized["Armor"] or itemType == RhadaTip_Localized["Weapon"] then
			local spec = GetActiveTalentGroup(false, false)

			if RhadaTip.totalGearDps_calc_error or RhadaTip.load_delay then
				RhadaTip:ComputeAllGear()
--				RhadaTip:debug_out("gear recalculated")
				if time() - RhadaTip.load_time > 15 then
					RhadaTip.load_delay = false
				end
			end

			local enchant_id, enchant_dps, ench_status, enchanted, ench_hit, ench_spirit, ench_exp = RhadaTip_get_enchant_info(ItemLink)
			local itemDps, item_hit, item_expertise, item_spirit, item_penalty, item_warning = getItemSlotValue(tooltip, false)
			if itemDps == nil or item_hit == nil or item_expertise == nil or item_penalty == nil then
				return "getItemSlotValue failed"
			end
			item_hit = item_hit + ench_hit
			RhadaTip.tooltip_cache[ItemLink] = {}
			local offspecItemDps = getItemSlotValue(tooltip, true)			
			RhadaTip.tooltip_cache[ItemLink][1] ={text= ("Offspec Item " .. RhadaTip_GainType .. "=" .. offspecItemDps), red = 1, green = 0, blue = 1}

			local Item_Is_Equiped = IsEquippedItem(ItemLink)
			if item_hit ~= nil then
				if item_hit > 0 then
					local item_hitcap = 0
					local equip_hit = 0
					if not Item_Is_Equiped then
						equip_hit = RhadaTip_get_equip_stat(itemEquipLoc, "ITEM_MOD_HIT_RATING_SHORT")
					end
					--get our current hit cap and hit rating										
					hit_rating, item_hitcap = RhadaTip_class.get_hitcap()
					--See if we are over our hit cap
					if tonumber(hit_rating) > tonumber(item_hitcap) then
						-- if the current hit rating is more than the desired hit cap, compute the excessHit
						local unused_hit = hit_rating - item_hitcap
						if Item_Is_Equiped then
							if unused_hit>item_hit then
--								RhadaTip:debug_out("over cap, equiped, item does not cross hit cap")
								itemDps = itemDps - (item_hit * (RhadaTip_Scales[spec]["ITEM_MOD_HIT_RATING_SHORT"] or 0))
								RhadaTip.tooltip_cache[ItemLink][6] = {text = ("This item has "..format("%.2f",item_hit).." unused hit."), red = 1, green = 1, blue = 0}
							else
--								RhadaTip:debug_out("over cap, equiped, item crosses hit cap")
								itemDps = itemDps - (unused_hit * (RhadaTip_Scales[spec]["ITEM_MOD_HIT_RATING_SHORT"] or 0))
								RhadaTip.tooltip_cache[ItemLink][6] = {text = ("This item has "..format("%.2f",unused_hit).." unused hit."), red = 1, green = 1, blue = 0}
							end
						else
							local effective_equip_hit = equip_hit - unused_hit
							if item_hit > effective_equip_hit then
								-- this item further extends our hit surplus. figure out how much addidional hit will be added beyond the equipped item
								-- then add that value to our surplus. subtract this from the possible dps value for the item.
								local tval = item_hit - effective_equip_hit
--								RhadaTip:debug_out("over cap, unequiped, Hit has no value, swapping will not effect the cap")
								itemDps = itemDps - (tval * (RhadaTip_Scales[spec]["ITEM_MOD_HIT_RATING_SHORT"] or 0))
								RhadaTip.tooltip_cache[ItemLink][6] = {text = ("This item has ".. format("%.2f",tval) .." unusable hit."), red = 1, green = 1, blue = 0}
							else
								 --this item will put us under our cap, so all of the hit is actually useful. no math needed.
								
							end
						end
					else
						local hit_needed = item_hitcap - hit_rating
						if Item_Is_Equiped then
--							RhadaTip:debug_out("under cap, equiped, item does not cross hit cap")
						else
							local effective_hit = item_hit
							if equip_hit > 0 then
								effective_hit = item_hit - equip_hit
							end
							if hit_needed < effective_hit then
--								RhadaTip:debug_out("under cap, unequiped, item crosses hit cap")
								itemDps = itemDps - ((effective_hit - hit_needed) * (RhadaTip_Scales[spec]["ITEM_MOD_HIT_RATING_SHORT"] or 0))
								RhadaTip.tooltip_cache[ItemLink][6] =  {text = ("This item has "..format("%.2f",(effective_hit - hit_needed)).." unusable hit."), red = 1, green = 1, blue = 0}
							else
--								RhadaTip:debug_out("under cap, unequiped, item does not cross hit cap")
							end
						end
					end
				end
			end
			if item_expertise ~= nil then
				if item_expertise > 0 then
					local item_expcap = 0
					local equip_exp = 0
					if not IsEquippedItem(ItemLink) then
						equip_exp = RhadaTip_get_equip_stat(itemEquipLoc, "ITEM_MOD_EXPERTISE_RATING_SHORT")
					end

					--get our current expertise cap and expertise rating										
					exp_rating, item_expcap = RhadaTip_class.get_expcap()
					--See if we are over our expertise cap
					if tonumber(exp_rating) > tonumber(item_expcap) then
						-- if the current hit rating is more than the desired expertise cap, compute the excessHit
						local unused_exp = exp_rating - item_expcap
						if Item_Is_Equiped then
							if unused_exp>item_expertise then
--								RhadaTip:debug_out("over cap, equiped, item does not cross expertise cap")
								itemDps = itemDps - (item_expertise * (RhadaTip_Scales[spec]["ITEM_MOD_EXPERTISE_RATING_SHORT"] or 0))
								RhadaTip.tooltip_cache[ItemLink][8] =  {text = ("This item has "..format("%.2f",item_expertise).." softcap expertise."), red = 1, green = 1, blue = 0}
							else
--								RhadaTip:debug_out("over cap, equiped, item crosses expertise cap")
								itemDps = itemDps - (unused_exp * (RhadaTip_Scales[spec]["ITEM_MOD_EXPERTISE_RATING_SHORT"] or 0))
								RhadaTip.tooltip_cache[ItemLink][8] =  {text = ("This item has "..format("%.2f",unused_exp).." softcap expertise."), red = 1, green = 1, blue = 0}
							end
						else
							local effective_equip_exp = equip_exp - unused_exp
							if item_expertise > effective_equip_exp then
								-- this item further extends our hit surplus. figure out how much addidional hit will be added beyond the equipped item
								-- then add that value to our surplus. subtract this from the possible dps value for the item.
								local tval = item_expertise - equip_exp + unused_exp
--								RhadaTip:debug_out("over cap, unequiped, Hit has no value, swapping will not effect the cap")
								itemDps = itemDps - (tval * (RhadaTip_Scales[spec]["ITEM_MOD_EXPERTISE_RATING_SHORT"] or 0))
								RhadaTip.tooltip_cache[ItemLink][8] =  {text = ("This item has ".. format("%.2f",tval) .." softcap expertise."), red = 1, green = 1, blue = 0}
							else
								 --this item will put us under our cap, so all of the exp is actually useful. no math needed.

							end
						end
					else
						local exp_needed = item_expcap - exp_rating
						if Item_Is_Equiped then
--							RhadaTip:debug_out("under cap, equiped, item does not cross expertise cap")
						else
							local effective_exp = item_expertise
							if equip_exp > 0 then
								effective_exp = item_expertise - equip_exp
							end
							if exp_needed < effective_exp then
--								RhadaTip:debug_out("under cap, unequiped, item crosses hit cap")
								itemDps = itemDps - ((effective_exp - exp_needed) * (RhadaTip_Scales[spec]["ITEM_MOD_EXPERTISE_RATING_SHORT"] or 0))
								RhadaTip.tooltip_cache[ItemLink][8] =  {text = ("This item has "..format("%.2f",(effective_exp - exp_needed)).." softcap expertise."), red = 1, green = 1, blue = 0}
							else
--								RhadaTip:debug_out("under cap, unequiped, item does not cross hit cap")
							end
						end
					end
				end
			end
			if itemDps ~= nil then
				RhadaTip.tooltip_cache[ItemLink][2] =  {text = ("Item " .. RhadaTip_GainType .. "=" .. format("%.2f",itemDps)), red = 1, green = 0, blue = 1}
			else
				return("RhadaTip error reading item. itemDps failed")
			end
			if tonumber(itemDps) > tonumber(RhadaTip.totalGearDps) then
				RhadaTip:ComputeAllGear()
			end

			-- format the currently equipped gear value
			local roundedGearGainTr = format("%.2f", (RhadaTip.totalGearDps or 0))
--			RhadaTip.tooltip_cache[ItemLink][4] =  {text = ("Current Total Gear " .. RhadaTip_GainType .. "=" .. roundedGearGainTr), red = 1, green = 0, blue = 1}
			-- compute the difference between the currently equipped item and the tooltipped item, using the function RhadaTip:ComputeGearTooltip(itemLocation, itemLink)
			
			if Item_Is_Equiped then
				RhadaTip.tooltip_cache[ItemLink][4] =  {text = ("Total " .. RhadaTip_GainType .. "=" .. roundedGearGainTr), red = 1, green = 0, blue = 1}
			else
				local totalGearDpsTip = RhadaTip:ComputeGearTooltip(itemEquipLoc, ItemLink)
				local roundedGearGainTip = format("%.2f", (totalGearDpsTip or 0))
				local roundedDiff = format("%.2f", (tonumber(roundedGearGainTip)-tonumber(roundedGearGainTr)))
				if tonumber(roundedGearGainTr) > tonumber(roundedGearGainTip) then
--					RhadaTip.tooltip_cache[ItemLink][5] =  {text = ("New Total Gear " .. RhadaTip_GainType .. "=" .. roundedGearGainTip .. " (" .. (roundedDiff) .. ")"), red = 1, green = 0, blue = 0}
					RhadaTip.tooltip_cache[ItemLink][5] =  {text = ("Total " .. RhadaTip_GainType .. "=" .. roundedGearGainTip .. " (" .. (roundedDiff) .. ")"), red = 1, green = 0, blue = 0}
				elseif tonumber(roundedGearGainTr) < tonumber(roundedGearGainTip) then
--					RhadaTip.tooltip_cache[ItemLink][5] =  {text = ("New Total Gear " .. RhadaTip_GainType .. "=" .. roundedGearGainTip .. " (" .. (roundedDiff) .. ")"), red = 0, green = 1, blue = 0}
					RhadaTip.tooltip_cache[ItemLink][5] =  {text = ("Total " .. RhadaTip_GainType .. "=" .. roundedGearGainTip .. " (" .. (roundedDiff) .. ")"), red = 0, green = 1, blue = 0}
				else
--					RhadaTip.tooltip_cache[ItemLink][5] =  {text = ("New Total Gear " .. RhadaTip_GainType .. "=" .. roundedGearGainTip), red = 1, green = 0, blue = 1}
					RhadaTip.tooltip_cache[ItemLink][5] =  {text = ("Total " .. RhadaTip_GainType .. "=" .. roundedGearGainTip), red = 1, green = 0, blue = 1}
				end
			end
			
			if item_penalty > 0 then
				RhadaTip.tooltip_cache[ItemLink][7] =  {text = ("This item includes a " .. format("%.2f", item_penalty) .. " DPS penalty"), red = 1, green = 0, blue = 0}
			end
			if DPS_ENCHANTS then
				if enchanted then
					RhadaTip.tooltip_cache[ItemLink][8] =  {text = (ench_status), red = 1, green = 1, blue = 0}
				else
					RhadaTip.tooltip_cache[ItemLink][8] =  {text = (ench_status), red = 1, green = 1, blue = 0}
				end
			end
			if item_warning ~= nil or item_warning ~= "" then
				RhadaTip.tooltip_cache[ItemLink][7] =  {text = item_warning, red = 1, green = 1, blue = 0}
			end

		elseif itemType == "Gem" then
			RhadaTip.tooltip_cache[ItemLink] = {}

			local gemDps, gemID = 0, 0
			gemID = tonumber(rhada_get_item_id(ItemLink)) or 0
			gemDps = RhadaTip_GetGemDps(gemID)
			RhadaTip.tooltip_cache[ItemLink][2] =  {text = ("Gem " .. RhadaTip_GainType .. "=" .. format("%.2f",gemDps)), red = 1, green = 0, blue = 1}
			--look up the current socketed gem counts
			local t1,t2,t3 = rhada_get_equiped_gem_counts()
			RhadaTip.tooltip_cache[ItemLink][3] =  {text = ("Socketed Gems: " .. t1 .. "/" .. t2 .. "/" .. t3 .. " (R/B/Y)"), red = 1, green = 0, blue = 1}
		elseif RhadaTip_class.rhada_item_index[itemType][itemSubType] == "9:9" or RhadaTip_class.rhada_item_index[itemType][itemSubType] == "4:6" then
			RhadaTip.tooltip_cache[ItemLink] = {}
			local enchDps, enchID = 0, 0
			enchID = tonumber(rhada_get_item_id(ItemLink)) or 0
--			RhadaTip:debug_out("itemid: " .. enchID)
			ench_proc_id = RhadaTip_Enchant_ids[enchID]
			if RhadaTip_Enchant_ids[enchID] ~= nil then
--				RhadaTip:debug_out("procid: " .. ench_proc_id)

				enchDps = RhadaTip_GetEnchDPS(ench_proc_id)
				if enchDps > 0 then
					RhadaTip.tooltip_cache[ItemLink][2] =  {text = ("Enchant " .. RhadaTip_GainType .. "=" .. format("%.2f",enchDps)), red = 1, green = 0, blue = 1}
				end
			else
				RhadaTip.tooltip_cache[ItemLink][2] =  {text = ("Enchant is not known to RhadaTip"), red = 1, green = 1, blue = 0}
			end
		end
	end
end

function RhadaTip_OnTooltipSetSpell(tooltip, ...)
	if tooltip == nil then return tooltip, ... end

	local spellName, spellRank, spellID = tooltip:GetSpell()
	if spellID == nil then return tooltip, ... end
	if RhadaTip.tooltip_cache[spellID] == nil then
		RhadaTip_GenerateTooltip_spell(tooltip, spellID)
	end
	RhadaTip_UpdateTooltip(tooltip, spellID)
	return tooltip, ...
end

function RhadaTip_GenerateTooltip_spell(tooltip, spellID)
	if spellID ~= nil then
		RhadaTip.tooltip_cache[spellID] = {}
		local enchDps = 0
		if RhadaTip_Enchant_ids[spellID] ~= nil then
			local ench_proc_id = RhadaTip_Enchant_ids[spellID]
			enchDps = RhadaTip_GetEnchDPS(ench_proc_id)

			if enchDps > 0 then
				RhadaTip.tooltip_cache[spellID][2] = {text = ("Enchant " .. RhadaTip_GainType .. "=" .. format("%.2f",enchDps)), red = 1, green = 0, blue = 1}
			end
		else
--			RhadaTip.tooltip_cache[spellID]["line1"] = ("Enchant is not known to RhadaTip")
		end
	end
end

function RhadaTip_UpdateTooltip(tooltip, ItemLink)
	if tooltip == nil then return end
	if RhadaTip.tooltip_cache[ItemLink] == nil then return end

	if RhadaTip.tooltip_cache[ItemLink] ~= nil then
		for k,v in pairs(RhadaTip.tooltip_cache[ItemLink]) do
			if k == 1 and SHOW_OFFSPEC_VALUES == "YES" then
				tooltip:AddLine(v.text, v.red, v.green, v.blue)
			end
			if k > 1 then
				tooltip:AddLine(v.text, v.red, v.green, v.blue)
			end
		end
	end
	tooltip:Show()
end

-- this function is used to load the support for EquipCompare, if the mod has actually been loaded
function RhadaTip:EC()
	-- if EquipCompare has been loaded
	if (IsAddOnLoaded("EquipCompare")) then
		-- hook the enhanced tooltip information to the EquipCompare proprietary tooltip
		ComparisonTooltip1:HookScript("OnTooltipSetItem", RhadaTip_OnTooltipSetItem)
--		ComparisonTooltip1:HookScript("OnTooltipCleared", RhadaTip_Ec1OnTooltipCleared)
		ComparisonTooltip2:HookScript("OnTooltipSetItem", RhadaTip_OnTooltipSetItem)
--		ComparisonTooltip2:HookScript("OnTooltipCleared", RhadaTip_Ec2OnTooltipCleared)
	end
end

-- this function is used to load the support for AtlasLoot, if the mod has actually been loaded
function RhadaTip:Al()
	-- if AtlasLoot has been loaded
	if (IsAddOnLoaded("AtlasLoot")) then
		for k,v in pairs(AtlasLoot_Data) do
			--test to see if this is an instance entry
			if AtlasLoot_Data[k].info and AtlasLoot_Data[k].info.module and AtlasLoot_Data[k].info.module == "AtlasLootCataclysm" and AtlasLoot_Data[k].info.instance ~= nil then
				local instance = strlower(AtlasLoot_Data[k].info.instance)

				--test to see if we have a db entry for this instance yet
				if RhadaTip_Inst_List[instance] == nil then
					--we don't, so lets add one
					RhadaTip_Inst_List[instance] = {}
				end
				--add this encounter to our db
				tinsert(RhadaTip_Inst_List[instance], k)
			end
		end
		-- hook the enhanced tooltip information to the AtlasLoot proprietary tooltip
		-- RhadaTip:debug_out("hooking atlas")
		AtlasLootTooltip:HookScript("OnTooltipSetItem", RhadaTip_OnTooltipSetItem)
--		AtlasLootTooltip:HookScript("OnTooltipCleared", RhadaTip_AlOnTooltipCleared)
	end
end

function RhadaTip:MAINLOAD(self)
	-- hook the enhanced tooltip information to the GameToolTip, ItemRefToolTip and ShoppingToolTip (no control needed here, these are inherited by the Blizzard default UI)

	ItemRefTooltip:HookScript("OnTooltipSetItem", RhadaTip_OnTooltipSetItem)
--	ItemRefTooltip:HookScript("OnTooltipCleared", RhadaTip_OnChatTooltipCleared)

	--this gives us access to the enchant spell tooltips
	GameTooltip:HookScript("OnTooltipSetSpell", RhadaTip_OnTooltipSetSpell)

	GameTooltip:HookScript("OnTooltipSetItem", RhadaTip_OnTooltipSetItem)
--	GameTooltip:HookScript("OnTooltipCleared", RhadaTip_OnTooltipCleared)
	ShoppingTooltip1:HookScript("OnTooltipSetItem", RhadaTip_OnTooltipSetItem)
--	ShoppingTooltip1:HookScript("OnTooltipCleared", RhadaTip_St1OnTooltipCleared)
	ShoppingTooltip2:HookScript("OnTooltipSetItem", RhadaTip_OnTooltipSetItem)
--	ShoppingTooltip2:HookScript("OnTooltipCleared", RhadaTip_St2OnTooltipCleared)
	ShoppingTooltip3:HookScript("OnTooltipSetItem", RhadaTip_OnTooltipSetItem)
--	ShoppingTooltip3:HookScript("OnTooltipCleared", RhadaTip_St3OnTooltipCleared)
	
--	GameTooltip:HookScript("OnShow", RhadaTip_OnTooltipSetItem)
end

function RhadaTip:ADDON_LOADED(...)
--This event fires whenever an AddOn has finished loading and the SavedVariables for that AddOn have been loaded from their file.
--	RhadaTip:debug_out("got to event handler ADDON_LOADED")
	-- check if this is our event. without this check, the following would be called from every mod
	
	-- if the addon loaded is this addon
	if(... == "RhadaTip" ) then
		RhadaTip:debug_out("RhadaTip Loaded")
		RhadaTip:debug_out("Loading Item Tree")
		RhadaTip_class.setup_item_tree()
		-- check if the global variable SOME_CASTING_TIME is nil
		if SOME_CASTING_TIME == nil then
			DEFAULT_CHAT_FRAME:AddMessage("No spell casting time has been set yet, setting it to 9999", 1.0, 0.0, 0.0, 53, 5);
			-- this should ensure that the trinket dps gain from the proc part is zero or close to it
			SOME_CASTING_TIME = 9999
		end
		-- check if the global variable SHOW_HELP_TOOLTIPS is nil
		if SHOW_HELP_TOOLTIPS == nil then
			-- set it to YES to enable the help tooltips until the user explicitly turns them off
			SHOW_HELP_TOOLTIPS = "YES"
		end
		-- check if the global variable DPS_ENCHANTS is nil
		if DPS_ENCHANTS == nil then
			-- set it to NO to enable the help tooltips untill the user explicitly changes it
			DPS_ENCHANTS = false
		end
		-- check if an user has ever stored some scaling values
		RhadaTip:init_scales()
	end 
end

--This event fires shortly before the PLAYER_LOGIN event and signals that information on the user's spells has been loaded and is available to the UI.
function RhadaTip:SPELLS_CHANGED(self,...)
--	RhadaTip:debug_out("got to event handler SPELLS_CHANGED")
end

--This event fires immediately before PLAYER_ENTERING_WORLD.
--Most information about the game world should now be available to the UI.
--All Sizing and Positioning of frames is supposed to be completed before this event fires.
--one-time initialization procedures once the player has "entered the world" should use this event instead of PLAYER_ENTERING_WORLD.
function RhadaTip:PLAYER_LOGIN(self,...)
	-- if the player logged in...
--	RhadaTip:debug_out("got to event handler PLAYER_LOGIN")
	local playerClass, englishClass = UnitClass("player");
	-- initialize the list of specs and the list of tiers for the englishClass (used on "PLAYER_ALIVE" to check for a compatible spec template)
	RhadaTip_SetSpecList(englishClass)
--	RhadaTip:ComputeAllGear()
--	rhada_load_gems();
		-- load the support for GameTooltip, ItemRefTooltip and ShoppingTooltips1,2,3
	RhadaTip:MAINLOAD(self);
	-- register this mod on the following four events
	RhadaTip:EC();
	-- load the support for AtlasLoot, if available
	RhadaTip:Al();
	-- load the support for WoWEquip, if available. This is disabled for now as WE is broken and abandoned
	--RhadaTip_WE();
	RhadaTip:debug_out("Loading Item Tree - PLAYER_LOGIN")
	RhadaTip_class.setup_item_tree()

	UIDropDownMenu_SetWidth(Rhada_config_panel_options_DropDown1, 242);
	UIDropDownMenu_JustifyText(Rhada_config_panel_options_DropDown1, "LEFT")
	UIDropDownMenu_Initialize(Rhada_config_panel_options_DropDown1, Rhada_DropDown1_init);

	UIDropDownMenu_SetWidth(Rhada_config_panel_options_DropDown2, 242);
	UIDropDownMenu_JustifyText(Rhada_config_panel_options_DropDown2, "LEFT")
	UIDropDownMenu_Initialize(Rhada_config_panel_options_DropDown2, Rhada_DropDown2_init);

	UIDropDownMenu_SetWidth(Rhada_config_panel_options_DropDown3, 242);
	UIDropDownMenu_JustifyText(Rhada_config_panel_options_DropDown3, "LEFT")
	UIDropDownMenu_Initialize(Rhada_config_panel_options_DropDown3, Rhada_DropDown3_init);

	UIDropDownMenu_SetWidth(Rhada_config_panel_options_DropDown4, 242);
	UIDropDownMenu_JustifyText(Rhada_config_panel_options_DropDown4, "LEFT")
	UIDropDownMenu_Initialize(Rhada_config_panel_options_DropDown4, Rhada_DropDown4_init);
	
	DEFAULT_CHAT_FRAME:AddMessage("RhadaTip " .. RhadaTipVersion .. ": addon loaded. Type "  .. SLASH_RhadaTip2 ..  " for the list of supported slash commands.", 1.0, 0.0, 0.95, 50, 5);

end

--This event fires immediately after PLAYER_LOGIN
--Most information about the game world should now be available to the UI. If this is an interface reload rather than a fresh log in, talent information should also be available.
--All Sizing and Positioning of frames is supposed to be completed before this event fires.
--This event also fires whenever the player enters/leaves an instance and generally whenever the player sees a loading screen
function RhadaTip:PLAYER_ENTERING_WORLD(self,...)
--	RhadaTip:debug_out("got to event handler PLAYER_ENTERING_WORLD")
	-- no need to flush the single item cache here

end

--This event fires after PLAYER_ENTERING_WORLD
--Quest and Talent information should now be available to the UI
function RhadaTip:PLAYER_ALIVE(self,...)
--	RhadaTip:debug_out("got to event handler PLAYER_ALIVE")
	-- do this auto selection of a pre set scaling value only if the user still has a nil or 0 value on both spellpower and attackpower. if the user has both those untouched it likely means
	-- that they have never entered any scaling values, so try to set them with the closest ones possible
	RhadaTip:SetTemplateSVOnLoad(true)
	RhadaTip_class.get_hit_conv()
	RhadaTip:ComputeAllGear();
	rhada_load_gems();
end

--this varible is used to prevent excesive recalculating of gear values during gearset swaps.
RhadaTip.throttle_timer = time()

function RhadaTip:PLAYER_EQUIPMENT_CHANGED(self,...)
--	RhadaTip:debug_out("got to event handler PLAYER_EQUIPMENT_CHANGED")
	if RhadaTip.throttle_timer == 0 then
		RhadaTip.throttle_timer = time()
	end
--	RhadaTip:debug_out(RhadaTip.throttle_timer)
	
	if time() - RhadaTip.throttle_timer ~= 0 then
		-- no need to flush the single item cache here
		RhadaTip:ComputeAllGear()
		RhadaTip:ClearTTcache()
	else
		RhadaTip.totalGearDps_calc_error = true
--		RhadaTip:debug_out("throttled")
	end
	RhadaTip.throttle_timer = time()
end

function RhadaTip:ACTIVE_TALENT_GROUP_CHANGED(self,...)
--	RhadaTip:debug_out("got to event handler ACTIVE_TALENT_GROUP_CHANGED")
		-- first flush the item value cache with RhadaTip:ClearItemCacheTable(), and then recompute everything with non cached items
	RhadaTip:ClearItemCacheTable()
	RhadaTip:ClearTTcache()
	local activeTalentGroup = GetActiveTalentGroup(false, false)
	-- refresh the scaling values
	-- refresh the hit, casting time and gems
	RhadaTip_class.get_hit_conv()
	RhadaTip:RefreshHitCap(activeTalentGroup);
	-- since we have just changed specs, we need to redetect the best profile
	if DEFAULT_PROFILE_VALUES ~= nil then
		DEFAULT_PROFILE_VALUES = rhada_PV_spec_finder()
	end
	-- after having loaded the appropriate spec scaling values, fire RhadaTip:SetTemplateSVOnLoad(), if they were null, it will load a preset value, otherwise it wont do anything
	RhadaTip:SetTemplateSVOnLoad(false)
	RhadaTip:config_panel_load_values()
	-- update the gear value
	RhadaTip:ComputeAllGear()
end

function RhadaTip:SOCKET_INFO_UPDATE(self,...)
	-- if the player has socketed a gem, clear the item cache, recompute the total gear value and check if a HPS<->DPS swap is necessary
--	RhadaTip:debug_out("got to event handler SOCKET_INFO_UPDATE")
	-- as of 2.1.6, first flush the item value cache with RhadaTip:ClearItemCacheTable(), and then recompute everything with non cached items (might not be needed due to a different item link)
	RhadaTip:ClearItemCacheTable()
	RhadaTip:ClearTTcache()
	RhadaTip:ComputeAllGear()
end

function RhadaTip:SPELL_UPDATE_COOLDOWN(self,...)
--	RhadaTip:debug_out("got to event handler SPELL_UPDATE_COOLDOWN")
end

function RhadaTip:FORGE_MASTER_ITEM_CHANGED(self,p1,p2,p3,p4,...)
--	RhadaTip:debug_out("got to event handler FORGE_MASTER_ITEM_CHANGED")
	RhadaTip:ClearItemCacheTable()
	RhadaTip:ClearTTcache()
end

function RhadaTip:FORGE_MASTER_SET_ITEM(self,p1,p2,p3,p4,...)
--	RhadaTip:debug_out("got to event handler FORGE_MASTER_ITEM_CHANGED")
end

function RhadaTip:ZONE_CHANGED_NEW_AREA()
	if not (IsAddOnLoaded("AtlasLoot")) then return end
--	RhadaTip_GetInstanceBossList()
--	RhadaTip:debug_out("got to event handler ZONE_CHANGED_NEW_AREA")
end
