local tinsert = tinsert
local ipairs = ipairs
local tonumber = tonumber
local mod = mod

-- a list of all the preset scaling values spec (cannot be local, is called by RhadaTip:SetTemplateSVOnLoad() in RhadaTip.lua)
RhadaTip_PVSPECList = {}

function RhadaTip_SetSpecList(class)
	if class == "DEATHKNIGHT" then
		RhadaTip_PVSPECList["Death_Knight_Unholy_1h_T11_372"] = {["class"] = "DEATHKNIGHT", ["spec"] = "3", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Death_Knight_Unholy_2h_T11_372"] = {["class"] = "DEATHKNIGHT", ["spec"] = "3", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Death_Knight_Frost_1h_T11_372"] = {["class"] = "DEATHKNIGHT", ["spec"] = "2", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Death_Knight_Frost_2h_T11_372"] = {["class"] = "DEATHKNIGHT", ["spec"] = "2", ["ilvl"] = "372"}
	
	elseif class == "WARLOCK" then
		RhadaTip_PVSPECList["Warlock_AffDrain_PreRaid"] = {["class"] = "WARLOCK", ["spec"] = "1", ["ilvl"] = "346"}
		RhadaTip_PVSPECList["Warlock_Affliction_PreRaid"] = {["class"] = "WARLOCK", ["spec"] = "1", ["ilvl"] = "346"}
		RhadaTip_PVSPECList["Warlock_Demonology_PreRaid"] = {["class"] = "WARLOCK", ["spec"] = "2", ["ilvl"] = "346"}
		RhadaTip_PVSPECList["Warlock_Destruction_PreRaid"] = {["class"] = "WARLOCK", ["spec"] = "3", ["ilvl"] = "346"}
		RhadaTip_PVSPECList["Warlock_AffDrain_T11_359"] = {["class"] = "WARLOCK", ["spec"] = "1", ["ilvl"] = "359"}
		RhadaTip_PVSPECList["Warlock_Affliction_T11_359"] = {["class"] = "WARLOCK", ["spec"] = "1", ["ilvl"] = "359"}
		RhadaTip_PVSPECList["Warlock_Demonology_T11_359"] = {["class"] = "WARLOCK", ["spec"] = "2", ["ilvl"] = "359"}
		RhadaTip_PVSPECList["Warlock_Destruction_T11_359"] = {["class"] = "WARLOCK", ["spec"] = "3", ["ilvl"] = "359"}
		RhadaTip_PVSPECList["Warlock_AffDrain_T11_372"] = {["class"] = "WARLOCK", ["spec"] = "1", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Warlock_Affliction_T11_372"] = {["class"] = "WARLOCK", ["spec"] = "1", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Warlock_Demonology_T11_372"] = {["class"] = "WARLOCK", ["spec"] = "2", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Warlock_Destruction_T11_372"] = {["class"] = "WARLOCK", ["spec"] = "3", ["ilvl"] = "372"}
	
	elseif class == "DRUID" then
		RhadaTip_PVSPECList["Druid_Feral_T11"] = {["class"] = "DRUID", ["spec"] = "2", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Druid_Balance_T11"] = {["class"] = "DRUID", ["spec"] = "1", ["ilvl"] = "372"}
		
	elseif class == "HUNTER" then
		RhadaTip_PVSPECList["Hunter_T11_MM_372"] = {["class"] = "HUNTER", ["spec"] = "2", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Hunter_T11_S_372"] = {["class"] = "HUNTER", ["spec"] = "3", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Hunter_T11_BM_372"] = {["class"] = "HUNTER", ["spec"] = "1", ["ilvl"] = "372"}
		
	elseif class == "MAGE" then
		RhadaTip_PVSPECList["Mage_Arcane_PreRaid"] = {["class"] = "MAGE", ["spec"] = "1", ["ilvl"] = "346"}
		RhadaTip_PVSPECList["Mage_Fire_PreRaid"] = {["class"] = "MAGE", ["spec"] = "2", ["ilvl"] = "346"}
		RhadaTip_PVSPECList["Mage_Frost_PreRaid"] = {["class"] = "MAGE", ["spec"] = "3", ["ilvl"] = "346"}
		RhadaTip_PVSPECList["Mage_Fire_Frostfire_PreRaid"] = {["class"] = "MAGE", ["spec"] = "2", ["ilvl"] = "346"}
		RhadaTip_PVSPECList["Mage_Frost_Frostfire_PreRaid"] = {["class"] = "MAGE", ["spec"] = "3", ["ilvl"] = "346"}
		
		RhadaTip_PVSPECList["Mage_Arcane_T11_359"] = {["class"] = "MAGE", ["spec"] = "1", ["ilvl"] = "359"}
		RhadaTip_PVSPECList["Mage_Fire_T11_359"] = {["class"] = "MAGE", ["spec"] = "2", ["ilvl"] = "359"}
		RhadaTip_PVSPECList["Mage_Frost_T11_359"] = {["class"] = "MAGE", ["spec"] = "3", ["ilvl"] = "359"}
		RhadaTip_PVSPECList["Mage_Fire_Frostfire_T11_359"] = {["class"] = "MAGE", ["spec"] = "2", ["ilvl"] = "359"}
		RhadaTip_PVSPECList["Mage_Frost_Frostfire_T11_359"] = {["class"] = "MAGE", ["spec"] = "3", ["ilvl"] = "359"}
		
		RhadaTip_PVSPECList["Mage_Arcane_T11_372"] = {["class"] = "MAGE", ["spec"] = "1", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Mage_Fire_T11_372"] = {["class"] = "MAGE", ["spec"] = "2", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Mage_Frost_T11_372"] = {["class"] = "MAGE", ["spec"] = "3", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Mage_Fire_Frostfire_T11_372"] = {["class"] = "MAGE", ["spec"] = "3", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Mage_Frost_Frostfire_T11_372"] = {["class"] = "MAGE", ["spec"] = "3", ["ilvl"] = "372"}
	
	elseif class == "PRIEST" then
		RhadaTip_PVSPECList["Priest_Heal_Discipline_T11_372"] = {["class"] = "PRIEST", ["spec"] = "1", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Priest_Shadow_PreRaid"] = {["class"] = "PRIEST", ["spec"] = "3", ["ilvl"] = "346"}
		RhadaTip_PVSPECList["Priest_Shadow_T11_359"] = {["class"] = "PRIEST", ["spec"] = "3", ["ilvl"] = "359"}
		RhadaTip_PVSPECList["Priest_Shadow_T11_372"] = {["class"] = "PRIEST", ["spec"] = "3", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Priest_Disc_AE_T11_372"] = {["class"] = "PRIEST", ["spec"] = "1", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Priest_Disc_PWS_T11_372"] = {["class"] = "PRIEST", ["spec"] = "1", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Priest_Disc_Single_T11_372"] = {["class"] = "PRIEST", ["spec"] = "1", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Priest_Holy_Single_T11_372"] = {["class"] = "PRIEST", ["spec"] = "2", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Priest_Holy_AE_T11_372"] = {["class"] = "PRIEST", ["spec"] = "2", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Priest_Holy_Mixed_T11_372"] = {["class"] = "PRIEST", ["spec"] = "2", ["ilvl"] = "372"}
	
	elseif class == "SHAMAN" then
		RhadaTip_PVSPECList["Shaman_Elemental_T11_372"] = {["class"] = "SHAMAN", ["spec"] = "1", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Shaman_Enhancement_T11_372_FTFT"] = {["class"] = "SHAMAN", ["spec"] = "2", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Shaman_Enhancement_T11_372_WFFT"] = {["class"] = "SHAMAN", ["spec"] = "2", ["ilvl"] = "372"}
	
	elseif class == "WARRIOR" then
		RhadaTip_PVSPECList["Warrior_401_Arms"] = {["class"] = "WARRIOR", ["spec"] = "1", ["ilvl"] = "277"}
		RhadaTip_PVSPECList["Warrior_Arms_T11_372"] = {["class"] = "WARRIOR", ["spec"] = "1", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Warrior_Fury_1h_T11_372"] = {["class"] = "WARRIOR", ["spec"] = "2", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Warrior_Fury_2h_T11_372"] = {["class"] = "WARRIOR", ["spec"] = "2", ["ilvl"] = "372"}
	
	elseif class == "PALADIN" then
		RhadaTip_PVSPECList["Paladin_Retribution_T11_359"] = {["class"] = "PALADIN", ["spec"] = "3", ["ilvl"] = "359"}
		RhadaTip_PVSPECList["Paladin_Retribution_T11_372"] = {["class"] = "PALADIN", ["spec"] = "3", ["ilvl"] = "372"}
	
	elseif class == "ROGUE" then
		RhadaTip_PVSPECList["Rogue_Assassination_T11_372"] = {["class"] = "ROGUE", ["spec"] = "1", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Rogue_Combat_T11"] = {["class"] = "ROGUE", ["spec"] = "2", ["ilvl"] = "372"}
		RhadaTip_PVSPECList["Rogue_Subtlety_T11"] = {["class"] = "ROGUE", ["spec"] = "3", ["ilvl"] = "372"}
	end
end

function RhadaTip_LoadPV()
	-- horizontal offset
	local offset = 0
	local i = 1
	for k,v in pairs(RhadaTip_PVSPECList) do
		local PV_string = k
		local PV_spec = v["spec"]
		local PV_gear = v["ilvl"]

		local f = CreateFrame("BUTTON", "FRAME" .. k, Rhada_config_panel_pv, "UIPanelButtonTemplate")
		f:SetWidth(220)
		f:SetHeight(30)
		if tonumber(i) > 9 and tonumber(i) < 18 then 
			offset = 220
		elseif tonumber(i) > 18 then 
			offset = 440
		end
		local off 
		if mod(i,10) == 0 and tonumber(i)<10 then
			off = (mod(i,10))
		else 
			off = (mod(i,10)-1)
		end
		if tonumber(i)>=10 and tonumber(i)<19 then
			off = (mod(i,10))
		end
		if tonumber(i)>=19 then
			off = (i-19)
		end
		f:SetPoint("CENTER",-170+(offset),110-(off*30))
		f:SetScript("OnClick", RhadaTip_PresetScalingValues)
		f:SetText(PV_string)
		i=i+1
	end
end

-- this function saves the scaling values passed to it as input to the proper global variables, depending on your currently active talent tree

local function RhadaTip_SetPresetScalingValues(sta, int, spi, spell, hit, crit, haste, str, agi, atp, mst, exp, mh, oh, tPT10, fPT10, tPT11, fPT11)
	local spec = GetActiveTalentGroup(false, false)
		RhadaTip_Scales[spec]["ITEM_MOD_STAMINA_SHORT"]=sta
		RhadaTip_Scales[spec]["ITEM_MOD_INTELLECT_SHORT"]=int
		RhadaTip_Scales[spec]["ITEM_MOD_SPIRIT_SHORT"]=spi
		RhadaTip_Scales[spec]["ITEM_MOD_SPELL_POWER_SHORT"]=spell
		RhadaTip_Scales[spec]["ITEM_MOD_HIT_RATING_SHORT"]=hit
		RhadaTip_Scales[spec]["ITEM_MOD_CRIT_RATING_SHORT"]=crit
		RhadaTip_Scales[spec]["ITEM_MOD_HASTE_RATING_SHORT"]=haste
		RhadaTip_Scales[spec]["ITEM_MOD_STRENGTH_SHORT"]=str
		RhadaTip_Scales[spec]["ITEM_MOD_AGILITY_SHORT"]=agi
		RhadaTip_Scales[spec]["ITEM_MOD_ATTACK_POWER_SHORT"]=atp
		RhadaTip_Scales[spec]["ITEM_MOD_MASTERY_RATING_SHORT"]=mst
		RhadaTip_Scales[spec]["ITEM_MOD_EXPERTISE_RATING_SHORT"]=exp
		RhadaTip_Scales[spec]["mainhand"] = mh
		RhadaTip_Scales[spec]["offhand"] = oh
		RhadaTip_Scales[spec]["tPT10_SCALE"]=tPT10
		RhadaTip_Scales[spec]["fPT10_SCALE"]=fPT10
		RhadaTip_Scales[spec]["tPT11_SCALE"]=tPT11
		RhadaTip_Scales[spec]["fPT11_SCALE"]=fPT11
end

-- this function captures which button the user has pressed, and calls RhadaTip_SetPresetScalingValues to actually set the global variables of 
-- each stat's scaling value to some preset value
function RhadaTip_PresetScalingValues(self)
--	RhadaTip_PresetScalingValuesNoButton(self:GetText())
	RhadaTip_Select_SV(self:GetText())
	DEFAULT_PROFILE_VALUES = nil
end


function rhada_PV_spec_finder()
	local k,v = 0,0
	local player_spec = RhadaTip_class.get_spec()
	local player_gear_lvl = rhada_gear_lvl()
	for k,v in pairs(RhadaTip_PVSPECList) do
		local PV_string = k
		local PV_spec = v["spec"]
		local PV_gear = v["ilvl"]
		
		if tonumber(PV_spec) == tonumber(player_spec) then
--			out("Found matching spec", 1.0, 0.0, 0.95, 50, 5);
			if tonumber(PV_gear) > tonumber(player_gear_lvl) then
--				out("Found matching Profile!", 1.0, 0.0, 0.95, 50, 5);
				return PV_string
			end
		end
	end
	return ""
end

-- this function stores the pre set scaling values into the global variables scaling values. it takes the template of interest as its input. it is called when the user clicks a button in RhadaTip14, but also
-- from RhadaTip.lua when the user logs with no scales set and a matching spec, therefore it cant be local
function RhadaTip_Select_SV(PV_string)
	local activeTalentGroup = GetActiveTalentGroup(false, false)
--	RhadaTip:debug_out(PV_string)
	if RhadaTip_ScalingValues[PV_string] == nil then return end
	RhadaTip_SetPresetScalingValues(
	RhadaTip_ScalingValues[PV_string]["sta"] or 0,
	RhadaTip_ScalingValues[PV_string]["int"] or 0,
	RhadaTip_ScalingValues[PV_string]["spi"] or 0,
	RhadaTip_ScalingValues[PV_string]["sp"] or 0,
	RhadaTip_ScalingValues[PV_string]["hit"] or 0,
	RhadaTip_ScalingValues[PV_string]["crt"] or 0,
	RhadaTip_ScalingValues[PV_string]["hst"] or 0,
	RhadaTip_ScalingValues[PV_string]["str"] or 0,
	RhadaTip_ScalingValues[PV_string]["agi"] or 0,
	RhadaTip_ScalingValues[PV_string]["atp"] or 0,
	RhadaTip_ScalingValues[PV_string]["mst"] or 0,
	RhadaTip_ScalingValues[PV_string]["exp"] or 0,
	RhadaTip_ScalingValues[PV_string]["mh"] or 0,
	RhadaTip_ScalingValues[PV_string]["oh"] or 0,
	RhadaTip_ScalingValues[PV_string]["tPT10"] or 0,
	RhadaTip_ScalingValues[PV_string]["fPT10"] or 0,
	RhadaTip_ScalingValues[PV_string]["tPT11"] or 0,
	RhadaTip_ScalingValues[PV_string]["fPT11"] or 0)
	-- refresh the general, non active talent group specific, variables	
	-- as of 2.1.6, first flush the item value cache with RhadaTip:ClearItemCacheTable(), and then recompute everything with non cached items
	RhadaTip:ClearItemCacheTable()
	-- after a change, recompute the dps gain from the currently equipped gear
	RhadaTip:config_panel_load_values()
	RhadaTip:ComputeAllGear()
end

RhadaTip_ScalingValues = {}
--updated 2011-01-25
RhadaTip_ScalingValues["Hunter_T11_BM_372"] = {				["agi"] = 2.5973,["atp"] = 0.9539,["hit"] = 2.4757,["crt"] = 0.7652,["hst"] = 0.9081,["mst"] = 0.5966,["mh"] = 4.8561,["oh"] = 0.0000,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Hunter_T11_MM_372"] = {				["agi"] = 2.7687,["atp"] = 0.9814,["hit"] = 2.2135,["crt"] = 1.1140,["hst"] = 0.8465,["mst"] = 1.0281,["mh"] = 7.3827,["oh"] = 0.0000,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Hunter_T11_S_372"] = {				["agi"] = 3.4571,["atp"] = 1.0100,["hit"] = 2.4092,["crt"] = 1.0868,["hst"] = 1.1357,["mst"] = 0.9368,["mh"] = 5.3447,["oh"] = 0.0000,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}

--updated 2011-01-25
RhadaTip_ScalingValues["Druid_Balance_T11"] = {				["int"] = 3.3256,["spi"] = 2.1761,["sp"]  = 2.5293,["hit"] = 2.1715,["crt"] = 0.8744,["hst"] = 1.8987,["mst"] = 0.9894,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Druid_Feral_T11"] = {				["hit"] = 0.8112,["crt"] = 1.0394,["hst"] = 0.8333,["str"] = 2.1774,["agi"] = 2.7759,["atp"] = 1.0513,["mst"] = 1.3695,["exp"] = 0.8739,["mh"] = 4.3035,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}

--updated 2011-01-25
RhadaTip_ScalingValues["Rogue_Assassination_T11_372"] = {	["str"] = 1.2268,["agi"] = 3.0631,["atp"] = 1.1708,["exp"] = 1.4600,["hit"] = 1.9269,["crt"] = 1.0167,["hst"] = 1.3652,["mst"] = 1.4866,["mh"] = 4.1198,["oh"] = 1.2531,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Rogue_Combat_T11"] = {				["str"] = 1.2252,["agi"] = 3.1218,["atp"] = 1.1554,["exp"] = 1.8299,["hit"] = 1.6082,["crt"] = 1.0405,["hst"] = 1.2179,["mst"] = 0.9084,["mh"] = 5.0629,["oh"] = 2.4655,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Rogue_Subtlety_T11"] = {			["str"] = 0.8863,["agi"] = 3.0631,["atp"] = 0.8154,["exp"] = 1.1918,["hit"] = 1.1280,["crt"] = 1.0274,["hst"] = 1.3097,["mst"] = 0.5073,["mh"] = 6.5216,["oh"] = 1.0117,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}

RhadaTip_ScalingValues["Priest_Heal_Discipline_T11_372"] = {["int"] = 1.5589,["spi"] = 0.5508,["sp"]  = 0.7705,["hit"] = 0.0000,["crt"] = 0.5190,["hst"] = 0.0000,["mst"] = 0.3002,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
--updated 2011-01-25
RhadaTip_ScalingValues["Priest_Shadow_PreRaid"] = {			["int"] = 2.8889,["spi"] = 1.1127,["sp"]  = 2.1380,["hit"] = 1.0526,["crt"] = 1.1590,["hst"] = 0.2963,["mst"] = 0.9444,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 438.00,["fPT11"] = 689.00}
RhadaTip_ScalingValues["Priest_Shadow_T11_359"] = {			["int"] = 2.8037,["spi"] = 1.0116,["sp"]  = 2.2315,["hit"] = 1.0336,["crt"] = 1.1694,["hst"] = 1.3611,["mst"] = 0.1670,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 438.00,["fPT11"] = 689.00}
RhadaTip_ScalingValues["Priest_Shadow_T11_372"] = {			["int"] = 1.9101,["spi"] = 2.0857,["sp"]  = 2.3399,["hit"] = 1.1472,["crt"] = 1.2593,["hst"] = 1.5763,["mst"] = 0.0959,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 438.00,["fPT11"] = 689.00}
--updated 2011-01-27
RhadaTip_ScalingValues["Priest_Disc_AE_T11_372"] = {		["int"] = 4.3558,["spi"] = 2.0072,["sp"]  = 1.2963,["hit"] = 0.2346,["crt"] = 0.7072,["hst"] = 0.4947,["mst"] = 0.6764,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 438.00,["fPT11"] = 689.00}
RhadaTip_ScalingValues["Priest_Disc_PWS_T11_372"] = {		["int"] = 1.4716,["spi"] = 0.7572,["sp"]  = 0.6214,["hit"] = 0.0000,["crt"] = 0.3205,["hst"] = 0.1905,["mst"] = 0.8707,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 438.00,["fPT11"] = 689.00}
RhadaTip_ScalingValues["Priest_Disc_Single_T11_372"] = {	["int"] = 2.5802,["spi"] = 1.1351,["sp"]  = 0.7472,["hit"] = 0.0333,["crt"] = 0.5843,["hst"] = 0.1549,["mst"] = 0.3610,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 438.00,["fPT11"] = 689.00}
RhadaTip_ScalingValues["Priest_Holy_AE_T11_372"] = {		["int"] = 2.7154,["spi"] = 1.8181,["sp"]  = 1.3142,["hit"] = 0.0398,["crt"] = 0.6937,["hst"] = 0.4793,["mst"] = 0.9038,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 438.00,["fPT11"] = 689.00}
RhadaTip_ScalingValues["Priest_Holy_Mixed_T11_372"] = {		["int"] = 2.6414,["spi"] = 1.6252,["sp"]  = 0.9592,["hit"] = 0.0279,["crt"] = 0.4599,["hst"] = 0.0000,["mst"] = 0.5660,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 438.00,["fPT11"] = 689.00}
RhadaTip_ScalingValues["Priest_Holy_Single_T11_372"] = {	["int"] = 1.4521,["spi"] = 0.9098,["sp"]  = 0.5536,["hit"] = 0.0128,["crt"] = 0.2548,["hst"] = 0.0972,["mst"] = 0.4852,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 438.00,["fPT11"] = 689.00}


--updated 2011-01-25
RhadaTip_ScalingValues["Mage_Arcane_PreRaid"] = {			["int"] = 2.9752,["sp"]  = 1.9021,["hit"] = 1.8535,["crt"] = 0.7316,["hst"] = 1.1044,["mst"] = 0.9818,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Mage_Arcane_T11_359"] = {			["int"] = 3.6126,["sp"]  = 1.9875,["hit"] = 2.2429,["crt"] = 0.9076,["hst"] = 0.7823,["mst"] = 0.9402,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Mage_Arcane_T11_372"] = {			["int"] = 3.8845,["sp"]  = 2.3225,["hit"] = 2.6410,["crt"] = 1.0407,["hst"] = 1.2129,["mst"] = 1.3539,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Mage_Fire_Frostfire_PreRaid"] = {	["int"] = 2.7766,["sp"]  = 2.0282,["hit"] = 1.9409,["crt"] = 1.2484,["hst"] = 2.3581,["mst"] = 0.8653,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Mage_Fire_Frostfire_T11_359"] = {	["int"] = 3.3878,["sp"]  = 2.1765,["hit"] = 2.3603,["crt"] = 1.7397,["hst"] = 1.0237,["mst"] = 1.0982,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Mage_Fire_Frostfire_T11_372"] = {	["int"] = 3.6054,["sp"]  = 2.3375,["hit"] = 2.6402,["crt"] = 1.7978,["hst"] = 1.1454,["mst"] = 1.2611,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Mage_Fire_PreRaid"] = {				["int"] = 2.8728,["sp"]  = 2.0152,["hit"] = 2.0728,["crt"] = 1.3027,["hst"] = 2.2616,["mst"] = 0.8938,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Mage_Fire_T11_359"] = {				["int"] = 3.1754,["sp"]  = 2.1884,["hit"] = 2.5457,["crt"] = 1.5340,["hst"] = 1.0563,["mst"] = 0.9330,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Mage_Fire_T11_372"] = {				["int"] = 3.6294,["sp"]  = 2.3346,["hit"] = 2.8680,["crt"] = 1.9286,["hst"] = 1.2162,["mst"] = 1.2076,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Mage_Frost_Frostfire_PreRaid"] = {	["int"] = 2.7658,["sp"]  = 2.1472,["hit"] = 1.9588,["crt"] = 1.2610,["hst"] = 1.0519,["mst"] = 0.7537,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Mage_Frost_Frostfire_T11_359"] = {	["int"] = 3.1502,["sp"]  = 2.3280,["hit"] = 2.4248,["crt"] = 1.6081,["hst"] = 0.6279,["mst"] = 0.8029,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Mage_Frost_Frostfire_T11_372"] = {	["int"] = 3.2472,["sp"]  = 2.4545,["hit"] = 2.5736,["crt"] = 1.4467,["hst"] = 1.0740,["mst"] = 0.9907,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Mage_Frost_PreRaid"] = {			["int"] = 2.8409,["sp"]  = 2.1800,["hit"] = 2.0361,["crt"] = 1.2647,["hst"] = 1.1312,["mst"] = 0.9072,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Mage_Frost_T11_359"] = {			["int"] = 3.2092,["sp"]  = 2.3769,["hit"] = 2.5024,["crt"] = 1.5529,["hst"] = 0.6940,["mst"] = 1.0528,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Mage_Frost_T11_372"] = {			["int"] = 3.1608,["sp"]  = 2.5036,["hit"] = 2.7036,["crt"] = 1.1418,["hst"] = 0.8170,["mst"] = 1.2328,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}

--updated 2011-01-25
RhadaTip_ScalingValues["Warlock_AffDrain_PreRaid"] = {		["sta"] = 0.0037,["int"] = 3.0647,["sp"]  = 2.4168,["hit"] = 1.6814,["crt"] = 1.0023,["hst"] = 1.2905,["mst"] = 1.0837,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Warlock_Affliction_PreRaid"] = {	["sta"] = 0.0000,["int"] = 2.9443,["sp"]  = 2.4943,["hit"] = 1.5408,["crt"] = 1.0151,["hst"] = 1.3939,["mst"] = 0.9586,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Warlock_Demonology_PreRaid"] = {	["sta"] = 0.0282,["int"] = 2.6231,["sp"]  = 2.1290,["hit"] = 1.6339,["crt"] = 0.8864,["hst"] = 1.1495,["mst"] = 0.9610,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Warlock_Destruction_PreRaid"] = {	["sta"] = 0.0954,["int"] = 2.8478,["sp"]  = 2.2178,["hit"] = 1.8694,["crt"] = 0.9567,["hst"] = 1.1641,["mst"] = 0.8124,["tPT10"] = 200.00,["fPT10"] = 738.00,["tPT11"] = 0.0000,["fPT11"] = 0.0000}

--updated 2011-02-11
RhadaTip_ScalingValues["Warlock_AffDrain_T11_359"] = {		["sta"] = 0.0101,["int"] = 3.0988,["sp"]  = 2.4223,["hit"] = 1.7779,["crt"] = 1.1500,["hst"] = 1.1898,["mst"] = 1.0087,["tPT10"] = 200.00,["fPT10"] = 738.00,["tPT11"] = 40.000,["fPT11"] = 20.000}
RhadaTip_ScalingValues["Warlock_Affliction_T11_359"] = {	["sta"] = 0.0092,["int"] = 2.9892,["sp"]  = 2.3922,["hit"] = 1.7859,["crt"] = 1.0719,["hst"] = 1.2163,["mst"] = 0.7614,["tPT10"] = 200.00,["fPT10"] = 738.00,["tPT11"] = 40.000,["fPT11"] = 20.000}
RhadaTip_ScalingValues["Warlock_Demonology_T11_359"] = {	["sta"] = 0.0000,["int"] = 2.8297,["sp"]  = 2.2520,["hit"] = 2.0206,["crt"] = 1.1386,["hst"] = 1.0797,["mst"] = 1.2217,["tPT10"] = 200.00,["fPT10"] = 738.00,["tPT11"] = 40.000,["fPT11"] = 20.000}
RhadaTip_ScalingValues["Warlock_Destruction_T11_359"] = {	["sta"] = 0.0021,["int"] = 2.9713,["sp"]  = 2.2801,["hit"] = 2.1024,["crt"] = 1.1110,["hst"] = 1.2067,["mst"] = 0.9673,["tPT10"] = 200.00,["fPT10"] = 738.00,["tPT11"] = 40.000,["fPT11"] = 20.000}

--updated 2011-02-11
RhadaTip_ScalingValues["Warlock_AffDrain_T11_372"] = {		["sta"] = 0.0000,["int"] = 3.2198,["sp"]  = 2.5102,["hit"] = 2.0092,["crt"] = 1.2416,["hst"] = 1.4718,["mst"] = 1.1465,["tPT10"] = 200.00,["fPT10"] = 738.00,["tPT11"] = 40.000,["fPT11"] = 20.000}
RhadaTip_ScalingValues["Warlock_Affliction_T11_372"] = {	["sta"] = 0.0304,["int"] = 3.1519,["sp"]  = 2.5055,["hit"] = 1.9493,["crt"] = 1.2046,["hst"] = 1.5460,["mst"] = 0.9121,["tPT10"] = 200.00,["fPT10"] = 738.00,["tPT11"] = 40.000,["fPT11"] = 20.000}
RhadaTip_ScalingValues["Warlock_Demonology_T11_372"] = {	["sta"] = 0.0076,["int"] = 2.9328,["sp"]  = 2.2883,["hit"] = 2.2751,["crt"] = 1.1600,["hst"] = 1.0163,["mst"] = 1.3312,["tPT10"] = 200.00,["fPT10"] = 738.00,["tPT11"] = 40.000,["fPT11"] = 20.000}
RhadaTip_ScalingValues["Warlock_Destruction_T11_372"] = {	["sta"] = 0.0000,["int"] = 3.1146,["sp"]  = 2.4407,["hit"] = 2.4150,["crt"] = 1.1916,["hst"] = 1.3379,["mst"] = 1.1024,["tPT10"] = 200.00,["fPT10"] = 738.00,["tPT11"] = 40.000,["fPT11"] = 20.000}

--updated 2011-02-10
RhadaTip_ScalingValues["Death_Knight_Unholy_1h_T11_372"] = {["str"] = 2.9560,["agi"] = 0.3588,["atp"] = 0.8608,["exp"] = 0.8194,["hit"] = 1.5046,["crt"] = 0.8287,["hst"] = 1.1876,["mst"] = 1.0700,["mh"] = 3.3868,["oh"] = 0.7307,["tPT10"] = 230.00,["fPT10"] = 211.00,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Death_Knight_Unholy_2h_T11_372"] = {["str"] = 3.1923,["agi"] = 0.4842,["atp"] = 0.8928,["exp"] = 0.8222,["hit"] = 2.0258,["crt"] = 1.0192,["hst"] = 1.5901,["mst"] = 1.2008,["mh"] = 4.8266,["oh"] = 0.0000,["tPT10"] = 63.000,["fPT10"] = 244.00,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Death_Knight_Frost_1h_T11_372"] = {	["str"] = 2.6003,["agi"] = 0.5733,["atp"] = 0.8610,["exp"] = 1.7732,["hit"] = 2.1380,["crt"] = 0.9765,["hst"] = 0.9182,["mst"] = 0.9147,["mh"] = 5.3403,["oh"] = 3.6498,["tPT10"] = 260.00,["fPT10"] = 248.00,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Death_Knight_Frost_2h_T11_372"] = {	["str"] = 2.2657,["agi"] = 0.5393,["atp"] = 0.7315,["exp"] = 0.9092,["hit"] = 1.2305,["crt"] = 0.9098,["hst"] = 0.9698,["mst"] = 0.7934,["mh"] = 7.6183,["oh"] = 0.0000,["tPT10"] = 260.00,["fPT10"] = 248.00,["tPT11"] = 0.0000,["fPT11"] = 0.0000}

RhadaTip_ScalingValues["Paladin_Retribution_T11_359"] = {	["str"] = 2.1795,["agi"] = 0.6214,["atp"] = 0.9465,["exp"] = 1.2000,["hit"] = 1.8090,["crt"] = 0.8640,["hst"] = 0.9722,["mst"] = 0.5412,["mh"] = 9.8469,["oh"] = 0.0000,["tPT10"] = 496.00,["fPT10"] = 242.000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Paladin_Retribution_T11_372"] = {	["str"] = 2.2200,["agi"] = 0.8353,["atp"] = 0.9975,["exp"] = 1.4851,["hit"] = 1.6299,["crt"] = 0.9064,["hst"] = 0.9423,["mst"] = 0.5095,["mh"] = 9.8469,["oh"] = 0.0000,["tPT10"] = 496.00,["fPT10"] = 242.000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}

--updated 2011-01-25
RhadaTip_ScalingValues["Shaman_Elemental_T11_372"] = {		["int"] = 2.8320,["spi"] = 2.9726,["sp"]  = 2.2731,["hit"] = 2.9202,["crt"] = 0.9910,["hst"] = 1.3468,["mst"] = 1.1406,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Shaman_Enhancement_T11_372_FTFT"]= {["str"] = 1.1740,["agi"] = 2.6654,["int"] = 1.4275,["spi"] = 0.1108,["sp"]  = 1.2664,["atp"] = 1.1219,["exp"] = 0.7859,["hit"] = 1.8521,["crt"] = 0.7958,["hst"] = 0.9879,["mst"] = 2.0147,["mh"] = 1.5062,["oh"] = 2.8589,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Shaman_Enhancement_T11_372_WFFT"]= {["str"] = 1.1833,["agi"] = 2.7690,["int"] = 1.2367,["spi"] = 0.1108,["sp"]  = 1.0906,["atp"] = 1.1257,["exp"] = 1.1744,["hit"] = 1.6122,["crt"] = 0.7789,["hst"] = 0.8450,["mst"] = 1.5607,["mh"] = 2.8532,["oh"] = 2.8400,["tPT10"] = 0.0000,["fPT10"] = 0.0000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}

RhadaTip_ScalingValues["Warrior_401_Arms"] = {				["str"] = 2.1475,["agi"] = 1.0192,["atp"] = 0.9401,["exp"] = 1.4281,["hit"] = 5.5696,["crt"] = 1.3012,["hst"] = 1.7411,["mst"] = 1.8373,["mh"] = 8.4606,["oh"] = 0.0000,["tPT10"] = 496.00,["fPT10"] = 242.000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Warrior_Arms_T11_372"] = {			["str"] = 2.2426,["agi"] = 1.1992,["atp"] = 1.0684,["exp"] = 0.0000,["hit"] = 2.3469,["crt"] = 1.5686,["hst"] = 1.0804,["mst"] = 1.0880,["mh"] = 9.4411,["oh"] = 0.0000,["tPT10"] = 496.00,["fPT10"] = 242.000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Warrior_Fury_1h_T11_372"] = {		["str"] = 2.6762,["agi"] = 1.4577,["atp"] = 1.2613,["exp"] = 1.0505,["hit"] = 1.4008,["crt"] = 1.8898,["hst"] = 1.2678,["mst"] = 0.6159,["mh"] = 4.4648,["oh"] = 2.2201,["tPT10"] = 496.00,["fPT10"] = 242.000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
RhadaTip_ScalingValues["Warrior_Fury_2h_T11_372"] = {		["str"] = 2.3795,["agi"] = 1.4737,["atp"] = 1.0791,["exp"] = 1.5753,["hit"] = 1.6066,["crt"] = 1.5131,["hst"] = 1.2009,["mst"] = 0.9881,["mh"] = 4.8204,["oh"] = 1.8247,["tPT10"] = 496.00,["fPT10"] = 242.000,["tPT11"] = 0.0000,["fPT11"] = 0.0000}
