RhadaTip_class = {}
RhadaTip_class.hc_mod = {}
RhadaTip_class.rhada_item_index = {}
RhadaTip_class.conv_factor = {}
--these are our base factors for each stat at level 60. This factor is the first half of the denominator 
--in our combat rating formulas. Since the combats stats share the same basic formula, we simply pick
--which base factor we need to use.
-- Dodge, Parry, Block, Hit, Spell Hit, Crit, Resilience(Player Damage Taken), Haste, Expertise, Mastery
RhadaTip_class.base_factor = {13.8, 13.8, 6.9, 9.37931, 8, 14, 21.5625, 10, 2.34483, 14}
--RhadaTip_class_list = {Warlock=0, Priest=0 , Mage=0, Hunter=0, Warrior=0, Druid=0, Deathknight=0, Rogue=0, Shaman=0, Paladin=0)

function RhadaTip_class.get_hitcap(gear_spirit)
	local tal_hit_reduction = 0
	local item_hitcap = 0
	local hit_rating = 0
	local class_hit_cap = 0
	local spec, icon = RhadaTip_class.get_spec()

	if HIT_CAP == "0" or HIT_CAP == nil then
		local playerClass, englishClass = UnitClass("player");
		tal_hit_reduction = RhadaTip_class.hc_mod[englishClass](gear_spirit)
		if englishClass == "HUNTER" then
			class_hit_cap = "8"
		elseif englishClass == "WARLOCK" then
			class_hit_cap = "17"
		elseif englishClass == "ROGUE" then
			class_hit_cap = "27"
		elseif englishClass == "MAGE" then
			class_hit_cap = "17"
		elseif englishClass == "PRIEST" then
			if spec == 1 then
				class_hit_cap = "0"
			elseif spec == 2 then
				class_hit_cap = "0"
			elseif spec == 3 then
				class_hit_cap = "17"
			end
		elseif englishClass == "PALADIN" then
			if spec == 1 then
				class_hit_cap = "0"
			elseif spec == 2 then
				class_hit_cap = "8"
			elseif spec == 3 then
				class_hit_cap = "8"
			end
		elseif englishClass == "WARRIOR" then
			if spec == 1 then
				class_hit_cap = "8"
			elseif spec == 2 then
				class_hit_cap = "27"
			elseif spec == 3 then
				class_hit_cap = "8"
			end

		elseif englishClass == "DEATHKNIGHT" then
			local name, icon, column, rank, maxRank, isExceptional, meetsPrereq, previewRank, meetsPreviewPrereq = GetTalentInfo(2,18,false,false)
			if spec == 2 and rank~= nil then
				class_hit_cap = "27"
			elseif spec == 3 then
				class_hit_cap = "17"
			elseif spec == 1 then
				class_hit_cap = "8"
			end
		elseif englishClass == "DRUID" then
			if spec == 1 then
				class_hit_cap = "17"
			elseif spec == 2 then
				class_hit_cap = "8"
			elseif spec == 3 then
				class_hit_cap = "0"
			end
		elseif englishClass == "SHAMAN" then
			if spec == 1 then
				class_hit_cap = "17"
			elseif spec == 2 then
				class_hit_cap = "8"
			elseif spec == 3 then
				class_hit_cap = "0"
			end
		else
			class_hit_cap = "17"
		end
--						RhadaTip:debug_out("using built-in hit cap(" .. class_hit_cap .. ")")
	else
		class_hit_cap = (HIT_CAP or 0)
--						RhadaTip:debug_out("using custom hit cap(" .. HIT_CAP .. ")")
	end
	item_hitcap = (class_hit_cap*RhadaTip_class.get_hit_conv())
	if CASTER_OR_MELEE == 1 then
		hit_rating = GetCombatRatingBonus(CR_HIT_SPELL)*RhadaTip_class.get_hit_conv() + tal_hit_reduction
	else
		hit_rating = GetCombatRatingBonus(CR_HIT_MELEE)*RhadaTip_class.get_hit_conv() + tal_hit_reduction
	end
	return hit_rating, item_hitcap, tal_hit_reduction
end

function RhadaTip_class.get_expcap()
	local exp_rating, exp_cap, exp_base = 0,0,6
	local playerClass, englishClass = UnitClass("player");
	local spec, icon = RhadaTip_class.get_spec()

	if tonumber(EXPERTISE_CAP or 0) > 0  then
		exp_cap = EXPERTISE_CAP
	elseif englishClass == "DEATHKNIGHT" then
		if spec == 1 or spec == 2 then
			exp_cap = RhadaTip_class.get_exp_conv() * 20
		end
	elseif englishClass == "ROGUE" or englishClass == "WARRIOR" then
		exp_cap = RhadaTip_class.get_exp_conv() * 26
	elseif englishClass == "SHAMAN" then
		if spec == 2 then
			exp_cap = RhadaTip_class.get_exp_conv() * 26
		end
	elseif englishClass == "PALADIN" then
		if spec == 2 or spec == 3 then
			exp_cap = RhadaTip_class.get_exp_conv() * 26
		end
	elseif englishClass == "DRUID" then
		if spec == 2 then
			exp_cap = RhadaTip_class.get_exp_conv() * 26
		end		
	end
	exp_rating = (GetExpertise()-exp_base) * RhadaTip_class.get_exp_conv()
	return exp_rating, exp_cap
end

function RhadaTip_class.is_dual_wield()
	local playerClass, englishClass = UnitClass("player");
	if englishClass == "SHAMAN" or englishClass == "HUNTER" or englishClass == "WARRIOR" or englishClass == "ROGUE" then
		return true
	elseif englishClass == "DEATHKNIGHT" then
		local spec, icon = RhadaTip_class.get_spec()
		if spec == 2 then
			return true
		else
			return false
		end
	else
		return false
	end
end

--is_jewelcrafter = false
function RhadaTip_class.is_jewelcrafter()
	local prof1, prof2, archaeology, fishing, cooking, firstaid = GetProfessions()
	if prof1 ~= nil and prof2 ~= nil then
		if (GetProfessionInfo(prof1) == "Jewelcrafting" or GetProfessionInfo(prof2) == "Jewelcrafting") then
			return true
		end
	end
	return false
end

function RhadaTip_class.check_race()
	local race, fileName = UnitRace("player")
	if race == "Draenei" or race == "Draeneï" or race == "드레나이" or race == "Дреней" or race == "德莱尼" or race == "德萊尼" then 
		return true
	else
		return false
	end
end

function RhadaTip_class.hc_mod:WARLOCK(gear_spirit)
	CASTER_OR_MELEE = 1
	RhadaTip_GainType = "DPS"
	return 0
end

function RhadaTip_class.hc_mod:HUNTER(gear_spirit)
	local talent_hit = 0
	--hunters count as melee for cap
	CASTER_OR_MELEE = 2
	--check character for drenai hit buff
	local race_result = RhadaTip_class.check_race()
	if race_result then
		--add 1% to the total reduction
		talent_hit = talent_hit + RhadaTip_class.get_hit_conv()
	end
	RhadaTip_GainType = "DPS"
	--return the total reduction 
	return talent_hit
end

function RhadaTip_class.hc_mod:MAGE(gear_spirit)
	local talent_hit = 0
	--hunters count as caster for cap
	CASTER_OR_MELEE = 1
	--check character for drenai hit buff
	local race_result = RhadaTip_class.check_race()
	if race_result then
		--add 1% to the total reduction
		talent_hit = talent_hit + RhadaTip_class.get_hit_conv()
	end
	RhadaTip_GainType = "DPS"
	--return the total reduction 
	return talent_hit
end

function RhadaTip_class.hc_mod:PRIEST(gear_spirit)
	local talent_hit = 0
	--hunters count as caster for cap
	CASTER_OR_MELEE = 1
	local spec, icon = RhadaTip_class.get_spec()

	if spec == 1 then
		RhadaTip_GainType = "HPS"
	elseif spec == 2 then
		RhadaTip_GainType = "HPS"
	elseif spec == 3 then
		RhadaTip_GainType = "DPS"
	end

	--get info for Twisted Faith
	local name, icon, column, rank, maxRank, isExceptional, meetsPrereq, previewRank, meetsPreviewPrereq = GetTalentInfo(3,7,false,false)
	--if the talent is not spec'd into, then return without further calculation
	if rank == nil then return(0) end
	--get the characters current spirit rating
	local cur_spirit, _, _, _ = UnitStat("player", 5)
	--check to see if the function was passed a spirit value
	if gear_spirit == nil then
		--if we were not passed a spirit value, and our spirit rating is nil then there is nothing further to do
		if cur_spirit == nil then return(0) end
		--at this point, no spirit was passed, and our rating is greater than zero. Continue executing with spirit rating
	else
		--we were givin a spirit value, so use that
		cur_spirit = gear_spirit
	end

	if maxRank == 1 then
		talent_hit = cur_spirit *.5
	elseif maxRank == 2 then
		talent_hit = cur_spirit
	else
		talent_hit = 0 
	end
	
	--check character for drenai hit buff
	local race_result = RhadaTip_class.check_race()
	if race_result then
		--add 1% to the total reduction
		talent_hit = talent_hit + RhadaTip_class.get_hit_conv()
	end
	--return the total reduction 
	return talent_hit

end

function RhadaTip_class.hc_mod:ROGUE(gear_spirit)
	CASTER_OR_MELEE = 2
	local talent_hit = 0

	--get info for Precision
	local name, icon, column, rank, maxRank, isExceptional, meetsPrereq, previewRank, meetsPreviewPrereq = GetTalentInfo(2,3,false,false)

	if rank == nil then return(0) end

	if maxRank == 1 then
		talent_hit = 2 * RhadaTip_class.get_hit_conv()
	elseif maxRank == 2 then
		talent_hit = 4 * RhadaTip_class.get_hit_conv()
	elseif maxRank == 3 then
		talent_hit = 6 * RhadaTip_class.get_hit_conv()
	else
		talent_hit = 0 
	end
	RhadaTip_GainType = "DPS"
	
	return talent_hit
end

function RhadaTip_class.hc_mod:SHAMAN(gear_spirit)
--	by default we set them as a Melee class
	local talent_hit = 0
	local spec, icon = RhadaTip_class.get_spec()

	if spec == 1 then
		RhadaTip_GainType = "DPS"
		CASTER_OR_MELEE = 2
	elseif spec == 2 then
		RhadaTip_GainType = "DPS"
		CASTER_OR_MELEE = 1
	elseif spec == 3 then
		RhadaTip_GainType = "HPS"
		CASTER_OR_MELEE = 2
	end

	--get info for Elemental Precision
	local name, icon, column, rank, maxRank, isExceptional, meetsPrereq, previewRank, meetsPreviewPrereq = GetTalentInfo(1,7,false,false)
	if rank == nil then return(0) end
--	since they have spell hit talents, we will flag them as a caster.
	
	local cur_spirit, _, _, _ = UnitStat("player", 5)
	if gear_spirit == nil then
		if cur_spirit == nil then return(0) end
	else
		cur_spirit = gear_spirit
	end

	if maxRank == 1 then
		talent_hit = cur_spirit * 0.33
	elseif maxRank == 2 then
		talent_hit = cur_spirit * 0.66
	elseif maxRank == 3 then
		talent_hit = cur_spirit
	else
		talent_hit = 0 
	end
	
	local race_result = RhadaTip_class.check_race(gear_spirit)
	if race_result then
		talent_hit = talent_hit + RhadaTip_class.get_hit_conv()
	end

	return talent_hit

end

function RhadaTip_class.hc_mod:WARRIOR(gear_spirit)
	local talent_hit = 0
	CASTER_OR_MELEE = 2
	local spec, icon = RhadaTip_class.get_spec()

	if spec == 1 then
		RhadaTip_GainType = "DPS"
	elseif spec == 2 then
		RhadaTip_GainType = "DPS"
	elseif spec == 3 then
		RhadaTip_GainType = "TP"
	end

	local race_result = RhadaTip_class.check_race()
	if race_result then
		talent_hit = talent_hit + RhadaTip_class.get_hit_conv()
	end
	return talent_hit
end

function RhadaTip_class.hc_mod:DEATHKNIGHT(gear_spirit)
	local talent_hit = 0

	--determine hit conv type
	local spec, _ = RhadaTip_class.get_spec()
	if spec == 1 then
		CASTER_OR_MELEE = 2
		RhadaTip_GainType = "TP"
	elseif spec == 2 then
		CASTER_OR_MELEE = 2
		RhadaTip_GainType = "DPS"
	elseif spec == 3 then
		CASTER_OR_MELEE = 1
		RhadaTip_GainType = "DPS"
	end

	--get info for Virulence
	local name, icon, column, rank, maxRank, isExceptional, meetsPrereq, previewRank, meetsPreviewPrereq = GetTalentInfo(3,2,false,false, nil)
--RhadaTip:debug_out(name .. ", " ..rank .. ", " .. maxRank)
	if maxRank == nil then 
		return(0)
	elseif maxRank == 1 then
		talent_hit = 3 * RhadaTip_class.get_hit_conv()
	elseif maxRank == 2 then
		talent_hit = 6 * RhadaTip_class.get_hit_conv()
	elseif maxRank == 3 then
		talent_hit = 9 * RhadaTip_class.get_hit_conv()
	else
		talent_hit = 0 
	end

	local race_result = RhadaTip_class.check_race()
	if race_result then
		talent_hit = talent_hit + RhadaTip_class.get_hit_conv()
	end

	return talent_hit

end

function RhadaTip_class.hc_mod:PALADIN(gear_spirit)
	local talent_hit = 0
	local race_result = RhadaTip_class.check_race()
	local spec, icon = RhadaTip_class.get_spec()

	if race_result then
		talent_hit = talent_hit + RhadaTip_class.get_hit_conv()
	end
	if spec == 1 then
		CASTER_OR_MELEE = 1
		RhadaTip_GainType = "HPS"
	elseif spec == 2 then
		RhadaTip_GainType = "DPS"
		CASTER_OR_MELEE = 2
	elseif spec == 3 then
		RhadaTip_GainType = "DPS"
		CASTER_OR_MELEE = 2
	end

	return talent_hit
end

function RhadaTip_class.hc_mod:DRUID(gear_spirit)
	local talent_hit = 0
	local spec, icon = RhadaTip_class.get_spec()
	if spec == 1 then
		CASTER_OR_MELEE = 2
		RhadaTip_GainType = "DPS"
	elseif spec == 2 then
		CASTER_OR_MELEE = 1
		RhadaTip_GainType = "DPS"
	elseif spec == 3 then
		CASTER_OR_MELEE = 1
		RhadaTip_GainType = "HPS"
	end

	--get info for Balance of Power
	local name, icon, column, rank, maxRank, isExceptional, meetsPrereq, previewRank, meetsPreviewPrereq = GetTalentInfo(1,6,false,false)
	
	if maxRank == nil then return(0) end

	local cur_spirit, _, _, _ = UnitStat("player", 5)
	if gear_spirit == nil then
		if cur_spirit == nil then return(0) end
	else
		cur_spirit = gear_spirit
	end

	if maxRank == 1 then
		talent_hit = cur_spirit *.5
	elseif maxRank == 2 then
		talent_hit = cur_spirit
	else
		talent_hit = 0 
	end
	
	return talent_hit
end

function RhadaTip_class.get_spec()
	local activeTalentGroup = GetActiveTalentGroup(false, false)
	-- get the tab in which the player has spent most of the points in
	local _, _, _, aff_icon, aff5 = GetTalentTabInfo(1, false, false, activeTalentGroup)
	local _, _, _, dem_icon, dem5 = GetTalentTabInfo(2, false, false, activeTalentGroup)
	local _, _, _, des_icon, des5 = GetTalentTabInfo(3, false, false, activeTalentGroup)
	local spec_num = 0
	local icon
	if aff5 == nil or dem5 == nil or des5 == nil then return 0 end
--	RhadaTip:debug_out("aff5:"..aff5)
--	RhadaTip:debug_out("dem5:"..dem5)
--	RhadaTip:debug_out("des5:"..des5)
	if aff5 > dem5 then
		if aff5 > des5 then
			spec_num = 1
			icon = aff_icon
		else
			spec_num = 3
			icon = des_icon
		end
	else
		if dem5 > des5 then
			spec_num = 2
			icon = dem_icon
		else
			spec_num = 3
			icon = des_icon
		end
	end
	return spec_num, icon
end

function RhadaTip_class.get_exp_conv()
	if RhadaTip_class.conv_factor[9] == nil or RhadaTip_class.conv_factor[9] == 0 then
		RhadaTip_class.set_combat_conv(9)
	end
	return RhadaTip_class.conv_factor[9]
end

function RhadaTip_class.get_hit_conv()
	local hit_type = 0
	if CASTER_OR_MELEE == 1 then 
		hit_type = 5
	else
		hit_type = 4
	end
	if RhadaTip_class.conv_factor[hit_type] == nil or RhadaTip_class.conv_factor[hit_type] == 0 then
		RhadaTip_class.set_combat_conv(hit_type)
	end
	return RhadaTip_class.conv_factor[hit_type]
end

function RhadaTip_class.set_combat_conv(combat_stat)
	--get the player level
	local level = UnitLevel("player")

	--This series of formulas is broken into level tiers. As we move from tier
	--to tier, the diminishing returns kick in harder and harder.
	-- player is level 1 to 10
	if level < 11 then
		local rating_factor = 0
		rating_factor = 2 / 52
		RhadaTip_class.conv_factor[combat_stat] = RhadaTip_class.base_factor[combat_stat] * rating_factor
	-- player is level 11 to 60
	elseif level > 10 and level < 61 then
		local rating_factor = 0
		rating_factor = (level - 8) / 52
		RhadaTip_class.conv_factor[combat_stat] = RhadaTip_class.base_factor[combat_stat] * rating_factor
	-- player is level 61 to 70
	elseif level > 60 and level < 71 then
		local rating_factor = 0
		rating_factor = 82 / (262 - 3 * level)
		RhadaTip_class.conv_factor[combat_stat] = RhadaTip_class.base_factor[combat_stat] * rating_factor
	-- player is level 71 to 80
	elseif level > 70 and level < 81 then
		local rating_factor = 0
		rating_factor = (82 / 52 * (131 / 63) ^ ((level - 70) / 10))
			RhadaTip_class.conv_factor[combat_stat] = RhadaTip_class.base_factor[combat_stat] * rating_factor
	-- player is level 81 to 85
	elseif level > 80 and level < 86 then
		local rating_factor = 0
		rating_factor = (82 / 52 * (131 / 63) * 3.9053695 ^ ((level - 80) / 5))
		RhadaTip_class.conv_factor[combat_stat] = RhadaTip_class.base_factor[combat_stat] * rating_factor
	else
		out("Error determining conversion factor. (Level="..level..")")
		RhadaTip_class.conv_factor[combat_stat] = 1
	end
end

function RhadaTip_class.AP_check(ItemLink)
	local playerClass, englishClass = UnitClass("player");
	local _, _, _, _, _, item_class, item_sub_class, _, item_slot = GetItemInfo(ItemLink)
	if RhadaTip_class == nil then
		RhadaTip_class.setup_item_tree()
	end 
--	RhadaTip:debug_out(ItemLink .. " type is " .. item_class .. "/" .. item_sub_class)
	if englishClass == "WARLOCK" then --complete
		if RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:2" or --Armor/cloth
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:1" or --Armor/misc
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:8" or --Weapon/One-Handed Swords
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:10" or --Weapon/Staves
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:13" or --Weapon/Dagger
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:16" then --Weapon/Wands
--			RhadaTip:debug_out(ItemLink .. " type is " .. item_class .. "/" .. item_sub_class .. "(".. RhadaTip_class.rhada_item_index[item_class][item_sub_class] .. ") (compatible)")
			return 2
		else
--			RhadaTip:debug_out(ItemLink .. " type is " .. item_class .. "/" .. item_sub_class .. "(".. RhadaTip_class.rhada_item_index[item_class][item_sub_class] .. ") (not compatible)")
			return 0
		end
	elseif englishClass == "HUNTER" then -- complete
		if RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:2" and item_slot == "INVTYPE_CLOAK" or --cloaks are ok even if they are cloth
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:1" or --Armor/misc
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:4" or --Armor/mail
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:1" or --Weapon/One-Handed Axe
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:2" or --Weapon/two-Handed Axe
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:3" or --Weapon/Bow
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:4" or --Weapon/gun
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:7" or --Weapon/polearm
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:8" or --Weapon/One-Handed Swords
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:9" or --Weapon/Two-Handed Swords
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:10" or --Weapon/Staves
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:13" or --Weapon/Dagger
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:11" or --Weapon/Fist
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:15" then --Weapon/crossBow
--			RhadaTip:debug_out(ItemLink .. " type is " .. item_class .. "/" .. item_sub_class .. "("..RhadaTip_class.rhada_item_index[item_class][item_sub_class] .. ") (compatible)")
			return 2
		elseif RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:2" or --Armor/cloth
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:3" then --Armor/leather
			--gear is usable, but at a penalty
			return 1
		else
--			RhadaTip:debug_out(ItemLink .. " type is " .. item_class .. "/" .. item_sub_class .. "("..RhadaTip_class.rhada_item_index[item_class][item_sub_class] .. ") (not compatible)")
			return 0
		end
	elseif englishClass == "MAGE" then --complete
		if RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:2" or --Armor/cloth
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:1" or --Armor/misc
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:8" or --Weapon/One-Handed Swords
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:10" or --Weapon/Staves
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:13" or --Weapon/Dagger
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:16" then --Weapon/Wands
--			RhadaTip:debug_out(ItemLink .. " type is " .. item_class .. "/" .. item_sub_class .. "("..RhadaTip_class.rhada_item_index[item_class][item_sub_class] .. ") (compatible)")
			return 2
		else
--			RhadaTip:debug_out(ItemLink .. " type is " .. item_class .. "/" .. item_sub_class .. "("..RhadaTip_class.rhada_item_index[item_class][item_sub_class] .. ") (not compatible)")
			return 0
		end
	elseif englishClass == "PRIEST" then -- complete
		if RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:2" or --Armor/cloth
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:1" or --Armor/misc
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:5" or --Weapon/One-Handed Mace
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:10" or --Weapon/Staves
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:13" or --Weapon/Dagger
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:16" then --Weapon/Wands
--			RhadaTip:debug_out(ItemLink .. " type is " .. item_class .. "/" .. item_sub_class .. "("..RhadaTip_class.rhada_item_index[item_class][item_sub_class] .. ") (compatible)")
			return 2
		else
--			RhadaTip:debug_out(ItemLink .. " type is " .. item_class .. "/" .. item_sub_class .. "("..RhadaTip_class.rhada_item_index[item_class][item_sub_class] .. ") (not compatible)")
			return 0
		end
	elseif englishClass == "ROGUE" then -- complete
		if RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:2" and item_slot == "INVTYPE_CLOAK" or --cloaks are ok even if they are cloth
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:3" or --Armor/leather
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:1" or --Armor/misc
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:1" or --Weapon/One-Handed Axe
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:8" or --Weapon/One-Handed Swords
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:5" or --Weapon/One-Handed Mace
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:13" or --Weapon/Dagger
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:11" or --Weapon/Fist
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:3" or --Weapon/Bow
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:15" or --Weapon/crossBow
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:4" or --Weapon/gun
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:14" then --Weapon/thrown
--			RhadaTip:debug_out(ItemLink .. " type is " .. item_class .. "/" .. item_sub_class .. "("..RhadaTip_class.rhada_item_index[item_class][item_sub_class] .. ") (compatible)")
			return 2
		elseif RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:2" then --Armor/cloth
			return 1
		else
--			RhadaTip:debug_out(ItemLink .. " type is " .. item_class .. "/" .. item_sub_class .. "("..RhadaTip_class.rhada_item_index[item_class][item_sub_class] .. ") (not compatible)")
			return 0
		end
	elseif englishClass == "SHAMAN" then -- complete
		if RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:2" and item_slot == "INVTYPE_CLOAK" or --cloaks are ok even if they are cloth
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:1" or --Armor/misc
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:4" or --Armor/mail
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:6" or --Armor/shield
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:1" or --Weapon/One-Handed Axe
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:5" or --Weapon/One-Handed Mace
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:7" or --Weapon/polearm
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:10" or --Weapon/Staves
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:13" or --Weapon/Dagger
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:11" or --Weapon/Fist
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:7" then --armor/relic
--			RhadaTip:debug_out(ItemLink .. " type is " .. item_class .. "/" .. item_sub_class .. "("..RhadaTip_class.rhada_item_index[item_class][item_sub_class] .. ") (compatible)")
			return 2
		elseif RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:2" or --Armor/cloth
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:3" then --Armor/leather
			return 1
		else
--			RhadaTip:debug_out(ItemLink .. " type is " .. item_class .. "/" .. item_sub_class .. "("..RhadaTip_class.rhada_item_index[item_class][item_sub_class] .. ") (not compatible)")
			return 0
		end
	elseif englishClass == "WARRIOR" then -- complete
		if RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:2" and item_slot == "INVTYPE_CLOAK" or --cloaks are ok even if they are cloth
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:1" or --Armor/misc
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:5" or --Armor/plate
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:6" or --Armor/shield
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:1" or --Weapon/One-Handed Axe
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:2" or --Weapon/two-Handed Axe
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:3" or --Weapon/Bow
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:4" or --Weapon/gun
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:5" or --Weapon/One-Handed Mace
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:6" or --Weapon/Two-Handed Mace
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:7" or --Weapon/polearm
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:8" or --Weapon/One-Handed Swords
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:9" or --Weapon/Two-Handed Swords
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:11" or --Weapon/Fist
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:13" or --Weapon/Dagger
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:14" or --Weapon/thrown
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:15" or --Weapon/crossBow
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:10" then --Weapon/Staves
--			RhadaTip:debug_out(ItemLink .. " type is " .. item_class .. "/" .. item_sub_class .. "("..RhadaTip_class.rhada_item_index[item_class][item_sub_class] .. ") (compatible)")
			return 2
		elseif RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:2" or --Armor/cloth
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:3" or --Armor/leather
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:4" then --Armor/mail
			return 1
		else
--			RhadaTip:debug_out(ItemLink .. " type is " .. item_class .. "/" .. item_sub_class .. "("..RhadaTip_class.rhada_item_index[item_class][item_sub_class] .. ") (not compatible)")
			return 0
		end
	elseif englishClass == "DEATHKNIGHT" then
		if RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:2" and item_slot == "INVTYPE_CLOAK" or --cloaks are ok even if they are cloth
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:1" or --Armor/misc
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:5" or --Armor/plate
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:7" or --armor/relic
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:1" or --Weapon/One-Handed Axe
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:2" or --Weapon/two-Handed Axe
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:5" or --Weapon/One-Handed Mace
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:6" or --Weapon/Two-Handed Mace
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:7" or --Weapon/polearm
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:8" or --Weapon/One-Handed Swords
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:9" then --Weapon/Two-Handed Swords
--			RhadaTip:debug_out(ItemLink .. " type is " .. item_class .. "/" .. item_sub_class .. "("..RhadaTip_class.rhada_item_index[item_class][item_sub_class] .. ") (compatible)")
			return 2
		elseif RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:2" or --Armor/cloth
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:3" or --Armor/leather
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:4" then --Armor/mail
--			RhadaTip:debug_out(ItemLink .. " type is " .. item_class .. "/" .. item_sub_class .. "("..RhadaTip_class.rhada_item_index[item_class][item_sub_class] .. ") " .. item_slot.. " (Partially compatible)")
			return 1
		else
--			RhadaTip:debug_out(ItemLink .. " type is " .. item_class .. "/" .. item_sub_class .. "("..RhadaTip_class.rhada_item_index[item_class][item_sub_class] .. ") (not compatible)")
			return 0
		end
	elseif englishClass == "PALADIN" then -- complete
		if RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:2" and item_slot == "INVTYPE_CLOAK" or --cloaks are ok even if they are cloth
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:1" or --Armor/misc
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:5" or --Armor/plate
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:6" or --Armor/shield
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:7" or --armor/relic
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:1" or --Weapon/One-Handed Axe
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:2" or --Weapon/two-Handed Axe
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:5" or --Weapon/One-Handed Mace
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:6" or --Weapon/Two-Handed Mace
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:7" or --Weapon/polearm
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:8" or --Weapon/One-Handed Swords
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:9" then --Weapon/Two-Handed Swords
--			RhadaTip:debug_out(ItemLink .. " type is " .. item_class .. "/" .. item_sub_class .. "("..RhadaTip_class.rhada_item_index[item_class][item_sub_class] .. ") (compatible)")
			return 2
		elseif RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:2" or --Armor/cloth
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:3" or --Armor/leather
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:4" then --Armor/mail
			return 1
		else
--			RhadaTip:debug_out(ItemLink .. " type is " .. item_class .. "/" .. item_sub_class .. "("..RhadaTip_class.rhada_item_index[item_class][item_sub_class] .. ") (not compatible)")
			return 0
		end
	elseif englishClass == "DRUID" then -- complete
		if RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:2" and item_slot == "INVTYPE_CLOAK" or --cloaks are ok even if they are cloth
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:3" or --Armor/leather
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:1" or --Armor/misc
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:7" or --armor/relic
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:5" or --Weapon/One-Handed Mace
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:6" or --Weapon/Two-Handed Mace
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:7" or --Weapon/polearm
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:11" or --Weapon/Fist
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:13" or --Weapon/Dagger
			RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "1:10" then --Weapon/Staves
--			RhadaTip:debug_out(ItemLink .. " type is " .. item_class .. "/" .. item_sub_class .. "("..RhadaTip_class.rhada_item_index[item_class][item_sub_class] .. ") (compatible)")
			return 2
		elseif RhadaTip_class.rhada_item_index[item_class][item_sub_class] == "2:2" then --Armor/cloth
			return 1
		else
--			RhadaTip:debug_out(ItemLink .. " type is " .. item_class .. "/" .. item_sub_class .. "("..RhadaTip_class.rhada_item_index[item_class][item_sub_class] .. ") (not compatible)")
			return 0
		end
	end
	return true
end

function RhadaTip_class.AP_get_penalty(ItemLink)
	local playerClass, englishClass = UnitClass("player");
	if englishClass == "WARLOCK" then
--		* Cloth Specialization – Increases Int by 5% while wearing only Cloth.
		local penalty = 0
		if RhadaTip_class.AP_check(ItemLink) == 1 then
			--item is equipable, but sub-par
			penalty = RhadaTip_class.AP_int_penalty()
			return true, penalty
		elseif RhadaTip_class.AP_check(ItemLink) == 0 then
			--item is not equipable
			return false, penalty
		else
			--item is fully compatible
			return true, penalty
		end
		
	elseif englishClass == "HUNTER" then
--		* Mail Specialization – Increases Agi by 5% while wearing only Mail.
		local penalty = 0
		if RhadaTip_class.AP_check(ItemLink) == 1 then
			--item is equipable, but sub-par
			penalty = RhadaTip_class.AP_agi_penalty()
			return true, penalty
		elseif RhadaTip_class.AP_check(ItemLink) == 0 then
			--item is not equipable
			return false, penalty
		else
			--item is fully compatible
			return true, penalty
		end
		
	elseif englishClass == "MAGE" then
--		* Cloth Specialization – Increases Int by 5% while wearing only Cloth.
		local penalty = 0
		if RhadaTip_class.AP_check(ItemLink) == 1 then
			--item is equipable, but sub-par
			penalty = RhadaTip_class.AP_int_penalty()
			return true, penalty
		elseif RhadaTip_class.AP_check(ItemLink) == 0 then
			--item is not equipable
			return false, penalty
		else
			--item is fully compatible
			return true, penalty
		end

	elseif englishClass == "PRIEST" then
--		* Cloth Specialization – Increases Int by 5% while wearing only Cloth.
		local penalty = 0
		if RhadaTip_class.AP_check(ItemLink) == 1 then
			--item is equipable, but sub-par
			penalty = RhadaTip_class.AP_int_penalty()
			return true, penalty
		elseif RhadaTip_class.AP_check(ItemLink) == 0 then
			--item is not equipable
			return false, penalty
		else
			--item is fully compatible
			return true, penalty
		end

	elseif englishClass == "ROGUE" then
--		* Leather Specialization – Increases Agi by 5% while wearing only Leather.
		local penalty = 0
		if RhadaTip_class.AP_check(ItemLink) == 1 then
			--item is equipable, but sub-par
			penalty = RhadaTip_class.AP_agi_penalty()
			return true, penalty
		elseif RhadaTip_class.AP_check(ItemLink) == 0 then
			--item is not equipable
			return false, penalty
		else
			--item is fully compatible
			return true, penalty
		end

	elseif englishClass == "SHAMAN" then
--		* Tribal Mail Specialization – Increases Int by 5% while wearing only Mail.
		local penalty = 0
		if RhadaTip_class.AP_check(ItemLink) == 1 then
			--item is equipable, but sub-par
			penalty = RhadaTip_class.AP_int_penalty()
			return true, penalty
		elseif RhadaTip_class.AP_check(ItemLink) == 0 then
			--item is not equipable
			return false, penalty
		else
			--item is fully compatible
			return true, penalty
		end

	elseif englishClass == "WARRIOR" then
		local spec = RhadaTip_class.get_spec()
		local penalty = 0
		if RhadaTip_class.AP_check(ItemLink) == 1 then
			--item is equipable, but sub-par
			if spec == 3 then 
--				* Defender’s Plate Specialization – Increases Stam by 5% while wearing only Plate.
				penalty = RhadaTip_class.AP_stm_penalty()
			else
--				* Furious Plate Specialization – Increases Str by 5% while wearing only Plate.
--				* Plate Specialization – Increases Str by 5% while wearing only Plate.
				penalty = RhadaTip_class.AP_str_penalty()
			end
			return true, penalty
		elseif RhadaTip_class.AP_check(ItemLink) == 0 then
			--item is not equipable
			return false, penalty
		else
			--item is fully compatible
			return true, penalty
		end

	elseif englishClass == "DEATHKNIGHT" then
--		* Plate Specialization – Increases Str by 5% while wearing only Plate.
		local penalty = 0
		if RhadaTip_class.AP_check(ItemLink) == 1 then
			--item is equipable, but sub-par
			penalty = RhadaTip_class.AP_str_penalty()
			return true, penalty
		elseif RhadaTip_class.AP_check(ItemLink) == 0 then
			--item is not equipable
			return false, penalty
		else
			--item is fully compatible
			return true, penalty
		end
		
	elseif englishClass == "PALADIN" then
--		* Blessed Plate Specialization – Increases Int by 5% while wearing only Plate.
		local penalty = 0
		if RhadaTip_class.AP_check(ItemLink) == 1 then
			--item is equipable, but sub-par
			penalty = RhadaTip_class.AP_int_penalty()
			return true, penalty
		elseif RhadaTip_class.AP_check(ItemLink) == 0 then
			--item is not equipable
			return false, penalty
		else
			--item is fully compatible
			return true, penalty
		end

	elseif englishClass == "DRUID" then
		local spec = RhadaTip_class.get_spec()
		local penalty = 0
		if RhadaTip_class.AP_check(ItemLink) == 1 then
			--item is equipable, but sub-par
			if spec == 3 or spec == 1 then 
--				* Astral Leather Specialization – Increases Int by 5% while wearing only Leather.
				penalty = RhadaTip_class.AP_int_penalty()
			elseif spec == 2 then
--				* Wild Leather Specialization – Increases Stam in Bear Form by 5% while wearing only Leather.
				--need logic here to handle detection of bear form
			penalty = RhadaTip_class.AP_stm_penalty()
			elseif spec == 2 then
--				* Wild Leather Specialization – Increases Agi in Cat Form by 5% while wearing only Leather.
				--need logic here to handle detection of cat form
				penalty = RhadaTip_class.AP_agi_penalty()
			end
			return true, penalty
		elseif RhadaTip_class.AP_check(ItemLink) == 0 then
			--item is not equipable
			return false, penalty
		else
			--item is fully compatible
			return true, penalty
		end
	end
end

function RhadaTip_class.AP_str_penalty()
	local cur_str, _, _, _ = UnitStat("player", 1)
	local penalty = 0
	local spec = GetActiveTalentGroup(false, false)
	if RhadaTip_Scales[spec]["ITEM_MOD_STRENGTH_SHORT"] ~= nil then
		penalty = cur_str * RhadaTip_Scales[spec]["ITEM_MOD_STRENGTH_SHORT"] * 0.05
	end
	return penalty
end

function RhadaTip_class.AP_agi_penalty()
	local cur_agi, _, _, _ = UnitStat("player", 2)
	local penalty = 0
	local spec = GetActiveTalentGroup(false, false)
	if RhadaTip_Scales[spec]["ITEM_MOD_AGILITY_SHORT"] ~= nil then
		penalty = cur_agi * RhadaTip_Scales[spec]["ITEM_MOD_AGILITY_SHORT"] * 0.05
	end
	return penalty
end

function RhadaTip_class.AP_stm_penalty()
	local cur_stm, _, _, _ = UnitStat("player", 3)
	local penalty = 0
	local spec = GetActiveTalentGroup(false, false)
	if RhadaTip_Scales[spec]["ITEM_MOD_STAMINA_SHORT"] ~= nil then
		penalty = cur_stm * RhadaTip_Scales[spec]["ITEM_MOD_STAMINA_SHORT"] * 0.05
	end
	return penalty
end

function RhadaTip_class.AP_int_penalty()
	local cur_int, _, _, _ = UnitStat("player", 4)
	local penalty = 0
	local spec = GetActiveTalentGroup(false, false)
	if RhadaTip_Scales[spec]["ITEM_MOD_INTELLECT_SHORT"] ~= nil then
		penalty = cur_int * RhadaTip_Scales[spec]["ITEM_MOD_INTELLECT_SHORT"] * 0.05
	end
	return penalty
end

function RhadaTip_class.setup_item_tree()
	local item_cat_list = {GetAuctionItemClasses()}
--	RhadaTip:debug_out("made it to RhadaTip_class.setup_item_tree")
	for i,j in ipairs(item_cat_list) do
		local my_prof = {GetAuctionItemSubClasses(i)}
--		RhadaTip:debug_out("made it to GetAuctionItemSubClasses(i)")
		RhadaTip_class.rhada_item_index[j] = {}
--		RhadaTip:debug_out("made it to RhadaTip_class.rhada_item_index[j] = {}")
		for k,v in ipairs(my_prof) do
--			RhadaTip:debug_out("made it to walking ipairs(my_prof)")
			RhadaTip_class.rhada_item_index[j][v] = (i .. ":" .. k)
--			RhadaTip:debug_out(j..":"..v)
		end
	end
end

